#include <iostream>
#include <string>
using namespace std;

#define ll long long

bool isNum(char c){
    return '0' <= c && c <= '9';
}
bool eval(string s){
    ll left = 0;
    ll right = 0;

    ll cur = 0;
    ll curSize = 0;
    ll sign = 1;
    bool isRight = false;
    bool wasPrevSign = true;
    bool wasPrevZero = false;
    int i = 0;

    for(char c : s){
        if(c == '='){
            if(wasPrevSign) return false;
            wasPrevSign = true;
            isRight = true;
            left += cur * sign;
            cur = 0;
            curSize = 0;
            sign = 1;
        }else if(c == '+'){
            if(wasPrevSign) return false;
            wasPrevSign = true;
            if(isRight) right += cur * sign;
            else left += cur * sign;
            cur = 0;
            curSize = 0;
            sign = 1;
        }else if(c == '-'){
            if(wasPrevSign) return false;
            wasPrevSign = true;
            if(isRight) right += cur * sign;
            else left += cur * sign;
            cur = 0;
            curSize = 0;
            sign = -1;
        }else{
            wasPrevSign = false;
            cur *= 10;
            cur += c-'0';
            curSize++;
            if(cur == 0 && c == '0' && i+1 < s.length() && isNum(s[i+1])) return false;
            if(curSize > 10) return false;
        }
        i++;
    }
    right += cur * sign;

    return left == right;
}
void solve(){
    string s;
    cin >> s;

    if(eval(s)){
        cout << "Correct" << endl;
        return;
    }

    for(int i = 0; i < s.length(); i++){
        if(isNum(s[i])){
            string sn = s.substr(0,i)+s.substr(i+1);
            for(int j = 0; j <= sn.length(); j++){
                string sl = sn.substr(0,j);
                string sr = sn.substr(j);
                string sm = "";
                sm += sl;
                sm += s[i];
                sm += sr;
                if(eval(sm)){
                    cout << sm << endl;
                    return;
                }
            }
        }
    }

    cout << "Impossible" << endl;
}

int main(){
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}