#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

bool isNumber(const string& s)
{
	if (s.size() > 10)return false;
	if (s.empty())return false;
	if (s[0] == '0')
	{
		return s.size() == 1;
	}
	for (const auto& i : s)
	{
		if (i < '0' || i > '9')return false;
	}
	return true;
}

bool isExpression(const string& s, long long &res)
{
	res = 0;
	char lastNshan = '+';
	string num = "";
	for (int i = 0; i < s.size(); ++i)
	{
		if (s[i] == '+' || s[i] == '-')
		{
			if (num.empty())return false;
			if (!isNumber(num))return false;
			if (lastNshan == '+')res += stoll(num);
			else if (lastNshan == '-')res -= stoll(num);
			lastNshan = s[i];
			num = "";
		}
		else
		{
			num += s[i];
		}
	}
	if (num.empty())return false;
	if (!isNumber(num))return false;
	
	if (lastNshan == '+')res += stoll(num);
	else if (lastNshan == '-')res -= stoll(num);

	return true;
}

bool isEquality(const string& s, bool &isValid)
{
	string s1;
	string s2;
	bool first = true;
	for (int i = 0; i < s.size(); ++i)
	{
		if (s[i] == '=')
		{
			first = false;
		}
		else
		{
			if (first)s1 += s[i];
			else s2 += s[i];
		}
	}
	long long a, b;
	bool ok = isExpression(s1, a) && isExpression(s2, b);
	if(ok)isValid = (a == b);
	return ok;
}

void solv()
{
	string s; cin >> s;
	bool isValid = false;
	isEquality(s, isValid);
	if (isValid)
	{
		cout << "Correct" << std::endl;
		return;
	}
	string sc = s;
	for (int i = 0; i < s.size(); ++i)
	{
		char cur = s[i];
		if (isdigit(cur))
		{
			sc = s;
			sc.erase(sc.begin() + i);
			for (int j = 0; j <= sc.size(); ++j)
			{
				sc.insert(sc.begin() + j, cur);
				bool isValid = false;
				if (isEquality(sc, isValid))
				{
					if (isValid)
					{
						cout << sc << endl;
						return;
					}
				}
				sc.erase(sc.begin() + j);
			}
		}
	}
	cout << "Impossible" << endl;
}




int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	//cin >> t;
	while (t--) solv();

}
