#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>

using namespace std;
using ll = long long;

typedef vector<int> VI;
typedef vector<VI> VVI;

void solve()
{
	int n, m, q; cin >> n >> m >> q;
	vector<pair<ll, ll>> task(n);
	vector<ll> movie(m);
	vector<ll> meet(q);
	for (int i = 0; i < n; ++i)
	{
		cin >> task[i].second;
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> task[i].first;
	}
	for (int i = 0; i < m; ++i)
	{
		cin >> movie[i];
	}
	for (int i = 0; i < q; ++i)
	{
		cin >> meet[i];
	}
	sort(task.begin(), task.end());
	vector<ll> startTask(n);
	for (int i = n - 1; i >= 0; --i)
	{
		if (i == n - 1)
		{
			startTask[i] = task[i].first - task[i].second;
		}
		else
		{
			if (startTask[i + 1] <= task[i].first)
			{
				startTask[i] = startTask[i + 1] - task[i].second;
			}
			else
			{
				startTask[i] = task[i].first - task[i].second;
			}
		}
	}
	ll minsBeforeTask = startTask[0];
	ll tasksTime = 0;
	vector<ll> minForMovie(m);
	vector<ll> prefMovie(m + 1);
	vector<ll> prefTask(n + 1);
	for (int i = 1; i <= n; ++i)
	{
		prefTask[i] = prefTask[i - 1] + task[i - 1].second;
	}
	for (int i = 1; i <= m; ++i)
	{
		prefMovie[i] = prefMovie[i - 1] + movie[i - 1];
	}
	// return;
	for (int i = 0, t = 0; i < m; ++i)
	{
		while (minsBeforeTask < movie[i])
		{
			if (t == n - 1) break;
			minsBeforeTask = startTask[t + 1] - prefTask[t + 1] - prefMovie[i];
			++t;
		}

		if (minsBeforeTask >= movie[i])
		{
			minForMovie[i] = prefMovie[i + 1] + prefTask[t];
			minsBeforeTask -= movie[i];
		}
		else
		{
			minForMovie[i] = prefTask[n] + prefMovie[i + 1];
			minsBeforeTask = 0;
		}
	}
	for (int i = 0; i < q; ++i)
	{
		auto it = upper_bound(minForMovie.begin(), minForMovie.end(), meet[i]) - minForMovie.begin() - 1;
		cout << it + 1 << " " ;
	}
	cout << endl;

}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	cin >> t;
	while (t--) solve();

}
