#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

#define ff first
#define ss second
using namespace std;


vector<vector<int>> gp;

vector<int> order;
int n;
vector<bool> vis;

void dfs(int u) {
    vis[u] = 1;
    for (auto to: gp[u]) {
        if (!vis[to]) dfs(to);
    }
    order.push_back(u);
}

void top_sort() {
    vis = vector<bool>(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        if (!vis[i]) {
            dfs(i);
        }
    }
    reverse(order.begin(), order.end());

}


void check(vector<int> &res, vector<pair<int, int>> &dag) {
    vector<int> idx(n + 1, 0);
    for (int i = 0; i < n; i++) {
        idx[res[i]] = i;

    }
    for (int i = 0; i < (int) dag.size(); i++) {
        if (idx[dag[i].ff] > idx[dag[i].ss]) {
            cout << "-1\n";
            return;
        }
    }
    for (int i = 0; i < n; i++)cout << res[i] << " ";
    cout << endl;


}

int main() {
    cin >> n;

    gp.resize(n + 1);
    vector<pair<int, int>> vp(n);
    int setTrue = 0, unsetTrue = 0;
    bool unsetka = 0, setka = 0;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;
        if (a == "set")vp[i].ff = 1;
        else vp[i].ff = 0;
        if (b == "true")vp[i].ss = 1;
        else vp[i].ss = 0;
        if (vp[i] == make_pair(1, 1)) setTrue = i + 1;
        if (vp[i] == make_pair(0, 1)) unsetTrue = i + 1;
        if (vp[i].ff)setka = 1;
        else unsetka = 1;
    }
    int m;
    cin >> m;

    vector<pair<int, int>> dag(m);
    for (int i = 0; i < m; i++) {
        cin >> dag[i].ff >> dag[i].ss;
        gp[dag[i].ff].push_back(dag[i].ss);

    }
    top_sort();
//    for (int i = 0; i < n; i++)cout << order[i] << " ";
//    cout << endl;
    if (setTrue && unsetTrue) {
        vector<int> res, middle_, right_;
        middle_.push_back(setTrue);
        cout << endl;
        vector<int> sets;
        bool boolr = 0;
        for (int i = 0; i < n; i++) {
            if (boolr && vp[order[i] - 1].ss == 0) {
                right_.push_back(order[i]);
            } else if (vp[order[i] - 1].ss == 0)res.push_back(order[i]);
            else {
                if (order[i] == unsetTrue)boolr = 1;
                if (order[i] == setTrue || order[i] == unsetTrue) continue;
                middle_.push_back(order[i]);
            }
        }
        middle_.push_back(unsetTrue);
        for (int i = 0; i < (int) middle_.size(); i++) {
            res.push_back(middle_[i]);
        }
        for (int i = 0; i < (int) right_.size(); i++) {
            res.push_back(right_[i]);
        }
        check(res, dag);

    } else if (setTrue && !unsetTrue) {
        vector<int> res, right_;
        for (int i = 0; i < n; i++) {
            if (vp[order[i] - 1].ff == 0)res.push_back(order[i]);
            else {
                if (order[i] != setTrue) {
                    right_.push_back(order[i]);
                }
            }
        }
        res.push_back(setTrue);
        for (int i = 0; i < (int) right_.size(); i++) {
            res.push_back(right_[i]);
        }
        check(res, dag);
    } else if (!setTrue && !unsetTrue) {
        if (setka && unsetka)cout << "-1\n";
        else {
            for (int i = 0; i < n; i++)cout << order[i] << " ";
            cout << endl;
        }

    } else {
        cout << "-1\n";
    }


}



