#include <iostream>
#include <vector>
#include <utility>
#include <array>
#include <algorithm>
#include <set>
#define pii pair<int, int>

using namespace std;



const int MAX = 1e6 + 100;

int arr[MAX];
vector<int> g[MAX];
vector<int> order;
int color[MAX];

bool dfs1(int node){
    color[node] = 1;
    for(int to:g[node]){
        if(color[to] == 2) continue;
        if(color[to] == 1) return 1;
        if(dfs1(to)) return 1;
    }
    color[node] = 2;
    return 0;
}

int used[MAX];
void dfs2(int node){
    used[node] = 1;
    for(int to:g[node]){
        if(used[to]) continue;
        dfs2(to);
    }
    order.push_back(node);
}

void solve(){
    int n; cin >> n;
    for(int i = 1; i <= n; ++i){
        string s1, s2; cin >> s1 >> s2;
        int a = ((s1 == "unset") << 1) | (s2 == "true");
        arr[i] = a;
    }
    int m; cin >> m;
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b;
        g[a].push_back(b);
    }
    int c1 = count(arr + 1, arr + n + 1, 1);
    int c2 = count(arr + 1, arr + n + 1, 3);
    if((c1 == 2) || (c1 == 0 && c2 > 0)){
        cout << -1 << '\n';
        return;
    }
    int idx1 = find(arr + 1, arr + n + 1, 1) - arr;
    int idx2 = find(arr + 1, arr + n + 1, 3) - arr;
    if(c1 == 1 && c2 == 0){
        for(int i = 1; i <= n; ++i){
            if(arr[i] == 2){
                g[i].push_back(idx1);
            }
            else if(arr[i] == 0){
                g[idx1].push_back(i);
            }
        }
    }
    else{
        for(int i = 1; i <= n; ++i){
            if(arr[i] == 0){
                g[idx1].push_back(i);
                g[i].push_back(idx2);
            }
            else if(arr[i] == 2){
                bool f = false;
                for(int a:g[i]){
                    if(arr[a] != 2){
                        g[i].push_back(idx1);
                        f = true;
                        break;
                    }
                }
                if(!f){
                    g[idx2].push_back(i);
                }
            }
        }
    }

    for(int i = 1; i <= n; ++i){
        if(color[i] == 0){
            if(dfs1(i)){
                cout << -1 << '\n';
                return;
            }
        }
    }
    for(int i = 1; i <= n; ++i){
        if(!used[i]){
            dfs2(i);
        }
    }
    reverse(order.begin(), order.end());
    for(int a:order){
        cout << a << ' ';
    }
    cout << '\n';
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
}