#include <iostream>
#include <vector>
#include <utility>
#include <array>
#include <algorithm>
#include <set>
#define pii pair<int, int>

using namespace std;


set<array<int, 3>> st;

const int MAX = 1e6 + 100;
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

int n;
string s[4];
int deg[4][MAX];

void del(int x, int y){
    if(s[x][y] == '#') return;
    st.erase({deg[x][y], x, y});
    s[x][y] = '#';
    for(int i = 0; i < 4; ++i){
        int x1 = x + dx[i], y1 = y + dy[i];
        if(s[x1][y1] == '#') continue;
        st.erase({deg[x1][y1], x1, y1});
        deg[x1][y1]++;
        st.insert({deg[x1][y1], x1, y1});
    }
}

void solve(){
    cin >> n;
    for(int i = 0; i <= 3; ++i){
        s[i].clear();
        for(int j = 0; j <= n + 2; ++j){
            deg[i][j] = 0;
        }
    }
    st.clear();
    for(int i = 0; i <= n + 1; ++i){
        s[0].push_back('#');
        s[3].push_back('#');
    }
    for(int i = 1; i <= 2; ++i){
        cin >> s[i];
        s[i].insert(s[i].begin(), '#');
        s[i].push_back('#');
    }
    for(int i = 1; i <= 2; ++i){
        for(int j = 0; j <= n + 1; ++j){
            if(s[i][j] == '.'){
                for(int k = 0; k < 4; ++k){
                    int x = i + dx[k], y = j + dy[k];
                    if(s[x][y] == '#'){
                        deg[i][j]++;
                    }
                }
                st.insert({deg[i][j], i, j});
            }
        }
    }
    while(st.size()){
        auto a = *st.rbegin();
        int d = a[0];
        int x = a[1];
        int y = a[2];
        if(d == 4){
            cout << "None\n";
            return;
        }
        else if(d < 3){
            break;
        }
        else{
            for(int i = 0; i < 4; ++i){
                int x1 = x + dx[i];
                int y1 = y + dy[i];
                if(s[x1][y1] == '.'){
                    del(x, y);
                    del(x1, y1);
                    break;
                }
            }
        }
    }
    if(st.size()){
        cout << "Multiple\n";
    }
    else{
        cout << "Unique\n";
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t; cin >> t;
    while(t--){
        solve();
    }
}