#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define trav(a, x) for(auto& a : x)
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct PushRelabel {
	struct Edge {
		int dest, back;
		ll f, c;
	};
	vector<vector<Edge>> g;
	vector<ll> ec;
	vector<Edge*> cur;
	vector<vi> hs; vi H;
	PushRelabel(int n) : g(n), ec(n), cur(n), hs(2*n), H(n) {}

	void addEdge(int s, int t, ll cap, ll rcap=0) {
		if (s == t) return;
		g[s].push_back({t, sz(g[t]), 0, cap});
		g[t].push_back({s, sz(g[s])-1, 0, rcap});
	}

	void addFlow(Edge& e, ll f) {
		Edge &back = g[e.dest][e.back];
		if (!ec[e.dest] && f) hs[H[e.dest]].push_back(e.dest);
		e.f += f; e.c -= f; ec[e.dest] += f;
		back.f -= f; back.c += f; ec[back.dest] -= f;
	}
	ll calc(int s, int t) {
		int v = sz(g); H[s] = v; ec[t] = 1;
		vi co(2*v); co[0] = v-1;
		rep(i,0,v) cur[i] = g[i].data();
		for (Edge& e : g[s]) addFlow(e, e.c);

		for (int hi = 0;;) {
			while (hs[hi].empty()) if (!hi--) return -ec[s];
			int u = hs[hi].back(); hs[hi].pop_back();
			while (ec[u] > 0)  // discharge u
				if (cur[u] == g[u].data() + sz(g[u])) {
					H[u] = 1e9;
					for (Edge& e : g[u]) if (e.c && H[u] > H[e.dest]+1)
						H[u] = H[e.dest]+1, cur[u] = &e;
					if (++co[H[u]], !--co[hi] && hi < v)
						rep(i,0,v) if (hi < H[i] && H[i] < v)
							--co[H[i]], H[i] = v + 1;
					hi = H[u];
				} else if (cur[u]->c && H[u] == H[cur[u]->dest]+1)
					addFlow(*cur[u], min(ec[u], cur[u]->c));
				else ++cur[u];
		}
	}
	bool leftOfMinCut(int a) { return H[a] >= sz(g); }
};

void solve(){
	int N;
	cin >> N;
	vector<vector<int> > A(2, vector<int>(N));
	vector<vector<int> > ord(2, vector<int>(N));
	for(int j = 0; j < 2; j++){
		for(int i = 0; i < N; i++){
			cin >> A[j][i];
			A[j][i]--;
			ord[j][A[j][i]] = i;
		}
	}
	vector<int> can_yes(N, 0), can_no(N, 0);
	int K;
	cin >> K;
	vector<vector<int> > seen(2);
	vector<int> seen_mask(N, 0);
	for(int g = 0; g < 2; g++){
		seen[g].reserve(K);
		for(int i = 0; i < K; i++){
			int x;
			cin >> x;
			if(x >= 0) x--;
			seen[g].push_back(x);
		}
		for(int x : seen[g]){
			if(x >= 0){
				can_yes[x] = 1;
				seen_mask[x] |= 1 << g;
			}
		}
	}
	vector<vector<int> > which_block(2, vector<int>(N, -1));
	vector<vector<int> > block_counts(2);
	for(int g = 0; g < 2; g++){
		int nempty = 0;
		int prv_idx = 0;

		int cur = 0;
		vector<int> block_count;
		for(int i = 0; i <= (int)seen[g].size(); i++){
			if(i == (int)seen[g].size() || seen[g][i] >= 0){
				int cur_idx = i == (int)seen[g].size() ? N : ord[g][seen[g][i]];
				if(prv_idx > cur_idx){
					cout << "Inconsistent\n" << '\n';
					return;
				}
				for(int j = prv_idx; j < cur_idx; j++){
					which_block[g][A[g][j]] = cur;
				}
				cur++;
				block_count.push_back(nempty);
				nempty = 0;
				prv_idx = cur_idx;
			}
			if(i < (int)seen[g].size() && seen[g][i] >= 0){
				which_block[g][seen[g][i]] = cur;
				cur++;
				block_count.push_back(1);
				prv_idx++;
			} else {
				nempty++;
			}
		}
		block_counts[g] = block_count;
	}
	int B0 = (int)block_counts[0].size();
	int B1 = (int)block_counts[1].size();
	int V = B0 + B1 + 2;
	PushRelabel flow(V);
	int st = B0 + B1;
	int en = st + 1;
	for(int i = 0; i < B0; i++){
		flow.addEdge(st, i, block_counts[0][i]);
	}
	for(int i = 0; i < B1; i++){
		flow.addEdge(i + B0, en, block_counts[1][i]);
	}
	for(int i = 0; i < N; i++){
		flow.addEdge(which_block[0][i], which_block[1][i] + B0, 1);
	}
	int ans = flow.calc(st, en);
	if(ans < K){
		cout << "Inconsistent" << '\n';
		return;
	}
	vector<vector<pair<int,int> > > residual(V);
	for(int v = 0; v < V; v++){
		for(auto e : flow.g[v]){
			residual[v].push_back({e.dest, e.c});
		}
	}
	for(int a = 0; a < N; a++){
		int v = which_block[0][a];
		for(auto e : flow.g[v]){
			int w = B0 + which_block[1][a];
			if(e.dest != w) continue;
			int x, y;
			if(e.f == 1){
				can_yes[a] = 1;
				x = v;
				y = w;
			} else {
				can_no[a] = 1;
				x = w;
				y = v;
			}
			vector<int> vis(V);
			queue<int> q;
			q.push(x);
			vis[x] = 1;
			while(!q.empty()){
				int cv = q.front();
				q.pop();
				for(auto [cw, cap] : residual[cv]){
					if(cap == 0) continue;
					if(vis[cw]) continue;
					vis[cw] = 1;
					q.push(cw);
				}
			}
			if(vis[y]){
				can_yes[a] = can_no[a] = 1;
			}
			break;
		}		
	}

	for(int i = 0; i < N; i++){
		cout << "-NY?"[(can_yes[i] << 1) ^ can_no[i]];
	}
	cout << '\n';
}

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int T;
	cin >> T;
	while(T--) solve();
}
