import kotlin.math.max
import kotlin.math.min

fun main() {
    operator fun List<Int>.component6() = get(5)
    tailrec fun gcd(x: Int, y: Int): Int = if (y == 0) x else gcd(y, x % y)
    tailrec fun gcd(x: Long, y: Long): Long = if (y == 0L) x else gcd(y, x % y)
    fun lcm(x: Int, y: Int) = x / gcd(x, y) * y
    fun lcm(x: Long, y: Long) = x / gcd(x, y) * y
    fun trace(w: Int, w1: Int, x1: Int, dx1: Int, w2: Int, x2: Int, dx2: Int): BooleanArray {
        val p = 2 * lcm(w - w1, w - w2)
        var x1 = x1
        var x2 = x2
        var dx1 = dx1
        var dx2 = dx2
        val t = BooleanArray(p)
        for (i in 0..<p) {
            val l = max(x1, x2)
            val r = min(x1 + w1, x2 + w2)
            t[i] = l < r
            x1 += dx1
            if (x1 == 0 || x1 == w - w1) dx1 = -dx1
            x2 += dx2
            if (x2 == 0 || x2 == w - w2) dx2 = -dx2
        }
        return t
    }
    repeat(readln().toInt()) {
        val (w, h) = readln().split(' ').map { it.toInt() }
        val (w1, h1, x1, y1, dx1, dy1) = readln().split(' ').map { it.toInt() }
        val (w2, h2, x2, y2, dx2, dy2) = readln().split(' ').map { it.toInt() }
        val tx = trace(w, w1, x1, dx1, w2, x2, dx2)
        val ty = trace(h, h1, y1, dy1, h2, y2, dy2)
        val g = gcd(tx.size, ty.size)
        val gx = LongArray(g)
        val gy = LongArray(g)
        for (i in 0..<tx.size) if (tx[i]) gx[i % g]++
        for (i in 0..<ty.size) if (ty[i]) gy[i % g]++
        var p = (0..<g).sumOf { i -> gx[i] * gy[i] }
        val q = lcm(tx.size.toLong(), ty.size.toLong())
        val gpq = gcd(p, q)
        println("${p / gpq}/${q / gpq}")
    }
}

