/**
 *    author:  tourist
 *    created: 05.12.2024 13:55:09
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt;
  cin >> tt;
  while (tt--) {
    int W, H;
    cin >> W >> H;
    struct Mover {
      int s, c, dc;
    };
    struct Rect {
      Mover x, y;
    };
    array<Rect, 2> rects;
    for (auto& r : rects) {
      cin >> r.x.s >> r.y.s >> r.x.c >> r.y.c >> r.x.dc >> r.y.dc;
    }
    auto Build = [&](int len, Mover a, Mover b) {
      int per_a = 2 * (len - a.s);
      int per_b = 2 * (len - b.s);
      int per = lcm(per_a, per_b);
      vector<int> ret(per);
      for (int i = 0; i < per; i++) {
        ret[i] = (a.c + a.s <= b.c || b.c + b.s <= a.c ? 0 : 1);
        a.c += a.dc;
        b.c += b.dc;
        if (a.c == 0 || a.c == len - a.s) {
          a.dc *= -1;
        }
        if (b.c == 0 || b.c == len - b.s) {
          b.dc *= -1;
        }
      }
      return ret;
    };
    vector<int> a = Build(W, rects[0].x, rects[1].x);
    vector<int> b = Build(H, rects[0].y, rects[1].y);
    int g = gcd(int(a.size()), int(b.size()));
    vector<int> sum_a(g);
    for (int i = 0; i < int(a.size()); i++) {
      sum_a[i % g] += a[i];
    }
    vector<int> sum_b(g);
    for (int i = 0; i < int(b.size()); i++) {
      sum_b[i % g] += b[i];
    }
    int64_t num = 0;
    for (int i = 0; i < g; i++) {
      num += int64_t(sum_a[i]) * sum_b[i];
    }
    int64_t den = int64_t(a.size()) * int64_t(b.size()) / g;
    auto red = gcd(num, den);
    cout << num / red << "/" << den / red << '\n';
  }
  return 0;
}
