#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#define fs first
#define ss second
#define vi vector <int>
#define vii vector <vi>
#define int long long
#define pii pair <int, int>
#define all(x) (x).begin(), (x).end()
#define pb push_back
using namespace std;
const int mod = 1e9 + 7;
const int inf = 1e18;
bool isfind;

bool expression(string s){
    if (s.empty()) return false;
    if (!isdigit(s[0]) || !isdigit(s.back())) return false;

    for (int i = 1; i < s.size(); ++ i)
        if (!isdigit(s[i]) && !isdigit(s[i-1]))
            return false;

    if (s[0] == '0') return false;
    for (int i = 1; i < s.size(); ++ i)
        if (s[i] == '0' && !isdigit(s[i-1]))
            return false;

    return true;
}

bool equality(string s){
    if (s.find('=') == string::npos) return false;
    string a = s.substr(0, (int)s.find('='));
    string b = s.substr((int)s.find('=') + 1);
    if (!expression(a) || !expression(b)) return false;

    return true;
}

int eval(string s){
    int res = 0, cur = 0, sign = 1;
    for (char c : s){
        if (isdigit(c)) cur = cur * 10 + (c - '0');
        else {
            if (cur > 9999999999LL) return inf;
            res += sign * cur;
            cur = 0;
            (c == '+' ? sign = 1 : sign = -1);
        }
    }
    if (cur > 9999999999LL) return inf;
    res += sign * cur;

    return res;
}

bool correct(string s){
    if (!equality(s)) return false;
    string a = s.substr(0, (int)s.find('='));
    string b = s.substr((int)s.find('=') + 1);

    return eval(a) == eval(b);
}

void cal(string s, int i){
    if (isfind) return;
    if (!isdigit(s[i])) return;

    string a = s;
    a.erase(i, 1);
    int n = s.size();
    string ss = "";
    ss.pb(s[i]);

    for (int j = 0; j < n; ++ j){
        string b = a;
        b.insert(j, ss);
        if (correct(b) && !isfind){
            cout << b;
            isfind = true;
        }
    }
}


void solve(){
    isfind = false;
    string s; cin >> s;
    if (correct(s)){
        cout << "Correct";
        return;
    }

    for (int i = 0; i < s.size(); ++ i)
        cal(s, i);

    if (!isfind) cout << "Impossible";
}

signed main(){
    cin.tie(nullptr)->ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t --)
        solve();
    return 0;
}
