#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;

typedef long long ll;

const int MAXN = (int)5e5 + 5;

vector<int> adj[MAXN];

pair<int, int> wh[MAXN];
bool used[MAXN];
int deg[MAXN];
int a[MAXN];
int n;

void solve()
{
    cin >> n;
    n *= 2;

    for (int i = 1; i <= n; i++)
    {
        wh[i] = {-1, -1};
    }

    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        if (wh[a[i]].first == -1)
        {
            wh[a[i]].first = i;
        }
        else
        {
            wh[a[i]].second = i;
        }
    }

    for (int i = 1; i <= n; i++)
    {
        adj[i].clear();
    }

    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    queue<int> Q;

    for (int i = 1; i <= n; i++)
    {
        deg[i] = sz(adj[i]);
        used[i] = false;
        if (deg[i] == 1)
        {
            Q.push(i);
        }
    }

    vector<pair<int, int>> pairs;

    while (!Q.empty())
    {
        int v = Q.front();
        Q.pop();

        if (used[v])
        {
            continue;
        }

        int u = 0;
        while (u < sz(adj[v]) && used[adj[v][u]])
        {
            u++;
        }
        if (u == sz(adj[v]))
        {
            continue;
        }
        u = adj[v][u];
        pairs.push_back({v, u});
        used[u] = used[v] = true;

        for (int to : adj[u])
        {
            if (--deg[to] == 1 && !used[to])
            {
                Q.push(to);
            }
        }
    }

    // cout << "pairs:\n";
    // for (auto [u, v] : pairs)
    // {
    //     cout << u << ' ' << v << '\n';
    // }
    // cout << endl;

    for (int i = 1; i <= n; i++)
    {
        adj[i].clear();
        used[i] = false;
    }

    for (int i = 0; i < sz(pairs); i++)
    {
        auto [u, v] = pairs[i];
        if (a[u] == a[v])
        {
            continue;
        }
        adj[a[u]].push_back(i);
        adj[a[v]].push_back(i);
    }

    vector<pair<int, int>> swaps;

    auto solve_cyc = [&](vector<int> cyc) -> void
    {
        assert(sz(cyc) >= 2);
        for (int i = 0; i < sz(cyc); i++)
        {
            int id = cyc[i];
            int nxt_id = cyc[(i + 1) % sz(cyc)];
            assert(a[pairs[id].second] == a[pairs[nxt_id].first]);
        }
        swaps.push_back({pairs[cyc[0]].first, pairs[cyc[1]].first});
        int l = 1, r = sz(cyc) - 1;
        bool dir = false;
        while (l < r)
        {
            if (!dir)
            {
                swaps.push_back({pairs[cyc[r]].second, pairs[cyc[l]].second});
                l++;
            }
            else
            {
                swaps.push_back({pairs[cyc[l]].first, pairs[cyc[r]].first});
                r--;
            }
            dir = !dir;
        }
    };

    for (int i = 1; i <= n / 2; i++)
    {
        if (sz(adj[i]) != 1 || used[i])
        {
            continue;
        }
        vector<int> path;
        int v = i, prv = -1;
        // cout << "path: ";
        while (true)
        {
            // cout << v << ' ';
            assert(!used[v]);
            used[v] = true;
            pair<int, int> nxt{-1, -1};
            for (int id : adj[v])
            {
                int to = a[pairs[id].first] ^ a[pairs[id].second] ^ v;
                if (id != prv)
                {
                    nxt = {id, to};
                }
            }
            if (nxt.second == -1)
            {
                break;
            }
            path.push_back(nxt.first);
            prv = nxt.first;
            v = nxt.second;
        }
        // cout << endl;

        for (int j = 1; j < sz(path); j++)
        {
            int id = path[j];
            int prv_id = path[j - 1];
            if (a[pairs[id].first] != a[pairs[prv_id].second])
            {
                swap(pairs[id].first, pairs[id].second);
            }
        }
        int fake_id = sz(pairs);
        {
            int frst_id = path[0], lst_id = path.back();
            int c = a[pairs[frst_id].first];
            int fake_u = wh[c].first ^ wh[c].second ^ pairs[frst_id].first;
            c = a[pairs[lst_id].second];
            int fake_v = wh[c].first ^ wh[c].second ^ pairs[lst_id].second;
            // cout << "fake " << fake_u << ' ' << fake_v << endl;
            pairs.push_back({fake_v, fake_u});
        }
        path.push_back(fake_id);
        // for (int j = 1; j < sz(path); j++)
        // {
        //     int id = path[j];
        //     int prv_id = path[j - 1];
        //     if (a[pairs[id].first] != a[pairs[prv_id].second])
        //     {
        //         swap(pairs[id].first, pairs[id].second);
        //     }
        // }
        solve_cyc(path);
    }

    for (int i = 1; i <= n / 2; i++)
    {
        if (sz(adj[i]) != 2 || used[i])
        {
            continue;
        }
        vector<int> cyc;
        int v = i, prv = -1;
        // cout << "cyc: ";
        while (true)
        {
            // cout << v << ' ';
            assert(!used[v]);
            used[v] = true;
            pair<int, int> nxt{-1, -1};
            for (int id : adj[v])
            {
                int to = a[pairs[id].first] ^ a[pairs[id].second] ^ v;
                if (id != prv)
                {
                    nxt = {id, to};
                }
            }
            cyc.push_back(nxt.first);
            if (nxt.second == i)
            {
                break;
            }
            prv = nxt.first;
            v = nxt.second;
        }
        // cout << endl;
        for (int j = 1; j < sz(cyc); j++)
        {
            int id = cyc[j];
            int prv_id = cyc[j - 1];
            if (a[pairs[id].first] != a[pairs[prv_id].second])
            {
                swap(pairs[id].first, pairs[id].second);
            }
        }

        solve_cyc(cyc);
    }

    cout << sz(swaps) << '\n';

    for (auto [u, v] : swaps)
    {
        cout << u << ' ' << v << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;

    while (T--)
    {
        solve();
    }

    return 0;
}