#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

class Matrix {
public:
    const short N;
    vector<bool> _data{};

    Matrix(short n) : N{n} {
        _data.resize(N*N, false);
    }

    auto at(int i, int j) const {
        return _data[i * N + j];
    }

    void set(int i, int j) {
         _data[i * N + j] = true;
    }
};

vector<short> finish_sequence() {
    int n;
    cin >> n;

    vector<short> seq(n + 1);
    for (int i{1}; i <= n; ++i)
        cin >> seq[i];

    return seq;
}

int main() {
    auto finish_seq = finish_sequence();
    short n = (short)(finish_seq.size() - 1);
    Matrix m{(short)(finish_seq.size() + 1)};

    int inv{0};
    // Mark Invariants
    for (int i{1}; i < finish_seq.size() - 1; ++i) {
        for (int j{i + 1}; j < finish_seq.size(); ++j) {
            if (finish_seq[i] > finish_seq[j]) {
                m.set(finish_seq[i], finish_seq[j]);
                inv++;
            }
        }
    }
    cout << n*(n-1)-inv << endl;

    // Initial Seq
    vector<short> s(finish_seq.size());
    for (short i{1}; i <= n; ++i) {
        s[i] = i;
    }

    // 1
    for (int i{1}; i <= n; ++i) {
        for (int j{1}; j < n; ++j) {
            if (m.at(s[j], s[j + 1])) break;
            else {
                cout << s[j + 1] << ' ' << s[j] << endl;
                swap(s[j], s[j + 1]);
            }
        }
    }


    return 0;
}
