// author: Danila "akshin_" Axyonov

#include <iostream>
#include <vector>
using namespace std;
typedef long long int lli;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    lli Q;
    cin >> Q;
    while (Q--)
        solve();

    return 0;
}

void solve() {
    lli N;
    cin >> N;
    vector<vector<char>> A(2, vector<char>(N));
    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < (int)N; ++j)
            cin >> A[i][j];

    if (N == 1LL) {
        if (A[0][0] == A[1][0])
            cout << "Unique" << endl;
        else // A[0][0] != A[1][0]
            cout << "None" << endl;
        return;
    }
    // now N >= 2

    bool left = true,
         was_changes;
    do {
        was_changes = false;
        if (left) {
            // case j = 0
            if (A[0][0] == '.') {
                if (A[1][0] == '#' and A[0][1] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[1][0] == '#' and A[0][1] == '.') {
                    A[0][0] = A[0][1] = '#';
                    was_changes = true;
                } else if (A[1][0] == '.' and A[0][1] == '#') {
                    A[0][0] = A[1][0] = '#';
                    was_changes = true;
                }
            }
            if (A[1][0] == '.') {
                if (A[0][0] == '#' and A[1][1] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[0][0] == '#' and A[1][1] == '.') {
                    A[1][0] = A[1][1] = '#';
                    was_changes = true;
                } else if (A[0][0] == '.' and A[1][1] == '#') {
                    A[1][0] = A[0][0] = '#';
                    was_changes = true;
                }
            }

            // case j = 1..N-2
            for (int j = 1; j + 1 < (int)N; ++j) {
                if (A[0][j] == '.') {
                    if (A[0][j - 1] == '#' and A[0][j + 1] == '#' and A[1][j] == '#') {
                        cout << "None" << endl;
                        return;
                    }
                    if (A[0][j - 1] == '.' and A[0][j + 1] == '#' and A[1][j] == '#') {
                        A[0][j] = A[0][j - 1] = '#';
                        was_changes = true;
                    } else if (A[0][j - 1] == '#' and A[0][j + 1] == '.' and A[1][j] == '#') {
                        A[0][j] = A[0][j + 1] = '#';
                        was_changes = true;
                    } else if (A[0][j - 1] == '#' and A[0][j + 1] == '#' and A[1][j] == '.') {
                        A[0][j] = A[1][j] = '#';
                        was_changes = true;
                    }
                }
                if (A[1][j] == '.') {
                    if (A[1][j - 1] == '#' and A[1][j + 1] == '#' and A[0][j] == '#') {
                        cout << "None" << endl;
                        return;
                    }
                    if (A[1][j - 1] == '.' and A[1][j + 1] == '#' and A[0][j] == '#') {
                        A[1][j] = A[1][j - 1] = '#';
                        was_changes = true;
                    } else if (A[1][j - 1] == '#' and A[1][j + 1] == '.' and A[0][j] == '#') {
                        A[1][j] = A[1][j + 1] = '#';
                        was_changes = true;
                    } else if (A[1][j - 1] == '#' and A[1][j + 1] == '#' and A[0][j] == '.') {
                        A[1][j] = A[0][j] = '#';
                        was_changes = true;
                    }
                }
            }

            // case j = N-1
            if (A[0][N - 1LL] == '.') {
                if (A[1][N - 1LL] == '#' and A[0][N - 2LL] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[1][N - 1LL] == '#' and A[0][N - 2LL] == '.') {
                    A[0][N - 1LL] = A[0][N - 2LL] = '#';
                    was_changes = true;
                } else if (A[1][N - 1LL] == '.' and A[0][N - 2LL] == '#') {
                    A[0][N - 1LL] = A[1][N - 1LL] = '#';
                    was_changes = true;
                }
            }
            if (A[1][N - 1LL] == '.') {
                if (A[0][N - 1LL] == '#' and A[1][N - 2LL] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[0][N - 1LL] == '#' and A[1][N - 2LL] == '.') {
                    A[1][N - 1LL] = A[1][N - 2LL] = '#';
                    was_changes = true;
                } else if (A[0][N - 1LL] == '.' and A[1][N - 2LL] == '#') {
                    A[1][N - 1LL] = A[0][N - 1LL] = '#';
                    was_changes = true;
                }
            }
        } else { // right
            // case j = N-1
            if (A[0][N - 1LL] == '.') {
                if (A[1][N - 1LL] == '#' and A[0][N - 2LL] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[1][N - 1LL] == '#' and A[0][N - 2LL] == '.') {
                    A[0][N - 1LL] = A[0][N - 2LL] = '#';
                    was_changes = true;
                } else if (A[1][N - 1LL] == '.' and A[0][N - 2LL] == '#') {
                    A[0][N - 1LL] = A[1][N - 1LL] = '#';
                    was_changes = true;
                }
            }
            if (A[1][N - 1LL] == '.') {
                if (A[0][N - 1LL] == '#' and A[1][N - 2LL] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[0][N - 1LL] == '#' and A[1][N - 2LL] == '.') {
                    A[1][N - 1LL] = A[1][N - 2LL] = '#';
                    was_changes = true;
                } else if (A[0][N - 1LL] == '.' and A[1][N - 2LL] == '#') {
                    A[1][N - 1LL] = A[0][N - 1LL] = '#';
                    was_changes = true;
                }
            }

            // case j = 1..N-2
            for (int j = (int)N - 2; j >= 1; --j) {
                if (A[0][j] == '.') {
                    if (A[0][j - 1] == '#' and A[0][j + 1] == '#' and A[1][j] == '#') {
                        cout << "None" << endl;
                        return;
                    }
                    if (A[0][j - 1] == '.' and A[0][j + 1] == '#' and A[1][j] == '#') {
                        A[0][j] = A[0][j - 1] = '#';
                        was_changes = true;
                    } else if (A[0][j - 1] == '#' and A[0][j + 1] == '.' and A[1][j] == '#') {
                        A[0][j] = A[0][j + 1] = '#';
                        was_changes = true;
                    } else if (A[0][j - 1] == '#' and A[0][j + 1] == '#' and A[1][j] == '.') {
                        A[0][j] = A[1][j] = '#';
                        was_changes = true;
                    }
                }
                if (A[1][j] == '.') {
                    if (A[1][j - 1] == '#' and A[1][j + 1] == '#' and A[0][j] == '#') {
                        cout << "None" << endl;
                        return;
                    }
                    if (A[1][j - 1] == '.' and A[1][j + 1] == '#' and A[0][j] == '#') {
                        A[1][j] = A[1][j - 1] = '#';
                        was_changes = true;
                    } else if (A[1][j - 1] == '#' and A[1][j + 1] == '.' and A[0][j] == '#') {
                        A[1][j] = A[1][j + 1] = '#';
                        was_changes = true;
                    } else if (A[1][j - 1] == '#' and A[1][j + 1] == '#' and A[0][j] == '.') {
                        A[1][j] = A[0][j] = '#';
                        was_changes = true;
                    }
                }
            }

            // case j = 0
            if (A[0][0] == '.') {
                if (A[1][0] == '#' and A[0][1] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[1][0] == '#' and A[0][1] == '.') {
                    A[0][0] = A[0][1] = '#';
                    was_changes = true;
                } else if (A[1][0] == '.' and A[0][1] == '#') {
                    A[0][0] = A[1][0] = '#';
                    was_changes = true;
                }
            }
            if (A[1][0] == '.') {
                if (A[0][0] == '#' and A[1][1] == '#') {
                    cout << "None" << endl;
                    return;
                }
                if (A[0][0] == '#' and A[1][1] == '.') {
                    A[1][0] = A[1][1] = '#';
                    was_changes = true;
                } else if (A[0][0] == '.' and A[1][1] == '#') {
                    A[1][0] = A[0][0] = '#';
                    was_changes = true;
                }
            }
        }

        left = !left;
    } while (was_changes);

    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < (int)N; ++j)
            if (A[i][j] == '.') {
                cout << "Multiple" << endl;
                return;
            }
    cout << "Unique" << endl;
    return;
}
