#include <iostream>
#include <queue>
#include <map>
#include <algorithm>

using namespace std;

bool f_set(bool reg) {
    return reg ? false : true;
}

bool f_unset(bool reg) {
    return !f_set(reg);
}

bool check(string& command, bool reg, bool result) {
    return command == "set" ? f_set(reg) == result : f_unset(reg) == result;
}

bool use(string& command) {
    return command == "set";
}

bool in(vector<int> list, int value) {
    for (int v : list) {
        if (v == value) return true;
    }
    return false;
}


int main() {
    int n, m;
    cin >> n;
    vector<tuple<string, bool>> history;
    map<int, vector<int>> rules;

    string s;
    string a;

    for (int i = 0; i < n; i++) {
        cin >> s >> a;
        history.push_back(tuple<string, bool>(s, a == "true"));
    }

    int k, l;
    cin >> m;

    for (int i = 0; i < m; i++) {
        cin >> k >> l;
        if (!rules.count(k)) {
            rules.insert({k, {}});
        }
        rules.at(k).push_back(l);
    }

    queue<tuple<bool, vector<int>>> super_queue;
    for (int i = 0; i < history.size(); i++) {
        string command = get<0>(history.at(i));
        if (check(command, false, get<1>(history.at(i)))) 
            super_queue.push(tuple<bool, vector<int>>(use(command), {i + 1}));
    }

    vector<int> answ(n, -1);
    while (!super_queue.empty()) {
        tuple<bool, vector<int>> value = super_queue.front();
        bool reg = get<0>(value);
        vector<int> hist = get<1>(value);
        super_queue.pop();

        if (hist.size() == history.size()) {
            answ = hist;
            break;
        }

        vector<tuple<bool, vector<int>>> bananas;
        bool flag_skip = false;

        for (int i = 0; i < history.size(); i++) {
            string command = get<0>(history.at(i)); 
            bool result = get<1>(history.at(i));

            if (in(hist, i + 1) || !check(command, reg, result)) {
                continue;
            }

            if (rules.count(i+1) != 0) {
                bool flag = false;
                for (int end : rules.at(i+1)) {
                    if (in(hist, end)) {
                        flag = true;
                        break;
                    }
                }
                if (flag) {
                    flag_skip = true;
                    break;
                }
            }

            vector<int> lol = hist;
            lol.push_back(i+1);
            bananas.push_back(tuple<bool, vector<int>>(use(command), lol));
        }
        
        if (!flag_skip) {
            for (tuple<bool, vector<int>> banana : bananas) {
                super_queue.push(banana);
            }
        }
    }

    if (answ.at(0) == -1) {
        cout << -1;
    } else {
        for (int i = 0; i < answ.size(); i++) {
            cout << answ.at(i) << ((i == answ.size() - 1) ? "" : " ");
        }
    }


    return 0;
}