#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;
/*
 *
 */

size_t new_ind = 0;

struct IndInt {
    ll x, id;

    IndInt(ll x, ll id) : x(x), id(id) {

    }

    explicit IndInt() = default;


    friend istream &operator>>(istream &in, IndInt &i) {
        in >> i.x;
        i.id = new_ind++;
        return in;
    }

    friend bool operator<(const IndInt &a, const IndInt &b) {
        if (a.x != b.x)
            return a.x < b.x;
        return a.id < b.id;
    }
};

struct Task {
    ll a, d, id;

    Task(ll a, ll d, ll id) : a(a), d(d), id(id) {

    }

    Task() = default;

    friend bool operator<(const Task &a, const Task &b) {
        if (a.d != b.d)
            return a.d < b.d;
        return a.id < b.id;
    }
};

void solve() {
    new_ind = 0;
    int n, m, q;
    cin >> n >> m >> q;
    vector<IndInt> meet(q);
    vector<ll> episode(m);
    vector<Task> task(n);
    for (int i = 0; i < n; ++i) {
        cin >> task[i].a;
        task[i].id = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> task[i].d;
    }
    cin >> episode >> meet;
    sort(meet.begin(), meet.end());
    sort(task.begin(), task.end());
    ll prev = 1e18;
    vector<pair<ll, ll>> frees;
    for (int i = n - 1; i >= 0; --i) {
        ll cur_d = min(prev, task[i].d);
        if (cur_d < prev) {
            meet.emplace_back(cur_d, -1);
            meet.emplace_back(prev, -2);
//            cerr << cur_d << ' '  << prev << ' ' << endl;
        }
        ll cur = cur_d - task[i].a;
        prev = cur;
    }
    if (prev > 0) {
        meet.emplace_back(0, -1);
        meet.emplace_back(prev, -2);
    }
    sort(meet.begin(), meet.end());
    ll freed = 0;
    int to_watch = 0;
    bool free_now = false;
    prev = 0;
    vector<ll> ans(q);
    for (auto e :meet) {
        if (e.id >= 0) {
            if (free_now) {
                freed += e.x - prev;
                while (to_watch < m && freed >= episode[to_watch]) {
                    freed -= episode[to_watch];
                    ++to_watch;
                }
                prev = e.x;
            }
            ans[e.id] = to_watch;
        } else if (e.id == -1) {
            free_now = true;
            prev = e.x;
        } else {
            free_now = false;
            freed += e.x - prev;
            while (to_watch < m && freed >= episode[to_watch]) {
                freed -= episode[to_watch];
                ++to_watch;
            }

            ;;
            ;
            ;
            ;
            ;;
            ;
            ;
        }
    }
    cout << ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.in", "r", stdin);
    freopen("./../bober.out", "w", stdout);
#endif

#define BOBRY

#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}