#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R> && !is_convertible_v<R, string>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;

/*
 *
 */

using graph = vector<set<int>>;

void solve() {
    int n;
    cin >> n;
    vector<int> a(2 * n);
    vector<vector<int>> where(n + 1);
    cin >> a;
    for (int i = 0; i < 2 * n; ++i) {
        where[a[i]].push_back(i);
    }
    graph g(2 * n);
    for (int i = 0; i < 2 * n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].insert(u);
        g[u].insert(v);
    }
    queue<int> leaf;
    for (int i = 0; i < 2 * n; ++i) {
        if (g[i].size() == 1) {
            leaf.push(i);
        }
    }
    vector<pair<int, int>> swapes;
    vector<bool> deleted(2 * n, false);
    while (!leaf.empty()) {
        int v = leaf.front();
        leaf.pop();
        if (g[v].size() != 1 || deleted[v]) {
            continue;
        }
        int x = a[v];
        int other = where[x][0];
        if (v == other) {
            other = where[x][1];
        }
        int u = *g[v].begin();
        if (u != other) {
            for (int j = 0; j < 2; ++j) {
                if (where[a[u]][j] == u) {
                    where[a[u]][j] = other;
                }
            }
            swap(a[u], a[other]);
            swapes.emplace_back(other + 1, u + 1);
        }
        deleted[v] = true;
        deleted[u] = true;
        for (int w: g[u]) {
            if (w == v) {
                continue;
            }
            g[w].erase(u);
            if (g[w].size() == 1) {
                leaf.push(w);
            }
        }
    }
    cout << swapes.size() << '\n';
    for (auto p: swapes) {
        cout << p.first << ' ' << p.second << '\n';
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
#endif

#define BOBRY
#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}