#include <bits/stdc++.h>

using namespace  std;

#define int long long

struct Op {
    bool is_set;
    bool is_true;
};

bool operator < (Op a, Op b) {
    if (a.is_true == b.is_true) {
        return a.is_set < b.is_set;
    }
    return a.is_true < b.is_true;
}

vector<vector<int>> g;

vector<int> top_sort;
vector<int> used;
vector <Op> operations;
vector <int> colors;

map<Op, vector<int>> pos_col = {
        {Op{false, false}, {0, 4}},
       {Op{false, true}, {3}},
        {Op{true, false}, {2}},
        {Op{true, true}, {1}}
};

void calc_top_sort(int v) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (used[to]) {
            continue;
        }

        calc_top_sort(to);
    }

    top_sort.emplace_back(v);
}

bool color(int v, int col) {
    colors[v] = col;
    used[v] = 1;
    for (auto to: g[v]) {
        if (colors[to] != -1 && colors[to] < col) {
            return false;
        }

        if (colors[to] != -1) {
            continue;
        }

        bool find = false;
        for (auto new_col : pos_col[operations[to]]) {
            if (new_col >= col) {
                color(to, new_col);
                find = true;
                break;
            }
        }

        if (!find) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, vector<int>());
    used.assign(n, 0);
    operations.assign(n, Op{});
    colors.assign(n, -1);

    int set_true = 0;
    int unset_true = 0;
    for (int i = 0; i < n; i++) {
        string s, b;
        cin >> s >> b;
        if (s == "set") {
            operations[i].is_set = true;
        } else {
            operations[i].is_set = false;
        }

        if (b == "false") {
            operations[i].is_true = false;
        } else {
            operations[i].is_true = true;
        }

        if (operations[i].is_true) {
            if (operations[i].is_set) {
                set_true++;
            } else {
                unset_true++;
            }
        }
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        g[l].emplace_back(r);
    }

    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }

        calc_top_sort(i);
    }

    reverse(top_sort.begin(), top_sort.end());

    if (set_true > 1 || unset_true > 1 || (set_true == 0 && unset_true > 0)) {
        cout << -1 << '\n';
        return;
    }

    fill(used.begin(), used.end(), 0);

    for (int i = 0; i < n; i++) {
        int cur = top_sort[i];
        if (used[cur]) {
            continue;
        }

        if (!color(cur, pos_col[operations[cur]][0])) {
            cout << -1 << '\n';
            return;
        }
    }

    vector<vector<int>> buckets(5);

    for (int i = 0; i < n; i++) {
        int cur = top_sort[i];
        buckets[colors[cur]].emplace_back(cur);
    }

    if (!buckets[3].empty() && buckets[1].empty()) {
        cout << -1 << '\n';
        return;
    }

    if (!buckets[2].empty() && buckets[1].empty()) {
        cout << -1 << '\n';
        return;
    }

    if (!buckets[4].empty() && buckets[3].empty()) {
        cout << -1 << '\n';
        return;
    }



    for (auto &bucket : buckets) {
        for (auto i: bucket) {
            cout << i + 1 << ' ';
        }
    }
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}