#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

enum class Type {
    set_true,
    unset_true,
    set_false,
    unset_false
};

const int N = 100010;
Type type[N];
vector<int> g[N];
int top[N], top_sz = 0;
int used[N];
int reachable_from[N];
int ans[N];

void topsort_dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            topsort_dfs(u);
        }
    }
    top[top_sz++] = v;
}

void reach_dfs(int v) {
    reachable_from[v] = 1;
    for (auto u : g[v]) {
        if (!reachable_from[u]) {
            reach_dfs(u);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        if (a == "set") {
            if (b == "false") {
                type[i] = Type::set_false;
            } else {
                type[i] = Type::set_true;
            }
        } else {
            if (b == "false") {
                type[i] = Type::unset_false;
            } else {
                type[i] = Type::unset_true;
            }
        }
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[a].push_back(b);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) topsort_dfs(i);
    }
    reverse(top, top + n);
    for (int i = 0; i < n; ++i) {
        if (type[i] != Type::unset_false && !reachable_from[i]) {
            reach_dfs(i);
        }
    }
    int sz = n;
    for (int i = n; i--;) {
        int v = top[i];
        if (type[v] == Type::unset_false && reachable_from[v]) {
            ans[--sz] = v;
        }
    }
    for (int i = n; i--;) {
        int v = top[i];
        if (type[v] == Type::unset_true) {
            ans[--sz] = v;
        }
    }
    for (int i = n; i--;) {
        int v = top[i];
        if (type[v] == Type::set_false) {
            ans[--sz] = v;
        }
    }
    for (int i = n; i--;) {
        int v = top[i];
        if (type[v] == Type::set_true) {
            ans[--sz] = v;
        }
    }
    for (int i = n; i--;) {
        int v = top[i];
        if (type[v] == Type::unset_false && !reachable_from[v]) {
            ans[--sz] = v;
        }
    }
    int reg = 0, fl = 1;
    for (int i = 0; i < n; ++i) {
        int v = ans[i];
        used[v] = 2;
        if (type[v] == Type::set_true) {
            fl &= reg == 0;
            reg = 1;
        } else if (type[v] == Type::set_false) {
            fl &= reg == 1;
        } else if (type[v] == Type::unset_true) {
            fl &= reg == 1;
            reg = 0;
        } else if (type[v] == Type::unset_false) {
            fl &= reg == 0;
        }
        for (auto u : g[v]) {
            if (used[u] == 2) fl = 0;
        }
    }
    if (fl) {
        for (int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << ' ';
        }
        cout << endl;
    } else {
        cout << -1 << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}