#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

//struct int256 {
//    uint64_t val[4];
//    int256(ll x) : lo(x) {}
//    int256(__int128 lo, __int128 hi) : lo(lo), hi(hi) {}
//    int256 operator+(const int256& o) const {
//        if (lo + o.lo < lo || lo + o.lo < lo)
//    }
//};

struct R {
    __int128 p, q;

    R(__int128 _p, __int128 _q) {
        p = _p, q = _q;
        __int128 g = gcd(p, q);
        p /= g, q /= g;
//        if (q > 4) {
//            assert(false);
//        }
        assert(q == 1);
    }

    R(ll _p, ll _q) {
        p = _p, q = _q;
        __int128 g = gcd(p, q);
        p /= g, q /= g;
//        assert(q <= 2);
        assert(q == 1);
    }

    R operator*(const R& o) const {
        __int128 g1 = gcd(p, o.q);
        __int128 g2 = gcd(q, o.p);
        return {(p / g1) * (o.p / g2), (q / g2) * (o.q / g1)};
    }

    R operator+(const R& o) const {
//        __int128 g1 = gcd(p, o.q);
//        __int128 g2 = gcd(q, o.p);
        return {p * o.q + q * o.p, q * o.q};
    }

    R operator-(const R& o) const {
        return {p * o.q - q * o.p, q * o.q};
    }

    bool operator<(const R& o) const {
        return p * o.q < q * o.p;
    }

    bool operator>(const R& o) const {
        return p * o.q > q * o.p;
    }

    bool operator==(const R& o) const {
        return p == o.p && q == o.q;
    }
};

struct N {
    R a, b;

    N(R a, R b) : a(a), b(b) {

    }

    N operator*(const N& o) const {
        return {a * o.a + R(2ll, 1ll) * b * o.b, a * o.b + b * o.a};
    }

    N operator+(const N& o) const {
        return {a + o.a, b + o.b};
    }

    N operator-(const N& o) const {
        return {a - o.a, b - o.b};
    }

    bool operator<(const N& o) const {
        bool l_neg = (a - o.a) < R(0ll, 1ll);
        bool r_neg = (o.b - b) < R(0ll, 1ll);
        if (l_neg && !r_neg) return true;
        if (!l_neg && r_neg) return false;
        if (!l_neg && !r_neg) {
            return (a - o.a) * (a - o.a) < (o.b - b) * (o.b - b) * R(2ll, 1ll);
        } else {
            return (a - o.a) * (a - o.a) > (o.b - b) * (o.b - b) * R(2ll, 1ll);
        }
    }
};

struct P {
    N x, y;
//    R a, b, c, d;

    P(N x, N y) : x(x), y(y) { }

    P go(int angle, ll len) {
        P copy = *this;
        switch (angle / 45) {
            case 0: x.a = x.a + R(2 * len, 1); break;
            case 1: x.b = x.b + R(len, 1); y.b = y.b + R(len, 1); break;
            case 2: y.a = y.a + R(2 * len, 1); break;
            case 3: x.b = x.b - R(len, 1); y.b = y.b + R(len, 1); break;
            case 4: x.a = x.a - R(2 * len, 1); break;
            case 5: x.b = x.b - R(len, 1); y.b = y.b - R(len, 1); break;
            case 6: y.a = y.a - R(2 * len, 1); break;
            case 7: x.b = x.b + R(len, 1); y.b = y.b - R(len, 1); break;
        }
        P res = *this;
        *this = copy;
        return res;
    }

    P rotate45() {
        P res = *this;
        N c(R(0ll, 1ll), R(1ll, 1ll));
        res.x = c * (x - y);
        res.y = c * (x + y);
        res.x.a.p /= 2;
        res.y.a.p /= 2;
        res.x.b.p /= 2;
        res.y.b.p /= 2;
        return res;
    }

    bool operator<(const P& o) const {
        return make_tuple(x.a, x.b, y.a, y.b) < make_tuple(o.x.a, o.x.b, o.y.a, o.y.b);
    }

    bool operator==(const P& o) const {
        return make_tuple(x.a, x.b, y.a, y.b) == make_tuple(o.x.a, o.x.b, o.y.a, o.y.b);
    }
};

void solve() {
    R zero(0ll, 1ll);
    P cur(N(zero, zero), N(zero, zero));
    int angle = 0;
    multiset<pair<P, P>> seg;
    int n;
    cin >> n;
    while (n--) {
        string cmd;
        cin >> cmd;
        if (cmd == "rotate") {
            int dangle;
            cin >> dangle;
            angle = (angle + dangle) % 360;
        } else if (cmd == "draw") {
            ll len;
            cin >> len;
            P nxt = cur.go(angle, len);
            seg.emplace(cur, nxt);
            seg.emplace(nxt, cur);
            cur = nxt;
        } else if (cmd == "move") {
            ll len;
            cin >> len;
            P nxt = cur.go(angle, len);
            cur = nxt;
        }
    }
    R inf((ll)1e18, 1ll);
    N mnx(inf, inf);
    N mny(inf, inf);
    for (auto [a, b] : seg) {
        mnx = min(mnx, a.x);
        mnx = min(mnx, b.x);
        mny = min(mny, a.y);
        mny = min(mny, b.y);
    }
    auto curseg = seg;
    for (int da = 45; da <= 360; da += 45) {
        multiset<pair<P, P>> newcurseg;
        for (auto [a, b] : curseg) {
            newcurseg.emplace(a.rotate45(), b.rotate45());
        }
        curseg = newcurseg;
        N curmnx(inf, inf);
        N curmny(inf, inf);
        for (auto [a, b] : curseg) {
            curmnx = min(curmnx, a.x);
            curmnx = min(curmnx, b.x);
            curmny = min(curmny, a.y);
            curmny = min(curmny, b.y);
        }
        newcurseg.clear();
        for (auto [a, b] : curseg) {
            newcurseg.emplace(P(a.x - curmnx + mnx, a.y - curmny + mny),
                              P(b.x - curmnx + mnx, b.y - curmny + mny));
        }
        curseg = newcurseg;
        if (curseg == seg) {
            cout << da << '\n';
            return;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}