#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

const ll INF = 1e18;

vector<vector<pair<int, ll>>> gr;
vector<vector<pair<int, ll>>> gr_t;
vector<vector<int>> dag;
vector<vector<int>> dag_t;

void solve() {
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    gr_t.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr[u].emplace_back(v, w);
        gr_t[v].emplace_back(u, w);
    }
    dag.resize(n);
    dag_t.resize(n);
    vector<ll> dist(n, INF);
    dist[n - 1] = 0;
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<>> pq;
    pq.emplace(0, n - 1);
    while (!pq.empty()) {
        auto [d, v] = pq.top();
        pq.pop();
        if (dist[v] != d) continue;
        for (auto [to, w] : gr_t[v]) {
            if (dist[to] > dist[v] + w) {
                dist[to] = dist[v] + w;
                pq.emplace(dist[to], to);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (dist[i] == INF) continue;
        for (auto [to, w] : gr[i]) {
            if (dist[i] == dist[to] + w) {
                dag[i].push_back(to);
                dag_t[to].push_back(i);
            }
        }
    }
    if (dist[0] == INF) {
        cout << -1 << '\n';
        return;
    }
    vector<ll> dp(n, INF);
    vector<int> cnt(n);
    for (int i = 0; i < n; ++i) {
        cnt[i] = sz(dag[i]);
    }
    vector<int> q;
    for (int i = 0; i < n; ++i) {
        if (dist[i] == INF) {
            dp[i] = -1;
            q.emplace_back(i);
        }
    }
    int y = -1;

    while (!q.empty()) {
        vector<int> layer;

        for (int st = 0; st < sz(q); ++st) {
            int v = q[st];
            layer.emplace_back(v);
            dp[v] = y;
            for (int from : dag_t[v]) {
                if (from == n - 1 || dp[from] == y) continue;
                --cnt[from];
                if (cnt[from] == 0) {
                    q.emplace_back(from);
                }
            }
        }
        q.clear();
        for (int v : layer) {
            for (auto [from, _] : gr_t[v]) {
                if (from == n - 1 || dp[from] != INF || dp[from] == y) continue;
                q.emplace_back(from);
            }
        }
        sort(all(q));
        q.erase(unique(all(q)), q.end());
        ++y;
    }
//    for (int i = 0; i < n; ++i) cout << dp[i] << ' ';
//    cout << '\n';
    cout << (dp[0] == INF ? n : dp[0]) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}