#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;



void solve() {
    int n; cin >> n;
    vi a(n * 2);
    rep(i, n * 2) cin >> a[i];
    rep(i, n * 2) a[i]--;
    vector<vi> g(n * 2);
    vi deg(n * 2);
    rep(_, n * 2 - 1) {
        int u, v; cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        deg[u]++;
        deg[v]++;
    }
    queue<int> q;
    rep(i, n * 2) {
        if (deg[i] == 1) {
            q.push(i);
        }
    }
    vector<bool> used(n * 2);
    vector<pair<int, int>> edges;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        assert(deg[v] <= 1);
        int u = -1;
        for(auto &t : g[v]) {
            deg[t]--;
            if (deg[t] == 1) {
                u = t;
                q.push(t);
            }
            if (!used[v] && !used[t]) {
                if (a[v] != a[t]) edges.emplace_back(v, t);
                used[v] = used[t] = true;
            }
        }
    }

    vector<vector<pair<int, int>>> g2(n);
    int e = edges.size();
    rep(i, e) {
        auto [u, v] = edges[i];
        g2[a[u]].emplace_back(a[v], i);
        g2[a[v]].emplace_back(a[u], i);
    }

    vector<bool> was(n);

    auto dfs = [&] (auto &&self, int v, vi &edges, vi &verts) -> void {
        was[v] = true;
        int cnt = 0;
        for(auto &[u, i] : g2[v]) {
            if (was[u]) continue;
            edges.push_back(i);
            verts.push_back(u);
            self(self, u, edges, verts);
            cnt++;
        }
        assert(cnt <= 1);
    };
    vector<int> xx(n);
    rep(i, n * 2) xx[a[i]] ^= i;

    vector<pair<int, int>> ans;
    rep(i, n) {
        if (g2[i].empty()) continue;
        if (was[i]) continue;
        if (g2[i].size() >= 2) continue;

        vi e2, verts;
        verts.push_back(i);
        dfs(dfs, i, e2, verts);

        vector<int> my;
        rep(j, e2.size()) {
            auto [u, v] = edges[e2[j]];
            if (a[v] != verts[j + 1]) {
                swap(u,v);
            }
            my.push_back(u);
            my.push_back(v);
        }
        int sz = my.size();

        int mid = (sz - 1) / 2;
        for(int j = mid - 1; j >= 0; --j) {
            ans.emplace_back(my[j], my[mid * 2 - j]);
        }
        int who = my[0];
        int nx = my.back();
        ans.emplace_back(xx[a[who]] ^ who, nx);
    }
    rep(i, n) {
        if (g2[i].empty()) continue;
        if (was[i]) continue;
//        cerr << g2[i].size() << endl;
        assert(g2[i].size() == 2);

        vi e2, verts;
        verts.push_back(i);
        dfs(dfs, i, e2, verts);

        bool ok = false;
        for(auto &[u, j] : g2[verts.back()]) {
            if (i == u && j != e2[0]) {
                e2.push_back(j);
                verts.push_back(u);
                ok = true;
                break;
            }
        }
        assert(ok);

        vector<int> my;
        rep(j, e2.size()) {
            auto [u, v] = edges[e2[j]];
            if (a[v] != verts[j + 1]) {
                swap(u,v);
            }
            my.push_back(u);
            my.push_back(v);
        }
        int sz = my.size();

        int mid = (sz - 1) / 2;
        for(int j = mid - 1; j >= 0; --j) {
            ans.emplace_back(my[j], my[mid * 2 - j]);
        }
        int who = my[0];
        int nx = my.back();
        assert(a[who] == a[nx]);
    }

    cout << ans.size() << '\n';
    for(auto &[u, v] : ans) cout << u + 1 << ' ' << v + 1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}