#include <iostream>
#include <vector>

using namespace std;

void dfs1(vector<vector<int>>& graph, vector<pair<pair<int, int>, int>>& answers, int i, int p)
{
    int summ = 0;
    pair<int, int> min_delta = make_pair(INT_MAX, INT_MAX);
    for(int j : graph[i])
	if(j != p)
	{
	    dfs1(graph, answers, j, i);
	    auto it = answers[j];
	    min_delta = min(min_delta, make_pair(it.first.first - it.first.second, j));
	    summ += it.first.first;
	}
    if(min_delta.first == 0)
	answers[i] = make_pair(make_pair(summ+1, summ), min_delta.second);
    else
	answers[i] = make_pair(make_pair(summ, summ), -1);
}

void dfs2(vector<vector<int>>& graph, vector<pair<pair<int, int>, int>>& answers, vector<pair<int, int>>& chosen_edges, int i, int p, bool can_take)
{
    int j0 = can_take ? answers[i].second : -1;
    if(j0 >= 0)
	chosen_edges.push_back(make_pair(i, j0));
    for(int j : graph[i])
	if(j != p)
	    dfs2(graph, answers, chosen_edges, j, i, j != j0);
}

void solve()
{
    int ns;
    cin >> ns;
    int n = ns * 2;
    vector<int> services(n);
    for(int& i : services)
	cin >> i;
    vector<vector<int>> graph(n);
    for(int i = 1; i < n; i++)
    {
	int u, v;
	cin >> u >> v;
	u--;
	v--;
	graph[u].push_back(v);
	graph[v].push_back(u);
    }
    vector<pair<pair<int, int>, int>> answers(n);
    dfs1(graph, answers, 0, -1);
    vector<pair<int, int>> chosen_edges;
    dfs2(graph, answers, chosen_edges, 0, -1, true);
    vector<int> edge(n, -1);
    for(int i = 0; i < chosen_edges.size(); i++)
	edge[chosen_edges[i].first] = edge[chosen_edges[i].second] = i;
    int m = chosen_edges.size();
    vector<vector<int>> graph2(m);
    vector<pair<int, int>> vertices(ns, make_pair(-1, -1));
    for(int i = 0; i < n; i++)
    {
	int s = services[i] - 1;
	if(vertices[s].first < 0)
	    vertices[s].first = i;
	else
	    vertices[s].second = i;
    }
    for(int i = 0; i < ns; i++)
    {
	int e1 = edge[vertices[i].first];
	int e2 = edge[vertices[i].second];
	if(e1 >= 0 && e2 >= 0 && e1 != e2)
	{
	    graph2[e1].push_back(e2);
	    graph2[e2].push_back(e1);
	}
    }
    auto find_next = [&](int i, int p)
    {
	bool first = true;
	for(int j : graph2[i])
	    if(j != p || !(first && (first = false, true)))
		return j;
        return -1;
    };
    auto find_start = [&](int i)
    {
	int start = i;
	int p = -1;
	for(;;)
	{
	    int j = find_next(i, p);
	    if(j < 0)
		return i;
	    p = i;
	    i = j;
	    if(i == start)
		return i;
	}
    };
    vector<bool> visited(ns);
    auto get_other = [&](int x)
    {
	int s = services[x] - 1;
	return vertices[s].first == x ? vertices[s].second : vertices[s].first;
    };
    auto filter_cycle = [&](int i)
    {
	int start = i = find_start(i);
	int p = -1;
	pair<int, int> cur = chosen_edges[i];
	vector<pair<int, int>> ans(1, cur);
	for(;;)
	{
	    visited[i] = true;
	    int j = find_next(i, p);
	    if(j == start)
		return ans;
	    if(j < 0)
	    {
		ans.push_back(make_pair(get_other(ans.back().second), get_other(ans.front().first)));
		return ans;
	    }
	    pair<int, int> next = chosen_edges[j];
	    if(services[next.first] != services[cur.second])
	    {
		if(services[next.second] == services[cur.second])
		    swap(next.first, next.second);
		else
		{
		    /*if(ans.size() != 1)
			__builtin_trap();*/
		    swap(cur.first, cur.second);
		    swap(ans.back().first, ans.back().second);
		}
	    }
	    p = i;
	    i = j;
	    cur = next;
	    ans.push_back(cur);
	}
    };
    vector<pair<int, int>> ans;
    auto push = [&](int x, int y)
    {
	if(x == y)
	    return; //__builtin_trap();
	ans.push_back(make_pair(x, y));
    };
    for(int i = 0; i < m; i++)
	if(!visited[i])
	{
	    if(graph2[i].size() == 0 && services[chosen_edges[i].first] == services[chosen_edges[i].second])
		continue;
	    vector<pair<int, int>> q = filter_cycle(i);
	    if(q.size() >= 2)
		push(q[0].second, q[1].second);
	    if(q.size() >= 3)
		push(q[0].first, q[2].first);
	    if(q.size() >= 4)
	    {
		bool sec = true;
		int i = 2;
		int j = q.size() - 1;
		for(int k = 3; k < q.size(); k++)
		{
		    if(sec)
			push(q[i].second, q[j].second);
		    else
			push(q[i].first, q[j].first);
		    if(sec)
		    {
			sec = false;
			i++;
		    }
		    else
		    {
			sec = true;
			j--;
		    }
		}
	    }
	}
    cout << ans.size() << '\n';
    for(auto i : ans)
	cout << i.first + 1 << ' ' << i.second + 1 << '\n';
}

int main()
{
    int T;
    cin >> T;
    for(int I = 1; I <= T; I++)
	solve();
}
