#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

struct Task {
    ll d{};
    int t{};
    int ind{};
};

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<Task> a(n);
    for(int i = 0;i < n;i++) {
        cin >> a[i].t;
    }

    for(int i = 0;i < n;i++) {
        cin >> a[i].d;
        a[i].ind = i;
    }

    vector<int> l(m);
    for(int i = 0;i < m;i++) {
        cin >> l[i];
    }

    vector<ll> lp(m + 1);
    for(int i = 1;i <= m;i++)
        lp[i] = lp[i - 1] + l[i - 1];

    sort(a.begin(), a.end(), [&](Task& a, Task& b) -> bool {
        return a.d < b.d;
    });

    set<pair<ll, int>> st;
    for(int i = n - 1;i >= 0;i--) {
        a[i].ind = i;
        ll r = 1e18;
        if(st.empty()) {
            r = a[i].d;
        } else {
            r = min(a[i].d, st.begin()->first - a[st.begin()->second].t);
        }

        st.insert({r, i});
    }

    vector<pair<ll, int>> t(q);

    for(int i = 0;i < q;i++) {
        ll x;
        cin >> x;

        t[i].first = x;
        t[i].second = i;
    }

    vector<int> answer(q);
    sort(t.begin(), t.end());

    ll lsum = 0;
    for(int i = 0;i < q;i++) {
        ll tk = t[i].first;

        while(st.size() && a[st.begin()->second].d <= tk) {
            int ind = st.begin()->second;
            lsum += a[ind].t;
            st.erase(st.begin());
        }

        ll r = tk;
        
        if(st.size()) {
            r = min(r, st.begin()->first - a[st.begin()->second].t);
        }

        answer[t[i].second] = r - lsum;
    }

    for(auto e : answer) {
        auto it = upper_bound(lp.begin(), lp.end(), e);
        cout << it - lp.begin() - 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt;
    cin >> tt;

    while(tt--)
        solve();
}