#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <cassert>
#include <functional>

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<set<int>> g(2 * n);
    vector<int> a(2 * n);
    vector<vector<int>> pos(n + 1);
    for(int i = 0;i < 2 * n;i++) {
        cin >> a[i];
        pos[a[i]].push_back(i);
    }
    
    for(int i = 0;i < 2 * n - 1;i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].insert(v);
        g[v].insert(u);
    }

    queue<int> q;
    int cl = 1;
    vector<int> color(2 * n);
    vector<vector<int>> vertc(n + 1);
    vector<vector<int>> cols(n + 1);

    for(int i = 0;i < 2 * n;i++) {
        if(g[i].size() == 1) {
            q.push(i);
        }
    }

    // cout << "ok" << endl;
    while(q.size()) {
        int v = q.front();
        q.pop();
        if(g[v].size() == 0) continue;

        int u = *g[v].begin();
        g[u].erase(v);
        g[v].erase(u);
        if(color[u] != 0 || color[v] != 0) {
            continue;
        }
        color[v] = color[u] = cl;
        vertc[cl].push_back(u);
        vertc[cl].push_back(v);
        cl++;

        if(g[u].size() == 1)
            q.push(u);
    }

    vector<int> swapped(2 * n);
    vector<pair<int, int>> answer;
    auto Swap = [&](int u, int v) {
        // cout << u + 1 << ' ' << v + 1 << ' ' << swapped[u] << swapped[v] << endl;
        assert(swapped[u] == 0 && swapped[v] == 0);
        answer.push_back({u, v});

        swapped[u] = 1;
        swapped[v] = 1;

        auto& p1 = pos[a[u]];
        for(auto& e : p1)
            if(e == u)
                e = v;
        
        auto& p2 = pos[a[v]];
        for(auto& e : p2)
            if(e == v)
                e = u;

        swap(a[u], a[v]);
    };

    // cout << "pair\n";
    // for(auto x : vertc) {
    //     cout << "d";
    //     for(auto vert : x)
    //         cout << vert + 1 << ' ';
    //     cout << endl;
    // }

    function<void(int)> dfs = [&](int c) {

        if(c == 0) return;
        if(vertc[c].size() < 2) return;
        // cout << c << endl;
        
        int v = vertc[c][0];
        int u = vertc[c][1];

        if(a[v] == a[u]) return;

        if(swapped[u]) {
            int need = a[u];
            int from = v;
            int next = pos[need][0];
            if(next == u) next = pos[need][1];
            Swap(v, next);
            dfs(color[next]);
        } else if(swapped[v]) {
            int need = a[v];
            int next = pos[need][0];
            int from = u;
            if(next == v) next = pos[need][1];            
            Swap(u, next);
            dfs(color[next]);
        } else {
            int need = a[u];
            int next = pos[need][0];
            int from = v;

            if(next == u) next = pos[need][1];
            
            // cout << from << ' ' << next << endl;
            if(swapped[next]) {
                from = u;
                int need = a[v];
                next = pos[need][0];
                if(next == v) next = pos[need][1];
            }

            Swap(from, next);
            dfs(color[next]);
        }
    };

    for(int i = 0;i <= n;i++) {
        dfs(i);
    }

    cout << answer.size() << '\n';
    for(auto e : answer)
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt;
    cin >> tt;
    while(tt--)
        solve();
}