#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> tree;
vector<vector<int>> dp;
vector<int> dp_ch;

void dfs_dp(int v, int p) {
    if (p != -1 && tree[v].size() == 1) {
        return;
    }
    for (int ch : tree[v]) {
        if (ch == p) {
            continue;
        }
        dfs_dp(ch, v);
    }
    int sum = 0;
    for (int ch : tree[v]) {
        if (ch == p) {
            continue;
        }
        sum += dp[ch][1];
    }
    dp[v][0] = sum;
    int max_sum = sum;
    int max_ind = -1;
    for (int i = 0; i < tree[v].size(); i++) {
        int ch = tree[v][i];
        if (ch == p) {
            continue;
        }
        int cur_sum = sum;
        cur_sum -= dp[ch][1];
        cur_sum += dp[ch][0] + 1;
        if (cur_sum > max_sum) {
            max_sum = cur_sum;
            max_ind = i;
        }
    }
    dp[v][1] = max_sum;
    dp_ch[v] = max_ind;
}

vector<pair<int, int>> pairs;

void restore_dp(int v, int p, bool is_take) {
    if (is_take) {
        int pair_with = dp_ch[v];
        for (int i = 0; i < tree[v].size(); i++) {
            if (i == pair_with) {
                continue;
            }
            if (tree[v][i] == p) {
                continue;
            }
            restore_dp(tree[v][i], v, true);
        }
        if (pair_with != -1) {
            restore_dp(tree[v][pair_with], v, false);
            pairs.push_back({v, tree[v][pair_with]});
        }
    }
    else {
        for (int ch : tree[v]) {
            if (ch == p) {
                continue;
            }
            restore_dp(ch, v, true);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> colors(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> colors[i];
    }
    tree = vector<vector<int>>(2 * n);
    for (int i = 0; i < 2 * n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        tree[a].push_back(b);
        tree[b].push_back(a);
    }
    dp = vector<vector<int>>(2 * n, vector<int>(2, 0));
    dp_ch = vector<int>(2 * n, -1);
    pairs.clear();
    dfs_dp(0, -1);
    restore_dp(0, -1, true);
    vector<bool> used(2 * n, false);
    for (auto [first, second] : pairs) {
        used[first] = true;
        used[second] = true;
    }
    int last = -1;
    vector<pair<int, int>> swaps;
    for (int i = 0; i < 2 * n; i++) {
        if (used[i]) {
            continue;
        }
        if (last == -1) {
            last = i;
        }
        else {
            pairs.push_back({last, i});
            last = -1;
        }
    }
    vector<bool> used_pairs(n, false);
    map<int, vector<int>> pos_a;
    for (int i = 0; i < pairs.size(); i++) {
        int first = pairs[i].first;
        int second = pairs[i].second;
        pos_a[colors[first]].push_back(i);
        pos_a[colors[second]].push_back(i);
    }
    set<int> two_swaps;
    for (int i = 0; i < n; i++) {
        int color1 = colors[pairs[i].first];
        int color2 = colors[pairs[i].second];
        if (color1 != color2) {
            two_swaps.insert(i);
        }
    }
    int current_ind = -1;
    bool is_first = true; //swap in first
    while(true) {
        if (two_swaps.empty()) {
//            cout << "empty";
            break;
        }
        set<int> colors_op;
        if (current_ind == -1) {
            current_ind = *(two_swaps.begin());
            is_first = true;
            two_swaps.erase(current_ind);
        }
        int color_req;
        if (is_first) {
            color_req = colors[pairs[current_ind].first];
        }
        else {
            color_req = colors[pairs[current_ind].second];
        }
        colors_op.insert(colors[pairs[current_ind].first]);
        colors_op.insert(colors[pairs[current_ind].second]);
        vector<int> req_indices = pos_a[color_req];
        int other_ind = req_indices[0];
        if (other_ind == current_ind) {
            other_ind = req_indices[1];
        }
        bool is_other_first = true; // swap with first
        int other_color1 = colors[pairs[other_ind].first];
        int other_color2 = colors[pairs[other_ind].second];
        colors_op.insert(colors[pairs[other_ind].first]);
        colors_op.insert(colors[pairs[other_ind].second]);
        if (other_color1 == color_req) {
            is_other_first = true;
        }
        else if (other_color2 == color_req){
            is_other_first = false;
        }
        else {
            cout << "ub";
            break;
        }
        int prev_color = -1;
        int swap_first, swap_second;
        if (is_first) {
            prev_color = colors[pairs[current_ind].second];
            colors[pairs[current_ind].second] = color_req;
            swap_first = pairs[current_ind].second;
        }
        else {
            prev_color = colors[pairs[current_ind].first];
            colors[pairs[current_ind].first] = color_req;
            swap_first = pairs[current_ind].first;
        }

        if (is_other_first) {
            colors[pairs[other_ind].first] = prev_color;
            swap_second = pairs[other_ind].first;
        }
        else {
            colors[pairs[other_ind].second] = prev_color;
            swap_second = pairs[other_ind].second;
        }
        swaps.push_back({swap_first, swap_second});
//        cout << "color_op: ";
//        for (auto clr : colors_op) {
//            cout << clr << ' ';
//        }
//        cout << endl;
        for (int color : colors_op) {
            vector<int> pos = pos_a[color];
            if (pos[0] == pos[1]) {
                cout << "ubpos" << endl;
                cout << "swaps: ";
                cout << swaps.size() << endl;
                for (auto [fs, ss] : swaps) {
                    cout << fs << ' ' << ss << endl;
                }
                cout << "color " << color << endl;
                cout << "pos " << pos[0] << ' ' << pos[1] << endl;
                cout << "colors: ";
                for (int i = 0; i < 2 * n; i++) {
                    cout << colors[i] << ' ';
                }
                cout << endl;
                cout << "pairs: ";
                for (int i = 0; i < n; i++ ){
                    cout << "(" << pairs[i].first << ' ' << pairs[i].second << ") ";
                }
                cout << endl;
                return;
            }
            bool is_first_good = false;
            int first = pairs[pos[0]].first;
            int second = pairs[pos[0]].second;
            if (colors[first] == color || colors[second] == color) {
                is_first_good = true;
            }
            first = pairs[pos[1]].first;
            second = pairs[pos[1]].second;
            bool is_second_good = false;
            if (colors[first] == color || colors[second] == color) {
                is_second_good = true;
            }

            bool is_in_req = false;
            bool is_in_other = false;
            first = pairs[current_ind].first;
            second = pairs[current_ind].second;
            if (colors[first] == color || colors[second] == color) {
                is_in_req = true;
            }
            first = pairs[other_ind].first;
            second = pairs[other_ind].second;
            if (colors[first] == color || colors[second] == color) {
                is_in_other = true;
            }
            if (!is_first_good) {
                if (is_in_req) {
                    pos[0] = current_ind;
                    is_in_req = false;
                }
                else if (is_in_other){
                    pos[0] = other_ind;
                    is_in_other = false;
                }
                else {
                    cout << "ubcolor1" << endl;
                }
            }
            if (!is_second_good) {
                if (is_in_req) {
                    pos[1] = current_ind;
                    is_in_req = false;
                }
                else if (is_in_other){
                    pos[1] = other_ind;
                    is_in_other = false;
                }
                else {
                    cout << "ubcolor2" << endl;
                }
            }
            pos_a[color] = pos;
        }
        bool is_good1 = colors[pairs[current_ind].first] == colors[pairs[current_ind].second];
        bool is_good2 = colors[pairs[other_ind].first] == colors[pairs[other_ind].second];
        if (!is_good1) {
            cout << "ubisgood1" << endl;
        }
        two_swaps.erase(current_ind);
        if (is_good2) {
            two_swaps.erase(other_ind);
            current_ind = -1;
            is_first = true;
        }
        else {
            current_ind = other_ind;
            is_first = is_other_first;
        }

    }
//    cout << "colors: " << endl;
//    for (int i = 0; i < n; i++) {
//        cout << colors[pairs[i].first] << ' ' << colors[pairs[i].second] << endl;
//    }
    cout << swaps.size() << '\n';
    for (int i = 0; i < swaps.size(); i++) {
        cout << swaps[i].first + 1 << ' ' << swaps[i].second + 1 << '\n';
    }
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while(t--) {
        solve();
    }
}
