#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;

// (x_0, x_1, y_0, y_1)
vector<array<int, 4>> dirs = {
    array{1, 0, 0, 0},
    array{0, 1, 0, 1},
    array{0, 0, 1, 0},
    array{0, -1, 0, 1},
    array{-1, 0, 0, 0},
    array{0, -1, 0, -1},
    array{0, 0, -1, 0},
    array{0, 1, 0, -1},
};

using P = array<ll, 4>;

P move(P start, int dist, int dir) {
    for (int i = 0; i < 4; i++) {
        start[i] += dist * dirs[dir][i];
    }
    return start;
}

vector<pair<P, P>> solve(const vector<pair<int, int>> &ops, int dir) {
    P p = {0, 0, 0, 0};
    vector<pair<P, P>> segs;
    vector<int> segs_dirs;
    for (auto [op, val] : ops) {
        if (op == 0) { // draw
            auto dest = move(p, val, dir);
            segs.emplace_back(p, dest);
            p = dest;
            segs_dirs.push_back(dir % 4);
        } else if (op == 1) { // rotate
            dir = (dir + val) % len(dirs);
        } else if (op == 2) { // move
            p = move(p, val, dir);
        }
    }

    assert(!segs.empty());

    for (int i = 0; i < 4; i++) {
        ll mn = segs[0].first[i];
        for (int j = 0; j < len(segs); j++) {
            mn = min(mn, segs[j].first[i]);
            mn = min(mn, segs[j].second[i]);
        }
        for (int j = 0; j < len(segs); j++) {
            segs[j].first[i] -= mn;
            segs[j].second[i] -= mn;
        }
    }

    vector<pair<P, P>> nsegs;
    for (int dir = 0; dir < 4; dir++) {
        map<P, vector<P>> g;
        for (int i = 0; i < len(segs); i++) {
            if (segs_dirs[i] != dir) {
                continue;
            }
            g[segs[i].first].push_back(segs[i].second);
            g[segs[i].second].push_back(segs[i].first);
        }

        set<P> used;
        for (auto [p, adj] : g) {
            if (len(adj) != 1) {
                continue;
            }
            if (used.count(p)) {
                continue;
            }

            auto last = p;
            for (auto v = p;;) {
                auto &cur_adj = g[v];
                assert(len(cur_adj) <= 2);
                used.insert(v);

                bool found = false;
                for (auto u : cur_adj) {
                    if (u == last) {
                        continue;
                    }
                    found = true;
                    last = v;
                    v = u;
                    break;
                }

                if (!found) {
                    nsegs.emplace_back(p, v);
                    break;
                }
            }
        }
    }

    for (auto &[x, y] : nsegs) {
        if (x > y) {
            swap(x, y);
        }
    }
    sort(all(nsegs));
    return nsegs;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    cin >> n;

    vector<pair<int, int>> ops(n);
    for (int i = 0; i < n; i++) {
        string s;
        int x;
        cin >> s >> x;
        if (s == "draw") {
            ops[i].first = 0;
        } else if (s == "rotate") {
            ops[i].first = 1;
            assert(x % 45 == 0);
            x /= 45;
        } else {
            assert(s == "move");
            ops[i].first = 2;
        }

        ops[i].second = x;
    }

    auto my = solve(ops, 0);

    for (int i = 1; i <= 8; i++) {
        auto cur = solve(ops, i % 8);
        if (my == cur) {
            cout << 45 * i << '\n';
            return 0;
        }
    }
    assert(false);

    return 0;
}
