#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;

struct chel {
    int w, h;
    int x, y;
    int dx, dy;

    void read() {
        cin >> w >> h >> x >> y >> dx >> dy;
    }

    void normalize(int W, int H) {
        if (x + w == W && dx == 1) {
            dx *= -1;
        } else if (x == 0 && dx == -1) {
            dx *= -1;
        }
        if (y + h == H && dy == 1) {
            dy *= -1;
        } else if (y == 0 && dy == -1) {
            dy *= -1;
        }
    }
};

struct BIT {
    int n;
    vector<int> bit;

    BIT(int n) : n(n), bit(n + 1) {}

    void add(int pos, int d) {
        for (pos++; pos < len(bit); pos += pos & -pos) {
            bit[pos] += d;
        }
    }

    void add_on_interval(int l, int r, int d) {
        add(l, d);
        add(r, -d);
    }

    int at(int pos) {
        int res = 0;
        for (pos++; pos > 0; pos -= pos & -pos) {
            res += bit[pos];
        }
        return res;
    }
};

constexpr int N = 8000 + 228;
int pref[N][N];

void solve() {
    int W, H;
    cin >> W >> H;

    chel first, second;
    first.read();
    second.read();

    first.normalize(W, H);
    second.normalize(W, H);

    auto find_preiod = [&](chel x) {
        auto init = x;
        vector<pair<int, int>> steps;
        while (true) {
            steps.emplace_back(x.x, x.y);
            x.x += x.dx;
            x.y += x.dy;
            x.normalize(W, H);
            if (init.x == x.x && init.y == x.y && init.dx == x.dx && init.dy == x.dy) {
                break;
            }
        }
        return steps;
    };

    auto first_per = find_preiod(first);
    auto second_per = find_preiod(second);

    if (len(first_per) < len(second_per)) {
        swap(first_per, second_per);
        swap(first, second);
    }

    int g = gcd(len(first_per), len(second_per));
    ll ans = 0;

    vector<int> coordsx, coordsy;
    BIT bit(H);

    for (int r = 0; r < g; r++) {
        coordsx.clear();
        coordsy.clear();
        for (int i = r; i < len(second_per); i += g) {
            int x1 = second_per[i].first - first.w + 1;
            int x2 = second_per[i].first + second.w;
            int y1 = second_per[i].second - first.h + 1;
            int y2 = second_per[i].second + second.h;

            x1 = max(x1, 0);
            y1 = max(y1, 0);
            x2 = min(x2, W);
            y2 = min(y2, H);

            coordsx.push_back(x1);
            coordsy.push_back(y1);
        }

        for (int i = r; i < len(first_per); i += g) {
            coordsx.push_back(first_per[i].first);
            coordsy.push_back(first_per[i].second);
        }

        sort(all(coordsx));
        coordsx.resize(unique(all(coordsx)) - coordsx.begin());
        sort(all(coordsy));
        coordsy.resize(unique(all(coordsy)) - coordsy.begin());

        auto get_coord = [&](int x, const vector<int> &v) {
            return int(lower_bound(all(v), x) - v.begin());
        };

        const int CUR_W = len(coordsx);
        const int CUR_H = len(coordsy);
        for (int i = 0; i <= CUR_W; i++) {
            memset(pref[i], 0, sizeof(int) * (CUR_H + 1));
        }

        for (int i = r; i < len(second_per); i += g) {
            int x1 = second_per[i].first - first.w + 1;
            int x2 = second_per[i].first + second.w;
            int y1 = second_per[i].second - first.h + 1;
            int y2 = second_per[i].second + second.h;

            x1 = max(x1, 0);
            y1 = max(y1, 0);
            x2 = min(x2, W);
            y2 = min(y2, H);

            x1 = get_coord(x1, coordsx);
            x2 = get_coord(x2, coordsx);
            y1 = get_coord(y1, coordsy);
            y2 = get_coord(y2, coordsy);
            pref[x1][y1]++;
            pref[x2][y1]--;
            pref[x1][y2]--;
            pref[x2][y2]++;
        }

        for (int i = 0; i <= CUR_W; i++) {
            for (int j = 1; j <= CUR_H; j++) {
                pref[i][j] += pref[i][j - 1];
            }
        }

        for (int i = 1; i <= CUR_W; i++) {
            for (int j = 0; j <= CUR_H; j++) {
                pref[i][j] += pref[i - 1][j];
            }
        }

        for (int i = r; i < len(first_per); i += g) {
            int cur_x = get_coord(first_per[i].first, coordsx);
            int cur_y = get_coord(first_per[i].second, coordsy);
            ans += pref[cur_x][cur_y];
        }
    }

    ll length = 1ll * len(first_per) / g * len(second_per);
    ll ggg = gcd(length, ans);
    ans /= ggg;
    length /= ggg;
    cout << ans << "/" << length << '\n';
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
