#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<numeric>
#include<cstdint>
#include<bitset>
#include<string>
#include<deque>

using namespace std;

#define int long long
using ull = uint64_t;
using pull = pair<ull, ull>;

template <class T>
ostream& operator<<(ostream& dst, const vector<T>& src) {
	for (auto& v : src) dst << v << ' ';
	return dst;
}
template <class U, class V>
ostream& operator<<(ostream& dst, const pair<U, V>& src) {
	return dst << '(' << (long long)(src.first) << ':' << (long long)(src.second) << ')';
}

void mark_overlap(vector<pull>& onto, ull step) {
	if (onto.empty() || onto.back().second != step) {
		onto.emplace_back(step, step + 1);
		return;
	}
	onto.back().second++;
}

void solve() {
	ull w, h; cin >> w >> h;

	ull steps_x = 2 * (w - 1);
	ull steps_y = 2 * (h - 1);

	pull r1x, r1y, r2x, r2y;
	int r1dx, r1dy, r2dx, r2dy;

	cin >> r1x.second >> r1y.second >> r1x.first >> r1y.first >> r1dx >> r1dy
		>> r2x.second >> r2y.second >> r2x.first >> r2y.first >> r2dx >> r2dy;
	r1x.second += r1x.first;
	r1y.second += r1y.first;
	r2x.second += r2x.first;
	r2y.second += r2y.first;

	vector<pull> x_overlap; x_overlap.reserve(10);
	vector<pull> y_overlap; y_overlap.reserve(10);

	for (ull i = 0; i < steps_x; i++) {
		ull lx = max(r1x.first, r2x.first);
		ull rx = min(r1x.second, r2x.second);
		if (lx < rx) mark_overlap(x_overlap, i);

		r1x.first += r1dx; r1x.second += r1dx;
		if (r1x.first == 0 || r1x.second == w) r1dx = -r1dx;
		r2x.first += r2dx; r2x.second += r2dx;
		if (r2x.first == 0 || r2x.second == w) r2dx = -r2dx;
	}
	for (ull i = 0; i < steps_y; i++) {
		ull ly = max(r1y.first, r2y.first);
		ull ry = min(r1y.second, r2y.second);
		if (ly < ry) mark_overlap(y_overlap, i);

		r1y.first += r1dy; r1y.second += r1dy;
		if (r1y.first == 0 || r1y.second == h) r1dy = -r1dy;
		r2y.first += r2dy; r2y.second += r2dy;
		if (r2y.first == 0 || r2y.second == h) r2dy = -r2dy;
	}

	vector<pull> x_overlap_mul, y_overlap_mul;
	//for (auto& [l, r] : x_overlap) {
	//	for (ull i = 0; i < steps_y; i++)
	//		x_overlap_mul.emplace_back(l + i * steps_x, r + i * steps_x);
	//}
	//for (auto& [l, r] : y_overlap) {
	//	for (ull i = 0; i < steps_x; i++)
	//		y_overlap_mul.emplace_back(l + i * steps_y, r + i * steps_y);
	//}
	for (ull i = 0; i < steps_y; i++) {
		for (auto& [l, r] : x_overlap)
			x_overlap_mul.emplace_back(l + i * steps_x, r + i * steps_x);
	}
	for (ull i = 0; i < steps_x; i++) {
		for (auto& [l, r] : y_overlap)
			y_overlap_mul.emplace_back(l + i * steps_y, r + i * steps_y);
	}

	ull a = 0;
	ull b = 0;
	ull overlap_len = 0;
	ull total_len = steps_x * steps_y;
	while (a < x_overlap_mul.size() && b < y_overlap_mul.size()) {
		auto [lx, rx] = x_overlap_mul[a];
		auto [ly, ry] = y_overlap_mul[b];
		ull l = max(lx, ly);
		ull r = min(rx, ry);
		if (l < r) overlap_len += r - l;
		if (rx < ry) a++;
		else         b++;
	}

	// cout << x_overlap_mul << endl << y_overlap_mul << endl;

	ull g = gcd(overlap_len, total_len);
	cout << overlap_len / g << "/" << total_len / g << endl;
}

signed main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int t = 1; cin >> t;
	for (int i = 0; i < t; i++)solve();

	return 0;
}