#include <bits/stdc++.h>
#define int long long
#define ld long double
#define p pair<int, int>
//#define endl '\n'
const int INF = (int)1e9+1;
const ld E = 3e-9;

using namespace std;

vector<p> hist;

int ask(int x) {
    cout << x+1 << endl;
    hist.emplace_back(x, -1);
    int w;
    cin >> w;
    hist.back().second = w;
    if (w == -1 || w == 3) {
        exit(0);
    }
    if (w == 2) {
        throw exception{};
    }
    return w;
}

struct Option {
    int l, r, x, y;
    ld P;

    bool operator<(const Option& other) const {
        return P < other.P;
    }
};

ld get_P_XA(Option& a) {
    auto [x, w] = hist.back();
    if (!(a.l <= x && x < a.r)) {
        return 1;
    }
    ld len = a.r-a.l;
//    assert(len > 0);
    return (len-1)/len;
}

ld get_P_BA(Option& a) {
    auto [x, w] = hist.back();
    ld P = (ld)(a.r-a.l)/(a.y-a.x);
    if (w == 1) {
        P = 1-P;
    }
    return P;
}

ld get_P_A_and_X(Option& a) {
    ld P_XA = get_P_XA(a);
    return P_XA*a.P;
}

ld get_P_A_and_B(Option& a) {
    ld P_BA = get_P_BA(a);
    return P_BA*a.P;
}

ld get_P_AX(Option& a, ld P_X) {
//    assert(abs(P_X) > E);
    return get_P_A_and_X(a)/P_X;
}

ld get_P_AB(Option& a, ld P_B) {
//    assert(abs(P_B) > E);
    return get_P_A_and_B(a)/P_B;
}

vector<Option> a;

ld get_P_X() {
    ld P = 0;
    for (auto& q : a) {
        P += get_P_XA(q)*q.P;
    }
    return P;
}

ld get_P_B() {
    ld P = 0;
    for (auto& q : a) {
        P += get_P_BA(q)*q.P;
    }
    return P;
}

void filter() {
    vector<Option> will;
    for (auto& q : a) {
        if (q.l >= q.r || abs(q.P) < E) {
            continue;
        }
        will.push_back(q);
    }
    a = will;
}

void rebuild() {
    ld P_X = get_P_X();
    for (auto& q : a) {
        q.P = get_P_AX(q, P_X);
    }
    auto [x, w] = hist.back();
    vector<Option> all;
    for (auto& q : a) {
        if (q.l <= x && x < q.r) {
            ld first = x-q.l, second = q.r-x-1, total = first+second;
            if (total == 0) {
                continue;
            }
            all.emplace_back(q.l, x, q.x, q.y, q.P*first/total);
            all.emplace_back(x+1, q.r, q.x, q.y, q.P*second/total);
        } else {
            all.push_back(q);
        }
    }
    a = all, all = {}, filter();
    ld P_B = get_P_B();
    for (auto& q : a) {
        q.P = get_P_AB(q, P_B);
    }
    if (w == 1) {
        for (auto& q : a) {
            int first = q.l-q.x, second = q.y-q.r, total = first+second;
            if (total == 0) {
                continue;
            }
            all.emplace_back(q.l, q.r, q.l, q.y, q.P*first/total);
            all.emplace_back(q.l, q.r, q.x, q.r, q.P*second/total);
        }
        a = all, all = {};
    }
    filter();
}

void solve(int n) {
    a = {{0, n, 0, n, 1}}, hist = {};
    while (true) {
        Option cur = *max_element(a.begin(), a.end());
        int m = (cur.l+cur.r)/2;
        ask(m);
        rebuild();
        ld P = 0;
        for (auto& q : a) {
            P += q.P;
        }
//        assert(abs(P-1) < E);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, t1;
    cin >> n >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        try {
            solve(n);
        } catch (...) {}
    }
    return 0;
}
