#include <bits/stdc++.h>
#define int long long
#define ld long double
#define p pair<int, int>
#define endl '\n'
const int INF = (int)1e9+1;
const int INF18 = (int)1e18 + 7;

using namespace std;

int n, m;
vector<pair<int, int>> da;
vector<int> last_time;
vector<int> l, pref_l, pref_a;

void build_pref_l() {
    pref_l.resize(l.size() + 1);
    pref_l[0] = 0;
    for (int i = 0; i < l.size(); ++i) {
        pref_l[i + 1] = pref_l[i] + l[i];
    }
}

void build_pref_a() {
    pref_a.resize(da.size() + 1);
    pref_a[0] = 0;
    for (int i = 0; i < n; ++i) {
        pref_a[i + 1] = pref_a[i] + da[i].second;
    }
}

void build_last_time() {
    sort(da.begin(), da.end());
    last_time.resize(da.size() + 1);
    last_time.back() = INF18;
    for (int i = n - 1; i >= 0; --i) {
        last_time[i] = min(last_time[i + 1], da[i].first) - da[i].second;
    }
}

int solve_t(int t) {
    int left = -1, right = n;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (da[mid].first >= t) {
            right = mid;
        } else {
            left = mid;
        }
    }
    int cur_last_time = last_time[right];
    int first_time = pref_a[right];
    int time_to_watch = cur_last_time - first_time;
    assert(time_to_watch >= 0);
    int ans = upper_bound(pref_l.begin(), pref_l.end(), time_to_watch) - pref_l.begin() - 1;
    return ans;
}

void solve() {
    int q;
    cin >> n >> m >> q;
    da.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> da[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> da[i].first;
    }
    build_last_time();
    l.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i];
    }
    build_pref_l();
    build_pref_a();
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        cout << solve_t(t) << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}