
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;


bool is_good(const char& ch) {
	return '0' <= ch && ch <= '9';
}

bool is_good(int i, string s) {
	if (!is_good(s[i]))
		return false;
	const int n = (int)s.size();
	return i - 1 >= 0 && is_good(s[i - 1]) || i + 1 < n && is_good(s[i + 1]);
}


bool calc_expression(const string& s) {
	int n = (int)s.size();
	int r = 0;

	long long first = 0;
	bool negative = false;
	int l = 0;
	for (l = 0; l < n; l = r + 1) {
		r = l;
		while (r < n && is_good(s[r])) {
			++r;
		}
		string now = s.substr(l, r - l);
		if (now[0] == '0' || now.size() > 10) return false;
		first += stoll(now) * (negative ? -1 : 1);
		if (r < n && s[r] == '=') {
			break;
		}
		negative = s[r] == '-';
	}
	l = r + 1;
	long long second = 0;
	negative = false;
	for (; l < n; l = r + 1) {
		r = l;
		while (r < n && is_good(s[r])) {
			++r;
		}
		string now = s.substr(l, r - l);
		if (now[0] == '0' || now.size() > 10) return false;
		second += stoll(now) * (negative ? -1 : 1);
		if (r == '=') {
			break;
		}
		negative = s[r] == '-';
	}
	return first == second;
}

void solve() {
	string s;
	cin >> s;
	if (calc_expression(s)) {
		cout << "Correct\n";
		return;
	}
	int n = (int)s.size();
	for (int i = 0; i < n; ++i) {
		if (!is_good(i, s)) {
			continue;
		}
		string t = s;
		t.erase(t.begin() + i);
		for (int j = 0; j < n - 1; ++j) {
			if (!is_good(j, s)) continue;
			string now = t.substr(0, j) + s[i] + t.substr(j);
			if (calc_expression(now)) {
				cout << now << '\n';
				return;
			}
		}
	}
	cout << "Impossible\n";
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	//cin >> t;
	forn(tt, t) solve();
}