
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;


void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<pair<ll, ll>>a(n);
	forn(i, n) cin >> a[i].second;
	forn(i, n) cin >> a[i].first;

	vector<ll> l(m);
	forn(i, m) cin >> l[i];
	vector<pair<ll, int>> t(q);
	forn(i, q) {
		cin >> t[i].first;
		t[i].second = i;
	}

	/////////////////////////
	sort(all(a));   //sort by deadline
	vector<ll> free(2 * n + 2);
	free[2 * n + 1] = LLONG_MAX - 1e10;
	free[2 * n] = a[n - 1].first;
	free[2 * n - 1] = a[n - 1].first - a[n - 1].second;
	for (int i = 2 * n - 2; i > 1; i -= 2) {
		ll time_end = min(free[i + 1], a[i / 2 - 1].first);
		free[i] = time_end;
		free[i - 1] = time_end - a[i / 2 - 1].second;
	}
	/////////////////////////
	sort(all(t));
	ll sumf = 0;
	int link = 1;
	int click = 0;
	vector<ll> ftime(t.size());
	while (click < t.size()) {
		while (link < free.size() && free[link] <= t[click].first) {
			if (link & 1)
				sumf += free[link] - free[link - 1];
			link++;
		}
		ftime[click] = sumf;
		if (link & 1)
			ftime[click] += t[click].first - free[link - 1];
		click++;
	}
	/////////////////////////
	vector<ll> prefl(m + 1);
	forn(i, m) prefl[i + 1] = prefl[i] + l[i];

	vector<ll> ans(q);
	forn(i, q) {
		int id = upper_bound(all(prefl), ftime[i]) - prefl.begin() - 1;
		ans[t[i].second] = id;
	}

	forn(i, q) cout << ans[i] << ' ';
	cout << '\n';
}


int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	cin >> t;
	forn(tt, t) solve();
}