#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int cnt;
    cin >> cnt;
    int n = 2 * cnt;
    vector<int> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    vector<vector<int>> g(n);
    set<int> del;
    vector<set<int>> lol(cnt);

    for(int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
        lol[a[u]].insert(u);
        lol[a[v]].insert(v);
    }

    vector<vector<int>> dp(n, vector<int>(2, -1));
    vector<int> dp_parent(n, -1);
    {
        std::function<void(int, int)> dfs;
        dfs = [&](int v, int p) -> void {
            int sum = 0;

            for (int u : g[v]) {
                if (u != p) {
                    dfs(u, v);
                    sum += dp[u][0];
                }
            }

            if (p != -1) {
                dp[v][1] = sum + 1;
            }

            dp[v][0] = sum;

            for (int u : g[v]) {
                if (u == p) {
                    continue;
                }

                int local = sum - dp[u][0] + dp[u][1];
                if (dp[v][0] < local) {
                    dp[v][0] = local;
                    dp_parent[v] = u;
                }
            }
        };

        dfs(0, -1);
    }

    vector<pair<int, int>> matching;

    {
        std::function<void(int, int, int)> dfs;
        dfs = [&](int v, int p, int value) {
            if (value == 0) {
                if (dp_parent[v] != -1) {
                    matching.push_back({v, dp_parent[v]});
                }

                for (int u : g[v]) {
                    if (u != p) {
                        int new_value = (dp_parent[v] == u ? 1 : 0);
                        dfs(u, v, new_value);
                    }
                }
            } else {
                for (int u : g[v]) {
                    if (u != p) {
                        dfs(u, v, 0);
                    }
                }
            }
        };

        dfs(0, -1, 0);
    }

    // cout << matching.size() << endl;

    // for (auto [u, v] : matching) {
    //     cout << u + 1 << ' ' << v + 1 << endl;
    // }
    // exit(0);

    // cout << "Hello 0" << endl;

    vector<vector<int>> where(cnt);

    for (int v = 0; v < matching.size(); v++) {
        where[a[matching[v].first]].push_back(v);
        where[a[matching[v].second]].push_back(v);
    }

    vector<vector<int>> gg(matching.size());
    set<int> ends;

    for (int value = 0; value < cnt; value++) {
        if (where[value].size() == 1) {
            ends.insert(where[value][0]);
        } else if (where[value].size() == 2) {
            gg[where[value][0]].push_back(where[value][1]);
            gg[where[value][1]].push_back(where[value][0]);
        }
    }

    vector<char> was(matching.size(), false);
    vector<pair<int, int>> ans;

    // cout << "Hello 1" << endl;

    for (auto root : ends) {
        if (!was[root]) {
            vector<int> bamboo;
            std::function<void(int)> dfs;
            dfs = [&](int v) {
                was[v] = true;
                bamboo.push_back(v);

                for (int u : gg[v]) {
                    if (!was[u]) {
                        dfs(u);
                    }
                }
            };

            dfs(root);

            for (int i = 0; i + 1 < bamboo.size(); i++) {
                int ugg = bamboo[i];
                int vgg = bamboo[i + 1];

                auto [ug1, ug2] = matching[ugg];
                auto [vg1, vg2] = matching[vgg];

                int& p = a[ug1];
                int& q = a[ug2];

                int& x = a[vg1];
                int& y = a[vg2];

                if (p == x) {
                    // swap(q, x);
                    ans.push_back({vg1, ug2});
                    del.insert(vg1);
                    del.insert(ug2);
                } else if (p == y) {
                    // swap(q, y);
                    ans.push_back({ug2, vg2});
                    del.insert(vg2);
                    del.insert(ug2);
                } else if (q == x) {
                    // swap(p, x);
                    ans.push_back({ug1, vg1});
                    del.insert(ug1);
                    del.insert(vg1);
                } else if (q == y) {
                    // swap(p, y);
                    ans.push_back({ug1, vg2});
                    del.insert(ug1);
                    del.insert(vg2);
                } else {
                    // assert(false);
                }
            }

            int last = bamboo.back();
            int vl = matching[last].first;
            int vr = matching[last].second;

            if (del.count(vl) == 0) {
                del.insert(vl);
                int x = a[vr];

                for (int w : lol[x]) {
                    if (w != vr) {
                        ans.push_back({w, vl});
                    }
                }
            } else {
                del.insert(vr);

                int x = a[vl];

                for (int w : lol[x]) {
                    if (w != vl) {
                        ans.push_back({w, vr});
                    }
                }
            }
        }
    }

    // cout << "Hello 2" << endl;

    for (int v = 0; v < matching.size(); v++) {
        if (!was[v]) {
            // cout << "v = " << v << endl;
            vector<int> cycle;
            std::function<void(int)> dfs;
            dfs = [&](int v) {
                was[v] = true;
                cycle.push_back(v);

                for (int u : gg[v]) {
                    if (!was[u]) {
                        dfs(u);
                    }
                }
            };

            dfs(v);

            // cout << v << ' ' << cycle.size() << endl;

            while (cycle.size() > 1) {
                int ugg = cycle[cycle.size() - 1];
                int vgg = cycle[cycle.size() - 2];
                auto [ug1, ug2] = matching[ugg];
                auto [vg1, vg2] = matching[vgg];
                int& p = a[ug1];
                int& q = a[ug2];

                int& x = a[vg1];
                int& y = a[vg2];

                if (p == x && del.count(vg1) == 0 && del.count(ug2) == 0) {
                    // swap(q, x);
                    ans.push_back({vg1, ug2});
                    del.insert(vg1);
                    del.insert(ug2);
                } else if (p == y && del.count(ug2) == 0 && del.count(vg2) == 0) {
                    // swap(q, y);
                    ans.push_back({ug2, vg2});
                    del.insert(vg2);
                    del.insert(ug2);
                } else if (q == x && del.count(ug1) == 0 && del.count(vg1) == 0) {
                    // swap(p, x);
                    ans.push_back({ug1, vg1});
                    del.insert(ug1);
                    del.insert(vg1);
                } else if (q == y && del.count(ug1) == 0 && del.count(vg2) == 0) {
                    // swap(p, y);
                    ans.push_back({ug1, vg2});
                    del.insert(ug1);
                    del.insert(vg2);
                } else {
                    // assert(false);
                }

                cycle.pop_back();
            }

            // cout << v << ' ' << cycle.size() << endl;
        }

        // cout << v << endl;
    }

    // cout << "================" << endl;

    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }

    // cout << "================" << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // freopen("input.txt", "r", stdin);

    int t = 1; 
    cin >> t;

    while (t--) {
        solve();
    }
}
