#include <bits/stdc++.h>

using namespace std;

string add(const string& a, const string& b) {
    string result;
    for (size_t i = 0, carry = 0; i < a.size() || i < b.size() || carry; ++i) {
        int digit = carry;
        if (i < a.size()) {
            digit += a[i] - '0';
        }
        if (i < b.size()) {
            digit += b[i] - '0';
        }
        if (digit >= 10) {
            carry = 1;
            digit -= 10;
        } else {
            carry = 0;
        }
        result.push_back(digit + '0');
    }
    return result;
}

string sub(const string& a, const string& b) {
    string result;
    int carry = 0;
    for (size_t i = 0; i < a.size() || i < b.size(); ++i) {
        int digit = carry;
        if (i < a.size()) {
            digit += a[i] - '0';
        }
        if (i < b.size()) {
            digit -= b[i] - '0';
        }
        if (digit < 0) {
            carry = -1;
            digit += 10;
        } else {
            carry = 0;
        }
        result.push_back(digit + '0');
    }
    if (carry < 0) {
        return "x";
    }
    return result;
}

bool check(const string& input) {
    vector<string> numbers;
    vector<bool> signs;
    bool past_eq = false;
    string cur_num;
    bool good = true;
    auto flush = [&]() {
        if (cur_num.size() > 10) {
            good = false;
            return;
        }
        if (cur_num.empty()) {
            good = false;
            return;
        }
        if (cur_num.at(0) == '0' && cur_num.size() > 1) {
            good = false;
        }
        reverse(cur_num.begin(), cur_num.end());
        numbers.push_back(cur_num);
        cur_num.clear();
    };
    for (auto ch : input) {
        if (isdigit(ch)) {
            cur_num.push_back(ch);
        } else {
            flush();
            if (ch == '=') {
                past_eq = true;
                signs.push_back(false);  // false is -
            } else if (ch == '-') {
                signs.push_back(past_eq);
            } else if (ch == '+') {
                signs.push_back(!past_eq);
            } else {
                assert(false);
            }
        }
    }
    flush();
    if (!good) {
        return false;
    }
    string cur = numbers.at(0);
    for (size_t i = 0; i < signs.size(); ++i) {
        if (signs[i]) {
            cur = add(cur, numbers.at(i + 1));
        }
    }
    for (size_t i = 0; i < signs.size(); ++i) {
        if (!signs[i]) {
            cur = sub(cur, numbers.at(i + 1));
            if (cur == "x") {
                return false;
            }
        }
    }
    for (auto ch : cur) {
        if (ch != '0') {
            return false;
        }
    }
    return true;
}

void solve() {
    string input;
    cin >> input;
    if (check(input)) {
        cout << "Correct" << endl;
        return;
    }
    for (size_t init_pos = 0; init_pos < input.size(); ++init_pos) {
        if (!isdigit(input[init_pos])) {
            continue;
        }
        for (size_t new_pos = 0; new_pos < input.size(); ++new_pos) {
            string new_input;
            for (size_t i = 0; i < input.size(); ++i) {
                if (init_pos < new_pos) {
                    if (i < init_pos) {
                        new_input.push_back(input[i]);
                    } else if (i < new_pos) {
                        new_input.push_back(input[i + 1]);
                    } else if (i == new_pos) {
                        new_input.push_back(input[init_pos]);
                    } else {
                        new_input.push_back(input[i]);
                    }
                } else {
                    if (i < new_pos) {
                        new_input.push_back(input[i]);
                    } else if (i == new_pos) {
                        new_input.push_back(input[init_pos]);
                    } else if (i <= init_pos) {
                        new_input.push_back(input[i - 1]);
                    } else {
                        new_input.push_back(input[i]);
                    }
                }
            }
            if (check(new_input)) {
                cout << new_input << endl;
                return;
            }
        }
    }
    cout << "Impossible" << endl;
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input", "r", stdin);
    freopen("../output", "w", stdout);
    cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
//    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}