
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;
void panic() {
	cout << "-1\n";
	exit(0);
}

vector<int>ord2;
bool MT2 = false;
vector<int>col;
void dfs(int v, const vector<vector<int>>& g, vector<int>& ord,
	vector<int>&used) {
	used[v] = 1;
	for (auto x : g[v]) {
		if (used[x] == 1) {
			panic();
		}
		if (used[x] == 2) {
			continue;
		}
		dfs(x, g, ord, used);
	}
	used[v] = 2;
	if (MT2 && col[v] == 0) {
		ord2.push_back(v);
	}
	else {
		ord.push_back(v);
	}
}
void solve() {
	int n;
	cin >> n;
	vector<vector<int>>g(n), idxes(4);
	//vector<int>idxes(4);
	col.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		string s1, s2;
		cin >> s1 >> s2;
		if (s1 == "set") {
			if (s2 == "true") {
				idxes[3].push_back(i);
				col[i] = 3;
			}
			else {
				col[i] = 2;
				idxes[2].push_back(i);
			}
		}
		else {
			if (s2 == "true") {
				col[i] = 1;
				idxes[1].push_back(i);
			}
			else {
				col[i] = 0;
				idxes[0].push_back(i);
			}
		}
	}
	assert(idxes[1].size() <= 1 && idxes[3].size() <= 1);
	if (idxes[0].size() != n && idxes[3].empty()) {
		panic();
	}
	for (auto x : idxes[3]) {
		for (auto y : idxes[1]) {
			g[x].push_back(y);
		}
	}
	for (auto x : idxes[3]) {
		for (auto y : idxes[2]) {
			g[x].push_back(y);
		}
	}
	for (auto x : idxes[2]) {
		for (auto y : idxes[1]) {
			g[x].push_back(y);
		}
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
	}
	for (auto v : idxes[0]) {
		bool need_edge = false;
		for (auto neib : g[v]) {
			if (col[neib]) {
				need_edge = true;
				
			}
		}
		if (!need_edge) {
			continue;
		}
		if (idxes[3].empty()) {
			panic();
		}
		g[v].push_back(idxes[3][0]);
	}
	vector<int>order;
	vector<int>used(n);
	MT2 = true;
	for (auto x : idxes[3]) {
		if (!used[x]) {
			dfs(x, g, order, used);
		}
	}
	MT2 = false;
	for (auto x : idxes[0]) {
		if (!used[x]) {
			dfs(x, g, order, used);
		}
	}
	if (!ord2.empty() && !idxes[3].empty() && idxes[1].empty()) {
		panic();
	}
	reverse(order.begin(), order.end());
	reverse(ord2.begin(), ord2.end());
	for (auto x : order)cout << x + 1 << " ";
	for (auto x : ord2)cout << x + 1 << " ";
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
