import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputReader in = new InputReader(System.in);
        PrintWriter out = new PrintWriter(System.out);
        solve(in, out);
        out.close();
    }

    public static class Pair {
        int a;
        int b;

        public Pair(int a, int b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Pair pair = (Pair) o;
            return a == pair.a && b == pair.b;
        }

        @Override
        public int hashCode() {
            return Objects.hash(a, b);
        }
    }

    public static void solve(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int[] arr = new int[n];

        for (int i = 0; i < n; i++) {
            arr[i] = in.nextInt();
        }

        HashSet<Pair> set = new HashSet<>();
        long ans = 0;

        Stack<String> stack = new Stack<>();

        while (true) {
            int colInter = 0;
            for (int i = 0; i < n-1; i++) {
                int a = arr[i];
                int b = arr[i+1];

                if (a < b && !set.contains(new Pair(a,b)) && !set.contains(new Pair(b,a))) {
                    ans += 2;
                    stack.add(a + " " + b);
                    stack.add(b + " " + a);
                    set.add(new Pair(a,b));
                    set.add(new Pair(b,a));
                    break;
                } else if (a > b && !set.contains(new Pair(a,b))) {
                    ans += 1;
                    arr[i] = b;
                    arr[i+1] = a;
                    stack.add(a + " " + b);
                    set.add(new Pair(a,b));
                    break;
                } else {
                    colInter = i;
                }
            }
            if (colInter == n-2) {
                break;
            }
        }

        out.println(ans);

        while (!stack.isEmpty()) {
            out.println(stack.pop());
        }

    }

    public static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;


        public InputReader(InputStream stream) {
            this.reader = new BufferedReader(new InputStreamReader(stream), 32768);
            this.tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw  new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
}