#include <bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

void dfs(int v, vector<vector<int>>& g, unordered_set<int>& used, unordered_set<int>& arr, vector<int>& order) {
    for(int to : g[v]) {
        if(arr.count(to) && !used.count(to)) {
            used.insert(to);
            dfs(to, g, used, arr, order);
        }
    }
    order.push_back(v);
}

vector<int> topsort(vector<int>& v, vector<vector<int>>& g) {
    unordered_set<int> used, arr;
    for(int i : v) arr.insert(i);
    vector<int> order;
    order.reserve(v.size());
    for(int i : v) {
        if(!used.count(i)) {
            used.insert(i);
            dfs(i, g, used, arr, order);
        }
    }
    reverse(all(order));
    return order;
}

bool check(int n, vector<int>& v, vector<vector<int>>& g) {
    vector<int> pos(n + 1, -1);
    for(int i = 0; i < v.size(); i++) pos[v[i]] = i;
    for(int i = 1; i <= n; i++) {
        for(int to : g[i]) {
            if(pos[i] > pos[to]) return 0;
        }
    }
    return 1;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<vector<int>>> a(2, vector<vector<int>>(2));
    for(int i = 1; i <= n; i++) {
        string s, t;
        cin >> s >> t;
        a[(s == "set" ? 1 : 0)][(t == "true" ? 1 : 0)].push_back(i);
    }
    int m;
    cin >> m;
    vector<vector<int>> g(n + 1);
    while(m--) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
    }
    if(a[1][1].size() == 0 && a[0][1].size() == 0) {
        if(!a[1][0].empty()) {
            cout << -1;
            return;
        }
        vector<int> v = topsort(a[0][0], g);
        for(int i : v) cout << i << ' ';
        return;
    }
    if(a[1][1].size() == 1 && a[0][1].size() == 0) {
        vector<int> v = topsort(a[0][0], g);
        v.push_back(a[1][1][0]);
        for(int i : topsort(a[1][0], g)) v.push_back(i);
        if(check(n, v, g)) {
            for(int i : v) cout << i << ' ';
        } else cout << -1;
        return;
    }
    if(a[1][1].size() == 1 && a[0][1].size() == 1) {
        queue<int> q;
        vector<bool> used(n + 1, 0);
        used[a[1][1][0]] = 1;
        q.push(a[1][1][0]);
        for(int v : a[1][0]) {
            used[v] = 1;
            q.push(v);
        }
        used[a[0][1][0]] = 1;
        q.push(a[0][1][0]);
        while(!q.empty()) {
            int v = q.front();
            q.pop();
            for(int to : g[v]) {
                if(!used[to]) {
                    used[to] = 1;
                    q.push(to);
                }
            }
        }
        vector<int> left, right;
        for(int v : a[0][0]) {
            if(used[v]) {
                right.push_back(v);
            } else {
                left.push_back(v);
            }
        }
        left = topsort(left, g);
        right = topsort(right, g);
        left.push_back(a[1][1][0]);
        for(int v : topsort(a[1][0], g)) left.push_back(v);
        left.push_back(a[0][1][0]);
        for(int v : right) left.push_back(v);
        if(check(n, left, g)) {
            for(int v : left) cout << v << ' ';
        } else cout << -1;
        return;
    }
    cout << -1;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--) solve();
    return 0;
}