#include <bits/stdc++.h>

#define ll long long
#define int long long

using namespace std;

const vector<pair<int, int>> moves = {
	{1, 0},
	{1, 1},
	{0, 1},
	{-1, 1},
	{-1, 0},
	{-1, -1},
	{0, -1},
	{1, -1}
};

int n;
vector<pair<string, int>> operations;

multiset<multiset<pair<ll, ll>>> draw(int alpha) {
	ll x = 0, y = 0;
	vector<multiset<pair<ll, ll>>> res;
	ll min_x = INT64_MAX;
	ll min_y = INT64_MAX;
	for (auto [type, d] : operations) {
		if (type == "rotate") {
			alpha = (alpha + d) % 8;
		} else {
			auto [dx, dy] = moves[alpha];
			ll x2 = x + d * dx;
			ll y2 = y + d * dy;
			multiset<pair<ll, ll>> st = multiset<pair<ll, ll>>{
				{x, y},
				{x2, y2}
			};
			if (type == "move") {
				x = x2;
				y = y2;
			} else {
				res.push_back(st);
				min_x = min({min_x, x, x2});
				min_y = min({min_y, y, y2});
				x = x2;
				y = y2;
			}
		}
	}
	multiset<multiset<pair<ll, ll>>> ans;
	// cerr << "ans:\n";
	for (const multiset<pair<ll, ll>> &st : res) {
		multiset<pair<ll, ll>> cur;
		for (auto p : st) {
			pair<ll, ll> new_p = {p.first - min_x, p.second - min_y};
			cur.insert(new_p);
			// cerr << new_p.first << " " << new_p.second << "\n";
		}
		// cerr << "----\n";
		ans.insert(cur);
	}
	return ans;
}

void solve() {
	cin >> n;
	operations.resize(n);
	for (auto &[name, d] : operations) {
		cin >> name >> d;
		if (name == "rotate")
			d /= 45;
	}
	auto init = draw(0);
	for (int i = 1; i < 8; i++) {
		auto cur = draw(i);
		if (cur == init) {
			cout << i * 45 << "\n";
			return;
		}
	}
	cout << "360\n";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef dimss
	freopen("test.txt", "r", stdin);
#endif

	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
	}
	return 0;
}