#include <bits/stdc++.h>

#define ll long long
#define int long long

using namespace std;


struct rational {
    ll a = 0, b = 0;

    rational() = default;
    rational(ll _a, ll _b) : a(_a), b(_b) {}

    friend bool operator<(const rational& lhs, const rational& other) {
        ll a = lhs.a;
        ll b = lhs.b;
        ll c = other.a;
        ll d = other.b;

        //a + b*sqrt(2) < c + d*sqrt(2)
        //(a - c) < sqrt(2) * (d - b)
        if ((a - c) >= 0 && (d - b) <= 0) {
            return false;
        }
        if ((a - c) >= 0 && (d - b) >= 0) {
            return (__int128)(a - c) * (a - c) < 2 * (__int128)(d - b) * (d - b);
        }
        if ((a - c) <= 0 && (d - b) >= 0) {
            if ((a - c) == 0 && (d - b) == 0) {
                return false;
            }
            return true;
        }
        assert((a - c) <= 0 && (d - b) <= 0);
        return (a - c) * (a - c) > 2 * (__int128)(d - b) * (d - b);
    }

    friend bool operator==(const rational& left, const rational& right) {
        return left.a == right.a && left.b == right.b;
    }

    friend rational operator+(const rational& left, const rational& right) {
        return rational{left.a + right.a, left.b + right.b};
    }


    friend rational operator-(const rational& left, const rational& right) {
        return rational{left.a - right.a, left.b - right.b};
    }

    rational operator*(const ll& d) {
        return rational{a * d, b * d};
    }
};


const vector<pair<rational, rational>> moves = {
        {rational{2, 0}, rational{}},
        {rational{0, 1}, rational{0, 1}},
        {rational{}, rational{2, 0}},
        {rational{0, -1}, rational{0, 1}},
        {rational{-2, 0}, rational{}},
        {rational{0, -1}, rational{0, -1}},
        {rational{}, rational{-2, 0}},
        {rational{0, 1}, rational{0, -1}}
};


// rational my_min(const rational& left, const rational& right) {
// 	return left < right ? left : right;
// }

void ckmin(rational& cur, const rational& rhs) {
    cur = (cur < rhs ? cur : rhs);
}

int n;
vector<pair<string, int>> operations;

multiset<multiset<pair<rational, rational>>> draw(int alpha) {
    rational x{}, y{};
    vector<multiset<pair<rational, rational>>> res;
    rational min_x{INT64_MAX, 0};
    rational min_y{INT64_MAX, 0};
    for (auto [type, d] : operations) {
        if (type == "rotate") {
            alpha = (alpha + d) % 8;
        } else {
            auto [dx, dy] = moves[alpha];
            auto x2 = x + dx * d;
            auto y2 = y + dy * d;
            multiset<pair<rational, rational>> st = multiset<pair<rational, rational>>{
                    {x, y},
                    {x2, y2}
            };
            if (type == "move") {
                x = x2;
                y = y2;
            } else {
                res.push_back(st);
                ckmin(min_x, x);
                ckmin(min_x, x2);
                // min_x = my_min({min_x, x, x2});
                ckmin(min_y, y);
                ckmin(min_y, y2);
                // min_y = my_min({min_y, y, y2});
                x = x2;
                y = y2;
            }
        }
    }
    multiset<multiset<pair<rational, rational>>> ans;
    // cerr << "ans:\n";
    for (const multiset<pair<rational, rational>> &st : res) {
        multiset<pair<rational, rational>> cur;
        for (auto p : st) {
            pair<rational, rational> new_p = {p.first - min_x, p.second - min_y};
            cur.insert(new_p);
            // cerr << new_p.first << " " << new_p.second << "\n";
        }
        // cerr << "----\n";
        ans.insert(cur);
    }
    return ans;
}

void solve() {
    cin >> n;
    operations.resize(n);
    for (auto &[name, d] : operations) {
        cin >> name >> d;
        if (name == "rotate")
            d /= 45;
    }
    auto init = draw(0);
    for (int i = 1; i < 8; i++) {
        auto cur = draw(i);
        if (cur == init) {
            cout << i * 45 << "\n";
            return;
        }
    }
    cout << "360\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef dimss
    freopen("test.txt", "r", stdin);
#endif

    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}