#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

struct drop {
    int x, y;

    drop(int a = 0, int b = 1) {
        x = a;
        y = b;
        int d = gcd(abs(x), abs(y));
        x /= d;
        y /= d;
    }

    drop operator+(drop a) {
        return drop(x * a.y + a.x * y, y * a.y);
    }

    drop operator-(drop a) {
        return drop(x * a.y - a.x * y, y * a.y);
    }

    drop operator*(drop a) {
        return drop(x * a.x, y * a.y);
    }

    bool operator==(drop a) {
        return (x == a.x && y == a.y);
    }

    bool operator<(drop a) {
        return (x * a.y < a.x * y);
    }
};

struct rac {
    drop x, y;

    rac(drop a = drop(0), drop b = drop(0)) {
        x = a;
        y = b;
    }

    rac operator+(rac a) {
        return rac(x + a.x, y + a.y);
    }

    rac operator-(rac a) {
        return rac(x - a.x, y - a.y);
    }

    rac operator*(int k) {
        return rac(x * k, y * k);
    }

    bool operator==(rac a) {
        return (x == a.x && y == a.y);
    }
};

bool operator<(rac a, rac b) {
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

struct vec {
    rac x, y;

    vec (rac a = rac(0), rac b = rac(0)) {
        x = a;
        y = b;
    }

    vec operator+(vec a) {
        return vec(x + a.x, y + a.y);
    }

    vec operator-(vec a) {
        return vec(x - a.x, y - a.y);
    }

    vec operator*(double k) {
        return vec(x * k, y * k);
    }

    vec norm() {
        return vec(y * -1, x);
    }

    vec deg45() {
        vec v(x, y);
        v = v + (v.norm());
        swap(v.x.x, v.x.y);
        v.x.y = v.x.y * drop(1, 2);
        swap(v.y.x, v.y.y);
        v.y.y = v.y.y * drop(1, 2);
        return v;
    }

    bool operator==(vec a) {
        return (x == a.x && y == a.y);
    }
};

bool operator<(vec a, vec b) {
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

bool operator<(pair<vec, vec> a, pair<vec ,vec> b) {
    if (a.first == b.first) {
        return a.second < b.second;
    }
    return a.first < b.first;
}

bool check(vector<pair<vec, vec>> a, vector<pair<vec, vec>> b) {
    if (a.size() != b.size()) return 0;
    //cout << "JUKUL\n";
    vec mi = a[0].first;
    for (int i = 0; i < a.size(); i++) {
        if (a[i].second < a[i].first) {
            swap(a[i].first, a[i].second);
        }
        if (a[i].first < mi) {
            mi = a[i].first;
        }
    }
    //cout << "START\n";
    //mi.print();
    for (int i = 0; i < a.size(); i++) {
        a[i].first = a[i].first - mi;
        a[i].second = a[i].second - mi;
    }
    sort(a.begin(), a.end());
    /*for (int i = 0; i < a.size(); i++) {
        a[i].first.print();
        a[i].second.print();
        b[i].first.print();
        b[i].second.print();
        cout << "HUI\n";
    }*/
    vector<bool> used(b.size(), 1);
    for (int i = 0; i < a.size(); i++) {
        bool fl = 1;
        for (int j = 0; j < b.size(); j++) {
            if (used[j] && a[i].first == b[j].first && a[i].second == b[j].second) {
                used[j] = 0;
                fl = 0;
                break;
            }
        }
        if (fl) return 0;
    }
    return 1;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<char, double>> a(n);
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        int k;
        cin >> k;
        a[i] = {t[0], k};
    }
    vector<set<pair<vec, vec>>> ass(4);
    vec v(rac(1), rac(0));
    int t = 0;
    vec p(rac(0), rac(0));
    for (int i = 0; i < n; i++) {
        if (a[i].first == 'r') {
            for (int j = 0; j < a[i].second / 45; j++) {
                t++;
                v = v.deg45();
            }
        } else if (a[i].first == 'm') {
            p = p + (v * a[i].second);
        } else {
            vec np = p + (v * a[i].second);
            ass[t % 4].insert({min(p, np), (p + np) - min(p, np)});
            p = np;
        }
    }
    vector<pair<vec, vec>> b, bb;
    for (int i = 0; i < 4; i++) {
        for (auto j : ass[i]) {
            bool f = 1;
            for (int o = 0; o < bb.size(); o++) {
                if (bb[o].second == j.first) {
                    bb[o].second = j.second;
                    f = 0;
                    break;
                }
            }
            if (f) {
                bb.push_back(j);
            }
        }
        for (auto j : bb) b.push_back(j);
        bb.clear();
    }
    vec mi = b[0].first;
    vector<pair<vec, vec>> c(b.size());
    for (int i = 0; i < b.size(); i++) {
        c[i] = b[i];
        if (b[i].first < mi) {
            mi = b[i].first;
        }
    }
    for (int i = 0; i < b.size(); i++) {
        b[i].first = b[i].first - mi;
        b[i].second = b[i].second - mi;
    }
    /*for (int i = 0; i  <b.size(); i++) {
        b[i].first.print();
        b[i].second.print();
        cout << "HUIn\n";
    }*/
    for (int i = 1; i < 10; i++) {
        for (int j = 0; j < c.size(); j++) {
            c[j].first = c[j].first.deg45();
            c[j].second = c[j].second.deg45();
        }
        if (check(c, b)) {
            cout << 45 * i;
            return;
        }
    }
    assert(0);
}

signed main() {
    //ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t --> 0) {
        solve();
    }
    return 0;
}
/*
13
r 45
d 10
r 180
m 10
d 10 r 180
m 10
r 90
d 10
r 180
m 20
r 180
draw 10
 */