#include <bits/stdc++.h>
using namespace std;

const bool SET = true;
const bool UNSET = false;

const int N = 1e5+7;

#define F first
#define S second
#define pb push_back

int n;
int unsetTrueI = -1;
int setTrueI = -1;
vector<pair<bool, bool>> ops; // set/unset, T/F
set<int> g[N];
set<int> gR[N];
bool connected[N] {};
int groups[N];

bool is(const pair<bool, bool> &op, bool type, bool result) {
    return op.F == type && op.S == result;
}

void no_ans(const string &comment) {
    #ifdef LOCAL
    cerr << comment << endl;
    #endif // LOCAL
    cout << -1 << endl;
    exit(0);
}

void connect(int a, int b) {
    g[a].insert(b);
    gR[b].insert(a);
    connected[a] = true;
    connected[b] = true;
}

void dfs(int i, bool visited[], vector<int>& order) {
    visited[i] = true;
    for (int j : g[i]) {
        if (groups[j] == groups[i] && !visited[j]) {
            dfs(j, visited, order);
        }
    }
    order.push_back(i);
}

vector<int> toposort_group(int group) {
    vector<int> order;
    bool visited[N] {};
    for (int i = 0; i < n; ++i) {
        if (!visited[i] && groups[i] == group) {
            dfs(i, visited, order);
        }
    }
    reverse(order.begin(), order.end());
    return order;
}

void colorUnsetFalse(int v, set<int> g[]) {
    for (auto to : g[v]) {
        if (is(ops[to], UNSET, false) && !groups[to]) {
            groups[to] = groups[v];
            colorUnsetFalse(v, g);
        }
    }
}

void validate(vector<int> &v) {
    map<int, int> mp;
    for (int i = 0; i < v.size(); ++i)
        mp[v[i]] = i;
    if (mp.size() != n) {
        no_ans("size mismatch");
    }
    for (int i = 0; i < n; ++i) {
        for (auto to : g[i]) {
            if (mp[i] >= mp[to]) {
                no_ans("constraints violation");
            }
        }
    }
    bool reg = 0;
    for (auto to : v) {
        bool expectResult;
        if (ops[to].F == SET) {
            expectResult = reg == false;
        } else {
            expectResult = reg == true;
        }
        if (ops[to].S != expectResult) {
            no_ans("unexpected result");
        }
        if (expectResult) reg = !reg;
    }
}

vector<int> noTrues() {
    for (auto op : ops) {
        if (op.F == SET) {
            no_ans("set false found");
        }
    }
    return toposort_group(0);
}

vector<int> oneTrue() {
    for (int i = 0; i < n; ++i) {
        if (is(ops[i], UNSET, true)) {
            no_ans("unset true found");
        }
        if (is(ops[i], SET, true)) {
            setTrueI = i;
        }
        if (is(ops[i], UNSET, false)) {
            groups[i] = 1;
        }
        if (is(ops[i], SET, false)) {
            groups[i] = 2;
        }
    }
    if (setTrueI == -1) {
        no_ans("no set true");
    }
    vector<int> ans;
    for (auto to : toposort_group(1))
        ans.pb(to);
    ans.pb(setTrueI);
    for (auto to : toposort_group(2))
        ans.pb(to);
    return ans;
}

vector<int> twoTrues() {
    for (int i = 0; i < n; ++i) {
        if (is(ops[i], UNSET, true)) {
            unsetTrueI = i;
        }
        if (is(ops[i], SET, true)) {
            setTrueI = i;
        }
        if (is(ops[i], SET, false)) {
            groups[i] = 2;
        }
    }
    if (unsetTrueI == -1 || setTrueI == -1) {
        no_ans("unset true or set true not found");
    }
    // iteration 1
    for (int i = 0; i < n; ++i) {
        for (auto to : g[i]) {
            if (is(ops[i], UNSET, false) && !is(ops[to], UNSET, false)) {
                if (groups[i] == 3) no_ans("groups violation 3->1");
                groups[i] = 1;
            }
            if (is(ops[to], UNSET, false) && !is(ops[i], UNSET, false)) {
                if (groups[to] == 1) no_ans("groups violation 1->3");
                groups[to] = 3;
            }
        }
    }
    // iteration 2
    for (int i = 0; i < n; ++i) {
        if (groups[i] == 1) colorUnsetFalse(i, gR);
        if (groups[i] == 3) colorUnsetFalse(i, g);
    }
    // iteration 3
    for (int i = 0; i < n; ++i) {
        if (groups[i] == 1) colorUnsetFalse(i, g);
        if (groups[i] == 3) colorUnsetFalse(i, gR);
    }
    for (int i = 0; i < n; ++i) {
        if (is(ops[i], UNSET, false) && !connected[i]) {
            groups[i] = 1;
        }
    }
    vector<int> ans;
    for (auto to : toposort_group(1)) {
        ans.pb(to);
    }
    ans.pb(setTrueI);
    for (auto to : toposort_group(2)) {
        ans.pb(to);
    }
    ans.pb(unsetTrueI);
    for (auto to : toposort_group(3)) {
        ans.pb(to);
    }
    while (ans.size() != n);
    return ans;
}

void solve() {
    cin >> n;
    string token;
    int trues = 0;
    for (int i = 0; i < n; ++i) {
        cin >> token;
        bool op = token == "set" ? SET : UNSET;
        cin >> token;
        bool result = token == "true";
        ops.pb({op, result});
        trues += result;
    }
    int m, a, b;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        connect(--a, --b);
    }
    vector<int> ans;
    #ifdef LOCAL
    cerr << trues << endl;
    #endif // LOCAL
    switch (trues) {
case 0:
    ans = noTrues();
    break;
case 1:
    ans = oneTrue();
    break;
case 2:
    ans = twoTrues();
    break;
    }
    validate(ans);
    for (auto to : ans)
        cout << to+1 << " ";
    cout << endl;
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #endif // LOCAL
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
