#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
map<ll, set<ll>> mp;
vector<pair<ll,ll>> ans;
vector<ll> vc;

#define int long long

const int INF = 1e16;

vector<vector<int>> graph, graph2;

void add(int v, int u) {
    graph[v].push_back(u);
    graph2[u].push_back(v);
}

vector<int> outs;
vector<bool> used;
vector<int> colors;

void dfs(int v) {
    used[v] = true;
    for (auto u: graph[v]) {
        if (used[u]) continue;
        dfs(u);
    }
    outs.push_back(v);
}

void dfs2(int v, int c) {
    colors[v] = c;
    for (auto u: graph2[v]) {
        if (colors[u] != -1) continue;
        dfs2(u, c);
    }
}

void solve() {
    int n; cin >> n;
    vector<int> arr(n);
    int trues = 0;
    for (auto& i: arr) {
        string tp, res; cin >> tp >> res;
        if (tp == "set" && res == "false") {
            i = 0;
        } else if (tp == "set" && res == "true") {
            i = 1;
            ++trues;
        } else if (res == "false") {
            i = 2;
        } else {
            i = 3;
            ++trues;
        }
    }
/*
    for (auto i: arr) {
        cout << i << " ";
    }
    cout << endl;*/
    int m; cin >> m;
    graph.assign(n, {});
    graph2 = graph;
    for (int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b; --a; --b;
        add(a, b);
    }

    if (trues == 0) {
        if (count(all(arr), 2) != n) {
            cout << "-1\n";
            return;
        }
    } else if (trues == 1) {
        if (count(all(arr), 1) != 1) {
            cout << "-1\n";
            return;
        }
        int idx = find(all(arr), 1) - arr.begin();
        for (int i = 0; i < n; ++i) {
            if (i == idx) continue;
            if (arr[i] == 2) {
                add(i, idx);
            } else {
                add(idx, i);
            }
        }
    } else {
        if (count(all(arr), 1) != 1) {
            cout << "-1\n";
            return;
        }
        int st = find(all(arr), 1) - arr.begin();
        int ut = find(all(arr), 3) - arr.begin();
        add(st, ut);
        set<int> sfs;
        for (int i = 0; i < n; ++i) {
            if (i == st || i == ut) continue;
            if (arr[i] == 0) {
                add(i, ut);
                add(st, i);
                sfs.insert(i);
            }
        }
        for (int v = 0; v < n; ++v) {
            if (arr[v] != 2) continue;
            for (auto u: graph[v]) {
                if (arr[u] != 2) {
                    add(v, st);
                    add(v, ut);
                    break;
                }
            }
            for (auto u: graph2[v]) {
                if (arr[u] != 2) {
                    add(st, v);
                    add(ut, v);
                    break;
                }
            }
        }
    }

    used.assign(n, false);
    for (int v = 0; v < n; ++v) {
        if (used[v]) continue;
        dfs(v);
    }
    reverse(all(outs));

    colors.assign(n, -1);
    int nxt = 0;
    for (auto v: outs) {
        if (colors[v] != -1) continue;
        dfs2(v, nxt);
        ++nxt;
    }

    if (nxt != n) {
        cout << "-1\n";
        return;
    }

    int x = -1, y = -1;
    vector<int> left, mid, right;
    for (int i = 0; i < n; ++i) {
        int v = outs[i];
        if (arr[v] == 1) {
            x = i;
            mid.push_back(v);
        } else if (arr[v] == 3) {
            y = i;
            mid.push_back(v);
        } else if (arr[v] == 0) {
            mid.push_back(v);
        } else {
            if (y == -1) {
                left.push_back(v);
            } else {
                right.push_back(v);
            }
        }
    }
    outs.clear();
    for (auto v: left) {
        outs.push_back(v);
    }
    for (auto v: mid) {
        outs.push_back(v);
    }
    for (auto v: right) {
        outs.push_back(v);
    }

    for (auto i: outs) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}


signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    // rifstream cin("../test.txt");

    int test_cnt = 1;
    // cin >> test_cnt;

    while (test_cnt--) {
        solve();
    }
}