#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <string>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'


struct instruction {
	int a = 0, b = 0, c = 0, d = 0;
};

struct program {
	int index;
	int size;
	int next0, next1;
	vector<instruction> inst;
};

int get_bit(int index, int bit) {
	return index * 16 + bit;
}

int get_word_index(int ip, int ind, int z) {
	return (ip + ind) * 4 + z;
}

string h = "0123456789abcdef";
void output(int n) {
	string s;
	while (n || s.size() != 4) {
		s += h[n % 16];
		n /= 16;
	}
	reverse(all(s));
	cout << s << ' ';
}

void output(instruction inst) {
	output(inst.a);
	output(inst.b);
	output(inst.c);
	output(inst.d);
}


void solve()
{
	int x; cin >> x;
	int io = (1 << 12) - 1;

	program main;
	program var;
	program setter0;
	program setter1;
	program temp;
	vector<program> checkers(16);

	//ADRESSES and SIZES;
	//MAIN
	int last = 0;
	main.index = last;
	main.size = 1;
	last += main.size * 4;

	//VAR
	var.index = last;
	var.size = 1;
	last += var.size * 4;
	

	//SETTER 0
	setter0.index = last;
	setter0.size = 16;
	last += setter0.size * 4;

	//SETTER 1
	setter1.index = last;
	setter1.size = 16;
	last += setter1.size * 4;

	//TEMP
	int zlast = last;
	last = (last + 32 - 1) / 32 * 32 ;
	
	temp.index = zlast;
	temp.size = last - zlast;
	temp.inst.resize(temp.size);

	//CHECKER
	forn(i, 16) {
		checkers[i].index = last;
		checkers[i].size = 8;
		last += checkers[i].size * 4;
	}

	main.next1 = checkers[0].index;
	setter0.next1 = (1 << 12);
	setter1.next1 = (1 << 12);

	forn(i, 16)
		checkers[i].next0 = setter0.index;
	forn(i, 15)
		checkers[i].next1 = checkers[i + 1].index;
	checkers[15].next1 = setter1.index;


	// LOGIC
	//MAIN
	main.inst.resize(main.size);
	main.inst[0] = { 0, 0, main.next1 };

	//VAR
	var.inst.resize(var.size);
	var.inst[0] = { x, 1, 0 };

	//SETTER 0
	setter0.inst.resize(setter0.size);
	int ind = setter0.index;
	forn(i, setter0.size){
		ind += 4;
		setter0.inst[i] = { 0, get_bit(io, i), ind };
	}
	setter0.inst.back().c = setter0.next1;

	//SETTER 1
	setter1.inst.resize(setter1.size);
	ind = setter1.index;
	forn(i, setter1.size) {
		ind += 4;
		setter1.inst[i] = { 0, get_bit(io, i), ind };
	}
	setter1.inst[0] = { get_bit(var.index + 1, 0), get_bit(io, 0), setter1.index };
	setter1.inst.back().c = setter1.next1;

	//CHECKER
	forn(i, 16) {
		int ind = checkers[i].index;
		int z = checkers[i].index + 2 * 4 + 2;
		vector<instruction> insts(checkers[i].size);
		ind += 4;
		insts[0] = { get_bit(var.index, i), get_bit(z, 2), ind };
		ind += 4;
		insts[1] = { get_bit(io, i), get_bit(z, 3), ind };
		ind += 4;
		insts[2] = { 0, 0, z + 2 * 4 };

		insts[4] = insts[7] = { 0, 0, checkers[i].next1 };
		insts[5] = insts[6] = { 0, 0, checkers[i].next0 };

		checkers[i].inst = insts;
	}

	


	// OUTPUT
	vector<program> programs = { main, var, setter0, setter1, temp };
	for (auto x : checkers) {
		programs.push_back(x);
	}
	for (auto x : programs) {
		for (auto z : x.inst) {
			output(z);
		}
	}
}
bool multitest = 0;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}