#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'


int bitcheck(ll mask, ll k) {
	return (mask >> k) & 1ll;
}

struct ev {
	ll tm;
	// 1 -  , 0 -  , 2 - 
	int type; 
	int index;
};

void solve()
{
	int n, m, q;
	cin >> n >> m >> q;
	vector<ll> a(n), d(n);
	vector<ll> l(m);
	vector<ll> t(q);
	forn(i, n) {
		cin >> a[i];
	}
	forn(i, n) {
		cin >> d[i];
	}

	forn(i, m) {
		cin >> l[i];
	}
	for (int i = 1; i < m; ++i) {
		l[i] += l[i - 1];
	}
	forn(i, q) {
		cin >> t[i];
	}

	vector<ll> ans(q);
	vector<ev> e;
	forn(i, n) {
		e.push_back({ d[i], 0, i });
		e.push_back({ d[i] - a[i], 1, i });
	}
	forn(i, q) {
		e.push_back({ t[i], 2, i });
	}

	sort(all(e), [&](auto l, auto r) {
		if (l.tm != r.tm) return l.tm < r.tm;
		if (l.type != r.type) return l.type < r.type;
		return l.index < r.index;
	});
	ll sm_l = 0;
	multiset<pair<ll,ll>> ends;
	ll sm_r = 0;
	for (auto sob : e) {
		int type = sob.type;
		if (type == 0) {
			ends.erase(ends.find({ d[sob.index], a[sob.index] }));
			sm_r -= a[sob.index];
			sm_l += a[sob.index];
		}
		else if (type == 1) {
			sm_r += a[sob.index];
			ends.insert({ d[sob.index], a[sob.index] });
		}
		else if (type == 2) {
			ll left_otr = sm_l;
			ll pp = ((ends.empty()) ? sob.tm : ends.rbegin()->first);
			ll right_otr = (pp - sm_r);
			ll len = right_otr - left_otr;
			
			int lf = 0, rg = m - 1;
			int res = -1;
			while (lf <= rg) {
				int mid = lf + (rg - lf) / 2;
				if (l[mid] <= len) {
					res = mid;
					lf = mid + 1;
				}
				else rg = mid - 1;
			}
			ans[sob.index] = res + 1;
		}
		else assert(0);
	}
	for (auto x : ans) {
		cout << x << ' ';
	}
	cout << endl;
}
bool multitest = 1;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}