#include <bits/stdc++.h>
using namespace std;

const int N = 1e5 + 10;
bool op[N], res[N];
vector <int> gr[N], order, gr_mid[N], gr_side[N], order_mid;
int used[N];
bool is_mid[N];
int pos[N];

bool dfs(int v, vector <int> *gr) {
    used[v] = 1;
    for (int u : gr[v]) {
        if (used[u] == 1) {
            return 0;
        }
        if (used[u] == 0 && !dfs(u, gr)) {
            return 0;
        }
    }
    used[v] = 2;
    order.push_back(v);
    return 1;
}

bool topsort(int n, vector <int> *gr) {
    memset(used, 0, sizeof(used));
    order.clear();
    for (int i = 1; i <= n; i++) {
        if (!used[i] && !dfs(i, gr)) {
            return 0;
        }
    }
    return 1;
}

bool topsort(int n, vector <int> *gr, vector <int> &indices) {
    memset(used, 0, sizeof(used));
    order.clear();
    for (int i : indices) {
        if (!used[i] && !dfs(i, gr)) {
            return 0;
        }
    }
    return 1;
}

void solve0(int n) {
    if (!topsort(n, gr)) {
        cout << -1;
        return;
    }
    for (int i = 1; i <= n; i++) {
        if (op[i]) {
            cout << -1;
            return;
        }
    }
    reverse(order.begin(), order.end());
    for (int i : order) {
        cout << i << " ";
    }
}

int fnd(int n, bool o, bool r) {
    for (int i = 1; i <= n; i++) {
        if (op[i] == o && res[i] == r) {
            return i;
        }
    }
    return -1;
}

void solve1(int n) {
    int pos_st = fnd(n, 1, 1);
    if (pos_st == -1) {
        cout << -1;
        return;
    }
    for (int i = 1; i <= n; i++) {
        if (i == pos_st) {
            continue;
        }
        assert(!res[i]);
        if (!op[i]) {
            gr[i].push_back(pos_st);
        } else {
            gr[pos_st].push_back(i);
        }
    }
    if (!topsort(n, gr)) {
        cout << -1;
        return;
    }
    reverse(order.begin(), order.end());
    for (int i : order) {
        cout << i << " ";
    }
}

void solve2(int n) {
    vector <int> mid; mid.reserve(n);
    vector <int> side; side.reserve(n);
    for (int i = 1; i <= n; i++) {
        if (op[i] || res[i]) {
            mid.push_back(i); is_mid[i] = 1;
        } else {
            side.push_back(i);
        }
    }
    int pos_st = fnd(n, 1, 1), pos_ut = fnd(n, 0, 1);
    if (pos_st == -1 || pos_ut == -1) {
        cout << -1;
        return;
    }
    for (int v = 1; v <= n; v++) {
        for (int u : gr[v]) {
            if (is_mid[v] && is_mid[u]) {
                gr_mid[v].push_back(u);
            }
        }
    }
    gr_mid[pos_st].push_back(pos_ut);
    for (int i : mid) {
        if (res[i]) {
            continue;
        }
        gr_mid[pos_st].push_back(i);
        gr_mid[i].push_back(pos_ut);
    }
    if (!topsort(n, gr_mid, mid)) {
        cout << -1;
        return;
    }
    reverse(order.begin(), order.end());
    order_mid = order;
    for (int v = 1; v <= n; v++) {
        for (int u : gr[v]) {
            if (is_mid[v] && is_mid[u]) {
                continue;
            }
            if (!is_mid[v] && !is_mid[u]) {
                gr_side[v].push_back(u);
                continue;
            }
            if (is_mid[u]) {
                gr_side[v].push_back(0);
                continue;
            }
            if (is_mid[v]) {
                gr_side[0].push_back(u);
            }
        }
    }
    side.push_back(0);
    if (!topsort(n, gr_side, side)) {
        cout << -1;
        return;
    }
    reverse(order.begin(), order.end());
    vector <int> ans; ans.reserve(n);
    for (int i : order) {
        if (i == 0) {
            for (int j : order_mid) {
                ans.push_back(j);
            }
        } else {
            ans.push_back(i);
        }
    }
    assert(ans.size() == n);
    for (int i = 0; i < n; i++) {
        pos[ans[i]] = i;
    }
    for (int v = 1; v <= n; v++) {
        for (int u : gr[v]) {
            if (pos[v] > pos[u]) {
                cout << -1;
                return;
            }
        }
    }
    for (int i : ans) {
        cout << i << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    int true_cnt = 0;
    for (int i = 1; i <= n; i++) {
        string a, b;
        cin >> a >> b;
        op[i] = (a == "set"); res[i] = (b == "true");
        true_cnt += res[i];
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        gr[a].push_back(b);
    }
    if (true_cnt == 0) {
        solve0(n);
        return 0;
    }
    if (true_cnt == 1) {
        solve0(n);
        return 0;
    }
    if (true_cnt == 2) {
        solve2(n);
        return 0;
    }
    assert(0);
}
