#include <iostream>
#include <vector>
#include <string>
#include <stdint.h>

using namespace std;

bool check(const string& s) {
	vector<string> v;
	v.emplace_back();
	vector<char> op;

	for (auto& e : s) {
		if (e == '+' || e == '-' || e == '=') {
			v.emplace_back();
			op.emplace_back(e);
		}
		else {
			v.back().push_back(e);
		}
	}

	for (auto& e : v) {
		if (e.empty()) return false;
		if (e[0] == '0') return false;
		if (e.size() > 10) return false;
	}

	int64_t res = stoll(v[0]);
	int sign = 1;
	for (int i = 0; i < op.size(); ++i) {
		if (op[i] == '-') res -= sign * stoll(v[i + 1]);
		else if (op[i] == '+') res += sign * stoll(v[i + 1]);
		else sign = -1, res += sign * stoll(v[i + 1]);
	}
	return res == 0;
}

int main() {
	string s;
	cin >> s;
	if (check(s)) {
		cout << "Correct\n";
		return 0;
	}
	for (int i = 0; i < s.size(); ++i) {
		string t = s;
		auto c = t[i];
		t.erase(t.begin() + i);
		for (int j = 0; j <= t.size(); ++j) {
			t.insert(t.begin() + j, c);
			if (check(t)) {
				cout << t << "\n";
				return 0;
			}
			t.erase(t.begin() + j);
		}
	}
	cout << "Impossible\n";

}