#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;
const ll INFLL = 1e18;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, ll> > > g(n);
    vector<vector<pair<int, ll> > > inv_g(n);
    for (int i = 0; i < m; i++) {
        int f, t, w;
        cin >> f >> t >> w;
        f--, t--;
        g[f].push_back({t, w});
        inv_g[t].push_back({f, w});
    }

    vector<ll> dist(n, INFLL);
    dist[n - 1] = 0;
    set<pair<ll, int> > dj;
    dj.insert({0, n - 1});
    while (dj.size()) {
        auto it = *dj.begin();
        dj.erase(it);
        int v = it.second;

        for (auto e : inv_g[v]) {
            if (dist[e.first] > dist[v] + e.second) {
                dj.erase({dist[e.first], e.first});
                dist[e.first] = dist[v] + e.second;
                dj.insert({dist[e.first], e.first});
            }
        }
    }

    if (dist[0] == INFLL) {
        cout << -1 << "\n";
        return;
    }

    vector<set<int> > sets(n);
    vector<set<int> > secondary_sets(n);
    for (int i = 0; i < n; i++) {
        for (auto e : g[i]) {
            if (dist[e.first] + e.second == dist[i]) {
                sets[i].insert(e.first);
                //cout << "PLACE (MAIN SET)" << i << " " << e.first << "\n";
            } else {
                secondary_sets[i].insert(e.first);
                //cout << "PLACE (SECONDARY SET)" << i << " " << e.first << "\n";
            }
        }
    }

    vector<int> q;
    auto update_sets = [&](int v) {
        //cout << "UPDATE SETS " << v << "\n";
        for (auto e : inv_g[v]) {
            int was_1 = sets[e.first].size() + secondary_sets[e.first].size() == 1;
            sets[e.first].erase(v);
            secondary_sets[e.first].erase(v);
            //cout << "? " << e.first << " -> " << sets[e.first].size() << " " << secondary_sets[e.first].size() << "\n";
            if (sets[e.first].size() + secondary_sets[e.first].size() == 0 && was_1 && e.first != n - 1 && dist[e.first] != INFLL) {
                q.push_back(e.first);
            }
        }
    };

    vector<pair<ll, int> > S;
    for (int i = 0; i < n; i++) {
        if (dist[i] != 0 && dist[i] != INFLL) {
            S.push_back({dist[i], i});
        }
    }
    sort(S.begin(), S.end());
    int j = 0;

    vector<int> perf(n);

    vector<int> badness(n, -INF);
    int ignore = 1;
    badness[n - 1] = INF;
    update_sets(n - 1);
    for (int i = 0; i < n; i++) {
        if (dist[i] == INFLL) {
            badness[i] = 0;
            update_sets(i);
            ignore++;
        }
    }

    for (int i = 0; i < q.size(); i++) {
        perf[q[i]] = 1;
        int mx = -INF, idx = -1;
        for (int j = 0; j < g[q[i]].size(); j++) {
            auto e = g[q[i]][j];
            if (dist[e.first] + e.second == dist[q[i]]) {
                if (badness[e.first] > mx) {
                    mx = max(mx, badness[e.first]);
                    idx = j;
                }
            }
        }
        //cout << "Placing sign from " << q[i] << " to " << g[q[i]][idx].first << "\n";
        int w = INF;
        for (int j = 0; j < g[q[i]].size(); j++) {
            auto e = g[q[i]][j];
            //cout << "? > " << badness[e.first] << "\n";

            if (badness[e.first] < -INF / 2) continue;

            if (j != idx) {
                w = min(w, badness[e.first] + 1);
            } else {
                w = min(w, badness[e.first]);
            }
        }
        badness[q[i]] = w;
        //cout << "COMPUTED BADNESS " << q[i] << " " << w << "\n";
        update_sets(q[i]);

        if (i + 1 == q.size() && q.size() != S.size()) {
            while (j < S.size()) {
                if (!perf[S[j].second]) {
                    q.push_back(S[j].second);
                    break;
                }
                j++;
            }
        }
    }

    //for (auto e : badness) cout << e << " "; cout << "\n";

    if (badness[0] - 1 > n) {
        cout << n << "\n";
    } else {
        cout << badness[0] - 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

/*
8

5 7
1 3 5
4 5 2
3 4 3
1 5 9
4 2 8
5 2 11
3 5 5

6 6
1 2 5
2 3 9
1 4 11
2 1 1000000
5 3 15
5 6 1

4 7
1 2 5
1 1 30
3 2 9
1 4 11
1 4 16
2 1 1000000
1 4 11

2 0

6 7
1 2 5
2 3 9
1 6 11
2 1 1000000
1 5 9
5 6 2
5 4 4

4 4
1 4 6
1 3 2
3 2 3
3 4 4

3 2
1 2 1
1 3 1

7 7
1 2 2
2 3 1
1 4 1
4 5 1
5 6 1
6 7 1
2 7 2
*/
