#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

vector <vector <int>> g;
vector <int> cnt_in;
vector <int> command;
vector <int> result;
vector <int> used;
vector <int> ord;

void dfs1(int v) {
    if (used[v] || command[v] == 1 || result[v] == 1 || cnt_in[v] > 0) return;
    used[v] = 1;
    ord.push_back(v);
    for (int i : g[v]) {
        --cnt_in[i];
        dfs1(i);
    }
}

void dfs2(int v) {
    if (used[v] || command[v] == 0 || result[v] == 1 || cnt_in[v] > 0) return;
    used[v] = 1;
    ord.push_back(v);
    for (int i : g[v]) {
        --cnt_in[i];
        dfs2(i);
    }
}

void dfs3(int v) {
    if (used[v] || command[v] == 1 || result[v] == 1 || cnt_in[v] > 0) return;
    used[v] = 1;
    ord.push_back(v);
    for (int i : g[v]) {
        --cnt_in[i];
        dfs3(i);
    }
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    cnt_in.resize(n);
    command.resize(n);
    result.resize(n);
    used.resize(n);

    vector <int> special;

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if (s == "set") {
            command[i] = 1;
        } else {
            command[i] = 0;
        }
        cin >> s;
        if (s == "true") {
            result[i] = 1;
            special.push_back(i);
        } else {
            result[i] = 0;
        }
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y; --x; --y;
        g[x].push_back(y);
        ++cnt_in[y];
    }


    //step 1
    for (int i = 0; i < n; ++i) {
        dfs1(i);
    }
    
    if (special.empty()) {
        if (ord.size() == n) {
            for (int i : ord) cout << i + 1 << " ";
        } else {
            cout << -1;
        }
        return;
    }

    int num_set = -1;
    for (int i = 0; i < special.size(); ++i) {
        if (command[special[i]] == 1) num_set = i;
    }
    if (num_set == -1) {
        cout << -1;
        return;
    }

    int v = special[num_set];
    if (cnt_in[v] > 0) {
        cout << -1;
        return;
    }
    special.erase(special.begin() + num_set);
    used[v] = 1;
    ord.push_back(v);
    for (int i : g[v]) {
        --cnt_in[i];
    }

    //step2

    for (int i = 0; i < n; ++i) {
        dfs2(i);
    }

    if (special.empty()) {
        if (ord.size() == n) {
            for (int i : ord) cout << i + 1 << " ";
        } else {
            cout << -1;
        }
        return;
    }

    v = special[0];
    if (command[v] == 1 || cnt_in[v] > 0) {
        cout << -1;
        return;
    }
    used[v] = 1;
    ord.push_back(v);
    for (int i : g[v]) {
        --cnt_in[i];
    }

    for (int i = 0; i < n; ++i) {
        dfs3(i);
    }

    if (ord.size() == n) {
        for (int i : ord) cout << i + 1 << " ";
    } else {
        cout << -1;
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}