#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}
vector<int> dx{1,1,1,0,-1,-1,-1,0};
vector<int> dy{-1,0,1,1,1,0,-1,-1};
struct point {
    ld x,y;
};
point operator*(point a, ld k) {
    return {a.x*k, a.y*k};
}
point operator+(point a,point b) {
    return {a.x+b.x,a.y+b.y};
}
point operator/(point a, ld k) {
    return {a.x/k,a.y/k};
}
ld len(point a) {
    return sqrt(a.x*a.x+a.y*a.y);
}
point spin(point a, ld ang) {
    return {a.x*cos(ang) - a.y*sin(ang), a.x * sin(ang) + a.y*cos(ang)};
}
point operator-(point a,point b) {
    return {a.x-b.x,a.y-b.y};
}
ld dist(point a,point b) {
    return len(a-b);
}
const ld EPS = 1e-7;
bool okseg(pair<point,point> a,pair<point,point> b) {
    if(dist(a.first, b.first)<EPS && dist(a.second, b.second)<EPS) return 1;
    if(dist(a.first, b.second) <EPS && dist(a.second, b.first)<EPS) return 1;
    return 0;
}
vector<pair<point,point>> normalize(vector<pair<point,point>> a) {
    point mn = {1e18,1e18};
    for(auto i : a) {
        if(i.first.x < mn.x || (i.first.x == mn.x && i.first.y < mn.y)) {
            mn = i.first;
        }
        if(i.second.x < mn.x || (i.second.x == mn.x && i.second.y < mn.y)) {
            mn = i.second;
        }
    }
    for(auto & i : a) {
        i.first = i.first-mn;
        i.second = i.second - mn;
    }
    return a;
}
const ld PI = acos(-1);
void solve() {
    int n;
    cin>>n;
    vector<pair<string,int>> cmd(n);
    for(int i =0;i< n;++i) {
        cin>>cmd[i].first>>cmd[i].second;
    }
    vector<pair<point,point>> segs;
    point orig = {0,0};
    int cur = 0;
    for(int i =0;i< n;++i) {
        if(cmd[i].first == "rotate") {
            while(cmd[i].second >= 45) {
                cmd[i].second -=45;
                cur = (cur+1)%8;
            }
        }
        else if(cmd[i].first == "move") {
            point f = {dx[cur], dy[cur]};
            f = f / len(f) * cmd[i].second;
            orig = orig + f;
        }
        else {
            point f = {dx[cur], dy[cur]};
            f = f / len(f) * cmd[i].second;
            segs.pbc({orig, orig+f});
            orig = orig + f;

        }
    }
    segs=normalize(segs);
    for(int go  =45;go<=360;go += 45){
        vector<pair<point,point>> tsegs;
        ld here =(ld)go / 180 * PI;
        for(auto i :segs) {
            tsegs.pbc({spin(i.first, here), spin(i.second, here)});
        }
        tsegs=normalize(tsegs);
        vector<int> used(segs.size());
        bool  match =1;
        for(int i=0;i< segs.size();++i) {
            bool ok =0;
            for(int j =0;j< segs.size();++j) {
                if(used[j]) continue;
                if(okseg(tsegs[i], segs[j])) {
                    used[j]=1;
                    ok = 1;
                    break;
                }
            }
            if(!ok) {
                match= 0;
                break;
            }
        }
        if(match) {
            cout<<go<<endl;
            return;
        }
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}