#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pr;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);
const ll maxn = 2e5;



vector<vector<ll>> graph(maxn);
vector<bool> used(maxn);
vector<ll> order;


void dfs(ll v){
    used[v] = true;

    for(auto &to : graph[v]){
        if(!used[to]){
            dfs(to);
        }
    }
    order.push_back(v);
}
int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    ll n;
    cin >> n;

    ll countS = 0,countU = 0;

    vector<pr> a(n);
    ll posS = -1,posU = -1;
    for (int i = 0; i < n; ++i) {
        string com,val;
        cin >> com >> val;


        if(com[0] == 's'){
            if(val[0] == 't'){
                a[i] = {1,1};
                posS = i;
                countS++;
            }
            else{
                a[i] = {1,0};
            }
        }
        else{
            if(val[0] == 't'){
                a[i] = {0,1};
                posU = i;
                countU++;
            }
            else{
                a[i] = {0,0};
            }
        }
    }

    ll m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        ll v,to;
        cin >> v >> to;

        v--,to--;

        graph[v].push_back(to);

    }
    if(countU + countS == 2 && (countU == 0 || countS == 0)){
        cout << -1;
        return 0;
    }
    if(countU + countS > 2){
        cout << -1;
        return 0;
    }
    if(countU + countS == 1 && countU == 1){
        cout << -1;
        return 0;
    }
    for (int v = 0; v < n; ++v) {
        if(!used[v]){
            dfs(v);
        }
    }

    fill(all(used),false);
    reverse(all(order));


    vector<ll> pos(n);

    for (int v = 0; v < n; ++v) {
        pos[order[v]] = v;
    }

    deque<ll> ans;


    if(countS + countU == 2){
        if(posS != -1){
            ans.push_back(posS);

            used[posS] = true;
            bool found = false;
            ll positionU = -1;
            for (int i = pos[posS] - 1; i >= 0; --i) {
                ll v = order[i];

                if(a[v].first == 0 && a[v].second == 1){
                    found = true;
                    positionU = i;

                    break;
                }
            }
            if(positionU == -1){
                positionU = pos[posS];
            }
            for (int i = positionU - 1; i >= 0; --i) {
                ll v = order[i];

                if(a[v].first == 0 && a[v].second == 0){
                    used[v] = true;
                    ans.push_front(v);
                }
            }
            for (int i = 0; i < n; ++i) {
                ll v = order[i];
                if(a[v].first == 1 && !used[v] && a[v].second == 0){
                    used[v] = true;
                    ans.push_back(v);
                }
            }
        }

        if(posU != -1){
            ans.push_back(posU);

            used[posU] = true;

            for (int i = 0; i < n; ++i) {
                ll v = order[i];
                if(!used[v] && a[v].first == 0){
                    ans.push_back(v);
                    used[v] = true;
                }
            }
        }

    }
    else if(countS == 1){
        if(posS != -1){
            ans.push_back(posS);

            used[posS] = true;
            for (int i = n-1; i >= 0; --i) {
                ll v = order[i];

                if(a[v].first == 0 && a[v].second == 0){
                    used[v] = true;
                    ans.push_front(v);
                }
            }
            for (int i = 0; i < n; ++i) {
                ll v = order[i];
                if(a[v].first == 1 && !used[v]){
                    used[v] = true;
                    ans.push_back(v);
                }
            }
        }

    }
    else if(countS + countU == 0){
        for (int i = 0; i < n; ++i) {
            ll v = order[i];
            ans.push_back(v);
        }
    }
    else{
        exit(228);
    }
    fill(all(used),false);
    assert(ans.size() == n);

    for(auto &v : ans){
        for(auto &to : graph[v]){
            if(used[to]){
                cout << -1;
                return 0;
            }
        }
        used[v] = true;
    }
    bool cur = false;

    assert(ans.size() == n);
    for (int i = 0; i < n; ++i) {
        auto [com,val] = a[ans[i]];

        if(com == 0){
            if(val){
                if(!cur){
                    cout << -1;
                    return 0;
                }
            }
            else{
                if(cur){
                    cout << -1;
                    return 0;
                }
            }
        }

        else{
            if(val){
                if(cur){
                    cout << -1;
                    return 0;
                }
            }
            else{
                if(!cur){
                    cout << -1;
                    return 0;
                }
            }
        }

        cur = com;

    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << " ";
    }
    return 0;
}