#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << x << endl
#else
#define show(x) ((void)0)
#endif

using ll = long long;
using pll = pair<int, int>;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<pll> hw(n);

    for (int i = 0; i < n; i++) {
        cin >> hw[i].first;
    }

    for (int i = 0; i < n; i++) {
        cin >> hw[i].second;
    }

    vector<ll> ep(m);
    for (int i = 0; i < m; i++) {
        cin >> ep[i];
    }

    sort(hw.begin(), hw.end(), [&](auto p1, auto p2) {
        if (p1.second == p2.second) {
            return p1.first < p2.first;
        }
        return p1.second < p2.second;
    });

    ll tm = 0;

    set<pll> handicap;
    vector<set<pll>::iterator> hw_to_hand(n);

    for (int i = 0; i < n; i++) {
        tm += hw[i].first;

        auto possible = hw[i].second - tm;

        handicap.insert({possible, i});
        hw_to_hand[i] = handicap.find({possible, i});
    }

    tm = 0;
    map<ll, ll> ans;
    ans[0] = 0;
    ll used = 0;

    ll cnt = 0;

    auto hw_ptr = 0;
    auto s_ptr = 0;

    while (s_ptr < m) {
        if (handicap.empty() || handicap.begin()->first >= used + ep[s_ptr]) {
            tm += ep[s_ptr];
            used += ep[s_ptr];
            cnt++;
            ans[tm] = cnt;
            s_ptr++;
        } else if (hw_ptr < n) {
            tm += hw[hw_ptr].first;
            handicap.erase(hw_to_hand[hw_ptr]);
            hw_ptr++;
        }
    }

    while (q--) {
        ll x;
        cin >> x;

        auto it = ans.lower_bound(x);
        if (it == ans.end() || it->first != x) {
            it = prev(it);
        }

        cout << it->second << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
