#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>
#include <cstdint>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>
#define rep(i, n) for(int i = 0; i < (n); i++)

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}

int IP_END_0;
int IP_END_1;
int x;

map<int, char> r;

string get16(int x) {
    string res;
    rep(_, 4) {
        int cv = (x & 15);
        res += r[cv];
        x >>= 4;
    }
    reverse(all(res));
    return res;
}

string getBlock(int block) {
    int curIp = block * 4 * 4;
    int curStartBit = curIp * 16;
    int a = (1 << 16) - 1 - block;
    int b = curStartBit + 32 + 15 - 2;
    int c1 = curIp + 8;
    int c2 = c1 + 4;
    int c = c1;
    int nxtIp = curIp + 16;
    int A, B;
    if (x & (1 << block)) {
        A = IP_END_0;
        B = nxtIp;
    } else {
        A = nxtIp;
        B = IP_END_0;
    }
    string res;
    ve<vi> arr = {{a, b, c, 0},
                {0, 0, 0, 0},
                {0, 0, A, 0},
                {0, 0, B, 0}};
    for (auto v : arr) {
        for (auto x : v) {
            res += get16(x) + " ";
        }
        res += '\n';
    }
    return res;
}

void solve() {
    cin >> x;
    ve<char> c = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
    rep(i, c.size()) {
        r[i] = c[i];
    }
    IP_END_1 = 16 * 4 * 4;
    IP_END_0 = IP_END_1 + 4;
    ve<vi> arr = {{IP_END_1 * 16 + 16 * 3, (1 << 16) - 1, (1 << 12) - 1, 0xFFFF},
                  {IP_END_0 * 16 + 16 * 3, (1 << 16) - 1, (1 << 12) - 1, 0x0000}};
    // cout << get16(UINT16_MAX);
    string res;
    rep(i, 16) {
        res += getBlock(i);
        // res += "\n";
    }
    for (auto v : arr) {
        for (auto x : v) {
            res += get16(x) + " ";
        }
        res += '\n';
    }
    cout << res;
}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}