#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int long long
const int INF = 1e18;

const int maxn = 4e5 + 10;

int dp[maxn][2];
vector<int> g[maxn];

void dfs(int v, int p = -1) {
    for (auto& u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][1] += max(dp[u][1], dp[u][0]);
    }
    dp[v][0] = dp[v][1];
    for (auto& u : g[v]) {
        if (u == p) continue;
        int res = dp[v][1] - max(dp[u][1], dp[u][0]) + dp[u][1] + 1;
        dp[v][0] = max(dp[v][0], res);
    }
}

vector<pair<int, int>> match;

void restore(int v, int c, int p = -1) {
    if (c == 1) {
        for (auto& u : g[v]) {
            if (u == p) continue;
            if (dp[u][0] > dp[u][1]) restore(u, 0, v);
            else restore(u, 1, v);
        }
    } else {
        for (auto& u : g[v]) {
            if (u == p) continue;
            int res = dp[v][1] - max(dp[u][1], dp[u][0]) + dp[u][1] + 1;
            if (dp[v][0] == res) {
                match.emplace_back(v, u);
                restore(u, 1, v);
                for (auto& k : g[v]) {
                    if (k == u || k == p) continue;
                    if (dp[k][0] > dp[k][1]) restore(k, 0, v);
                    else restore(k, 1, v);
                }
                return;
            }
        }

        for (auto& u : g[v]) {
            if (u == p) continue;
            if (dp[u][0] > dp[u][1]) restore(u, 0, v);
            else restore(u, 1, v);
        }
    }

}

void solve() {
    int n;
    cin >> n;
    n *= 2;
    vector<int> col(n);
    for (int i = 0; i < n; ++i) cin >> col[i];
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    dfs(0, -1);
    restore(0, 0, -1);

    map<int, int> q;
    map<int, vector<int>> col_v;
    for (auto& [v, u] : match) {
        q[v] = u;
        q[u] = v;
    }

    for (int i = 0; i < n; ++i) {
        if (col_v.find(col[i]) == col_v.end()) col_v[col[i]] = {i};
        else col_v[col[i]].emplace_back(i);
    }

    vector<pair<int, int>> ans;
    vector<int> used(n);
    for (int i = 0; i < n; ++i) {
        if (q.find(i) == q.end()) continue;
        if (used[i]) continue;
        int x = i;
        while (!used[x] && q.find(x) != q.end()) {
            used[x] = used[q[x]] = 1;
            if (col[x] == col[q[x]]) break;

            int u = q[x];
            int j = 0;
            if (col_v[col[x]][0] == x) j = 1;

            int v = col_v[col[x]][j];
            ans.emplace_back(u, v);

            col_v[col[x]][j] = u;
            if (col_v[col[u]][0] == u) col_v[col[u]][0] = v;
            else col_v[col[u]][1] = v;

            swap(col[u], col[v]);
            x = v;
        }
    }
    cout << ans.size() << '\n';
    for (auto& [v, u] : ans) {
        cout << v + 1 << " " << u + 1 << '\n';
    }

    for (int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i][0] = dp[i][1] = 0;
    }
    match.clear();

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
