#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>

#define ll long long;
#define nl "\n";

using namespace std;

long long expr(string& exp) {
	long long res = 0;
	long long currnum = 0;
	long long currsign = 1;
	long long n = exp.length();
	for (long long i = 0; i < n; i++) {
		if (exp[i] == '+' || exp[i] == '-') {
			res += currnum * currsign;
			currnum = 0;
			currsign = exp[i] == '-' ? -1 : 1;
		}
		else {
			currnum = currnum * 10 + (exp[i] - '0');
		}
	}
	res += currnum * currsign;
	return res;
}

bool isok(string& s) {
	long long n = s.length();
	long long ind;
	for (long long i = 0; i < n; i++) {
		if (s[i] == '=') {
			ind = i;
			break;
		}
	}
	string s1 = "", s2 = "";
	for (long long i = 0; i < ind; i++) {
		s1 += s[i];
	}
	for (long long i = ind + 1; i < n; i++) {
		s2 += s[i];
	}
	return expr(s1) == expr(s2);
}

bool isint(char c) {
	return c >= '0' && c <= '9';
}

bool extra(char c) {
	return c == '=' || c == '-' || c == '+';
}

signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;
	int n = s.length();
	if (isok(s)) {
		cout << "Correct" << nl;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		if (s[i] < '0' || s[i] > '9') continue;
		for (long long j = 0; j < n; j++) {
			string now = "";
			for (long long k = 0; k < j; k++) {
				if (k != i) now += s[k];
			}
			now += s[i];
			for (long long k = j; k < n; k++) {
				if (k != i) now += s[k];
			}
			bool flag = 0;
			for (int k = 0; k < n; k++) {
				if (now[k] == '0') {
					if ((k - 1 >= 0 && !isint(now[k - 1])) || (k - 1 == -1)) {
						if (k + 1 < n && isint(now[k + 1])) flag = 1;
					}
				}
			}
			int len = 0;
			for (int k = 0; k < n; k++) {
				if (extra(now[k])) {
					if (k - 1 >= 0 && extra(now[k - 1])) flag = 1;
					if (k + 1 < n && extra(now[k + 1])) flag = 1;

				}
				if (isint(now[k])) {
					len++;
					if (len > 10) flag = 1;
				}
				else {
					len = 0;
				}
			}
			if (flag) continue;
			if (isok(now)) {
				cout << now << nl;
				return 0;
			}
		}
	}
	cout << "Impossible" << nl;
	return 0;
}