#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long
// #define double long double

using namespace std;

vector<vector<int>> g, rg;
vector<pair<bool, bool>> op;
vector<bool> used;
vector<int> tp;

bool val_sus(int v, bool st = false) {
	used[v] = true;

	int t = op[v].first;

	if (st && !op[v].first) {
		t = 2;
	}

	for (auto u : g[v]) {
		if (!used[u]) {
			val_sus(u, st);
		}

		t = max(t, tp[u]);
		if (op[u].first != op[v].first) {
			t = max(t, tp[u] + 1);
		}

		if (!op[u].first && op[u].second && !op[v].first) {
			t = max(t, 2ll);
		}

		if (op[v].first && t != 1) {
			return false;
		}

		if (!op[v].first && !(t == 0 || t == 2)) {
			return false;
		}
	}

	tp[v] = t;

	return true;
}

vector<vector<int>> ans(3);
void dfs(int v) {
	used[v] = 1;

	for (int u : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}

	ans[tp[v]].push_back(v);
}

void solve() {
	int n;
	cin >> n;

	op.resize(n);
	tp.resize(n);

	int cnt_ut = 0, cnt_st = 0;
	int idx_ut = -1, idx_st = -1;
	for (int i = 0; i < n; i++) {
		string s1, s2;
		cin >> s1 >> s2;

		op[i] = { s1 == "set", s2 == "true" };
		if (op[i].first && op[i].second) {
			cnt_st++;
			idx_st = i;
		} 

		if (!op[i].first && op[i].second) {
			cnt_ut++;
			idx_ut = i;
		}
	}

	bool val_suc = cnt_st <= 1 && cnt_ut <= cnt_st;

	if (!val_suc) {
		cout << -1 << '\n';
		return;
	}
	
	g.resize(n);
	rg.resize(n);

	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;

		g[a].push_back(b);
		rg[b].push_back(a);
	}

	used.assign(n, false);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			if (!val_sus(i, idx_ut == -1)) {
				cout << -1;
				return;
			}
		}
	}

	if (idx_st != -1) {
		for (auto u : rg[idx_st]) {
			if (op[u].first) {
				cout << -1;
				return;
			}
		}

		for (int i = 0; i < n; i++) {
			if (tp[i] == 1 && i != idx_st) {
				g[idx_st].push_back(i);
			}
		}
	}

	if (idx_ut != -1) {
		for (auto u : rg[idx_ut]) {
			if (tp[u] == 0) {
				cout << -1;
				return;
			}
		}

		for (int i = 0; i < n; i++) {
			if (tp[i] == 1) {
				g[i].push_back(idx_ut);
			}
		}
	}

	used.assign(n, false);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}

	for (int i = 0; i < 3; i++) {
		reverse(ans[i].begin(), ans[i].end());
	}

	vector<int> ful_ans;

	for (auto i : ans[2]) {
		ful_ans.push_back(i);
	}

	if (idx_st != -1) {
		ful_ans.push_back(idx_st);
	}

	for (auto i : ans[1]) {
		if (i == idx_st)
			continue;

		ful_ans.push_back(i);
	}

	if (idx_ut != -1) {
		ful_ans.push_back(idx_ut);
	}

	for (auto i : ans[0]) {
		if (i == idx_ut)
			continue;

		ful_ans.push_back(i);
	}

	bool val = false;
	for (auto i : ful_ans) {
		if (val == op[i].first) {
			if (op[i].second) {
				cout << -1;
				return;
			}
		}

		if (val != op[i].first) {
			if (!op[i].second) {
				cout << -1;
				return;
			}
			val = op[i].first;
		}
	}

	for (auto i : ful_ans) {
		cout << i + 1 << ' ';
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}