#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct dist: pair<int, int> {
    dist operator+(const dist& other) {
        return dist(pair{first + other.first, second + other.second});
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), rg(n);
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        g[u].emplace_back(v, t);
        rg[v].emplace_back(u, t);
    }
    dist def{pair{-1,-1}};
    auto dijkstra = [&n, &def](int s, vector<vector<pair<int, int>>> &g) {
        vector<dist> d(n, def);
        d[s] = dist{pair{0, 0}};
        set<pair<dist, int>> b;
        b.emplace(dist{pair{0, 0}}, s);
        while (!b.empty()) {
            int u = b.begin()->second;
            b.erase(b.begin());
            for (const auto& [v, t]: g[u]) {
                if (d[v] == def || d[v] > d[u] + dist{pair{t, 1}}) {
                    b.erase({d[v], v});
                    d[v] = d[u] + dist{pair{t, 1}};
                    b.insert({d[v], v});
                }
            }
        }
        return d;
    };
    auto d1 = dijkstra(n - 1, rg);
    vector<vector<pair<int, int>>> g1(n);
    for (int u = 0; u < n - 1; ++u) {
        if (d1[u] == def) continue;
        for (auto [v, t]: g[u]) {
            if (d1[v] != def && d1[u] == d1[v] + dist{pair{t, 1}}) {
                g1[u].push_back({v, 0});
            } else {
                g1[u].push_back({v, 1});
            }
        }
    }
    auto d2 = dijkstra(0, g1);
    int res = n + 1;
    for (int u = 0; u < n; ++u) {
        if (d1[u] == def && d2[u] != def) {
            res = min(d2[u].first, res);
        }
    }
    cout  <<res - 1;

}
