#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdio>
using namespace std;

typedef long long ll;

bool expr_correct(string &expr)
{
	if (expr[0] == '+' || expr[0] == '-' || expr[0] == '=')
		return false;

	int pos = 0;
	while (pos < expr.size())
	{
		int end_num = pos;
		while (end_num < expr.size() && '0' <= expr[end_num] && expr[end_num] <= '9')
			end_num++;

		if (end_num - pos > 10)
			return false;

		if (pos + 1 < end_num && expr[pos] == '0')
			return false;

		if (end_num == expr.size()) break;

		int sign_ptr = end_num;
		while (sign_ptr < expr.size() &&
			(expr[sign_ptr] == '+' || expr[sign_ptr] == '-' || expr[sign_ptr] == '='))
			sign_ptr++;

		if (end_num + 1 < sign_ptr)
			return false;


		if (sign_ptr == expr.size())
			return false;

		pos = sign_ptr;
	}

	return true;
}

ll stoi(string& eq, int l, int r)
{
	ll res = 0;
	while (l < r)
	{
		res *= 10LL;
		res += (long long)(eq[l] - '0');
		l++;
	}

	return res;
}

bool eq_is_correct(string& eq)
{
	int pos = 0;
	ll lhs = 0, rhs = 0;
	ll last_sign = 1;
	bool left_done = false;

	while (pos < eq.size())
	{
		int end_num = pos;
		while (end_num < eq.size() && '0' <= eq[end_num] && eq[end_num] <= '9')
			end_num++;

		ll num = stoi(eq, pos, end_num);
		if (left_done)
			rhs += num * last_sign;
		else
			lhs += num * last_sign;

		if (end_num == eq.size())
			break;

		if (eq[end_num] == '+')
			last_sign = 1;
		if (eq[end_num] == '-')
			last_sign = -1;
		if (eq[end_num] == '=')
			left_done = true;

		pos = end_num + 1;
	}

	return (lhs == rhs);
}

int main()
{
	string eq;
	cin >> eq;
	
	int flag = 0;

	string new_ex;
	for (int i = 0; i < eq.size(); i++)
		new_ex += eq[i];

	if (eq_is_correct(eq)) {
		cout << "Correct";
		return 0;
	}

	for (int i = 0; i < eq.size(); i++)
	{
		for (int j = 0; j < eq.size(); j++)
		{
			if (j == i)
				continue;

			if (j < i)
			{
				for (int k = 0; k < j; k++)
					new_ex[k] = eq[k];
				new_ex[j] = eq[i];
				for (int k = j + 1; k < i; k++)
					new_ex[k] = eq[k - 1];
				new_ex[i] = eq[i - 1];
				for (int k = i + 1; k < eq.size(); k++)
					new_ex[k] = eq[k];
			}

			else if (j > i) {
				for (int k = 0; k < i; k++)
					new_ex[k] = eq[k];
				for (int k = i; k < j; k++)
					new_ex[k] = eq[k + 1];
				new_ex[j] = eq[i];
				for (int k = j + 1; k < eq.size(); k++)
					new_ex[k] = eq[k];
			}
			if (expr_correct(new_ex)) {
				if (eq_is_correct(new_ex) && flag == 0) {
					flag = 1; 
					cout << new_ex;
				}
					
			}
		}
	}
	if (flag == 0)
		cout << "Impossible";
}


