#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <chrono>
#include <random>
#include <functional>
#include <stack>
#include <cassert>
#include <climits>
using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vint = vector<int>;
using vvint = vector<vint>;
using vll = vector<ll>;
using vvll= vector<vll>;
using vst = vector<string>;
using vpll = vector<pll>;
using vpii = vector<pii>;
using vldb = vector<ldb>;
using t3ll = tuple<ll, ll, ll>;
#define all(x) x.begin(), x.end()
#define forp(i,s,f) for(int i = s; i < f; ++i) 
#define form(i,s,f) for(int i = s; i > f; --i) 
#define size(x) int(x.size())
#define dprint(x) for(auto now: x) cout << now << '\n'
#define x first
#define y second

pll screenSize;
pll c1, c2;
pll s1, s2;
pll d1, d2;

pll initC1, initC2;
pll initD1, initD2;

void Move() {
	c1.x += d1.x;
	c1.y += d1.y;
	if (c1.x <= 0) {
		d1.x = 1;
	}
	else if (c1.x + s1.x >= screenSize.x) {
		d1.x = -1;
	}
	if (c1.y <= 0) {
		d1.y = 1;
	}
	else if (c1.y + s1.y >= screenSize.y) {
		d1.y = -1;
	}

	c2.x += d2.x;
	c2.y += d2.y;
	if (c2.x <= 0) {
		d2.x = 1;
	}
	else if (c2.x + s2.x >= screenSize.x) {
		d2.x = -1;
	}
	if (c2.y <= 0) {
		d2.y = 1;
	}
	else if (c2.y + s2.y >= screenSize.y) {
		d2.y = -1;
	}
}

bool CheckInitState() {
	if (initC1 != c1 || initC2 != c2)
		return false;
	if (initD1 != d1 || initD2 != d2)
		return false;
	return true;
}

bool CheckCol() {
	pll c3 = c1, c4 = c2;
	c3.x += s1.x;
	c3.y += s1.y;
	c4.x += s2.x;
	c4.y += s2.y;
	/*
	if ((((c2.x >= c1.x && c2.x < c3.x) || (c4.x > c1.x && c4.x <= c3.x)) &&
		((c2.y >= c1.y && c2.y < c3.y) || (c4.y > c1.y && c4.y <= c3.y))) ||
		(((c2.x <= c1.x && c4.x >= c3.x) || (c2.x >= c1.x && c4.x <= c3.x)) && 
		((c2.y <= c1.y && c4.y >= c3.y) || (c2.y >= c1.y && c4.y <= c3.y))))
		return true;
	return false;
	*/
	if ((c3.x > c2.x && c1.x < c4.x) && (c3.y > c2.y && c1.y < c4.y))
		return true;
	return false;
}

int GCD(int a, int b) {
	while (b) {
		a %= b;
		swap(a, b);

	}
	return a;
}

void solve() {
	cin >> screenSize.x >> screenSize.y;
	cin >> s1.x >> s1.y;
	cin >> c1.x >> c1.y;
	cin >> d1.x >> d1.y;
	cin >> s2.x >> s2.y;
	cin >> c2.x >> c2.y;
	cin >> d2.x >> d2.y;

	initC1 = c1;
	initC2 = c2;
	initD1 = d1;
	initD2 = d2;

	ll p = 0, q = 0;

	while (true) {
		Move();
		q++;
		if (CheckCol())
			p++;
		if (CheckInitState())
			break;
	}

	if (p == 0) {
		cout << "0/1\n";
		return;
	}
	int g = GCD(p, q);
	cout << p / g << "/" << q / g << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}