#include <bits/stdc++.h>

using namespace std;

using ii = __int128;
using ll = long long;

struct F {
    ll a{0}, b{0};

    explicit F(ll a = 0, ll b = 0) : a(a), b(b) {}

    F operator+(F f) const {
        return F(a + f.a, b + f.b);
    }

    F operator-(F f) {
        return F(a - f.a, b - f.b);
    }
};

bool operator==(F a, F b) {
    return a.a == b.a && a.b == b.b;
}

bool operator<(F a, F b) {
    a = a - b;
    ll x = a.a, y = a.b;
    y *= -1;
    if (x >= 0 && y <= 0) {
        return false;
    }
    if (x < 0 && y >= 0) {
        return true;
    }
    ii val = x * (ii) x  - y * (ii) y * 2;
    if (x >= 0) {
        return val < 0;
    }
    return val > 0;
}

struct Point {
    F x, y;

//    Point() = default;

    explicit Point(F x = F(0, 0), F y = F(0, 0)) : x(x), y(y) {}

    Point operator+(Point f) {
        return Point(x + f.x, y + f.y);
    }

    Point operator-(Point f) {
        return Point(x - f.x, y - f.y);
    }
};

bool operator==(Point a, Point b) {
    return a.x == b.x && a.y == b.y;
}

bool operator<(Point a, Point b) {
    if (a.x < b.x) return true;
    if (b.x < a.x) return false;
    return a.y < b.y;
}

void update(vector<pair<Point, Point>>& a) {
    vector<Point> b;
    for (auto& [x, y] : a) {
        b.push_back(x);
        b.push_back(y);
        if (y < x) swap(x, y);
    }
    std::sort(b.begin(), b.end());
    for (auto& [x, y] : a) {
        x = x - b[0];
        y = y - b[0];
    }
    std::sort(a.begin(), a.end());
//    for (auto [x, y] : a) {
//        cout << x.x.a << " " << x.x.b << " " << x.y.a << " " << x.y.b << endl;
//        cout << y.x.a << " " << y.x.b << " " << y.y.a << " " << y.y.b << endl;
//    }
}

void solve() {
    int n;
    cin >> n;
    vector<pair<string, int>> cmd(n);
    vector<array<int, 4>> d = {{0, 1, 0, 0},
                               {1, 0, 1, 0},
                               {0, 0, 0, 1},
                               {-1, 0, 1, 0},
                               {0, -1, 0, 0},
                               {-1, 0, -1, 0},
                               {0, 0, 0, -1},
                               {1, 0, -1, 0}};
    int dir = 0;
    vector<pair<Point, Point>> have;
    Point pt;
    for (auto& [s, x] : cmd) {
        cin >> s >> x;
        if (s == "rotate") {
            dir = (dir + x / 45) % 8;
        } else if (s == "move") {
            pt.x.a += x * d[dir][0];
            pt.x.b += x * d[dir][1];
            pt.y.a += x * d[dir][2];
            pt.y.b += x * d[dir][3];
        } else {
            have.push_back({pt, pt});
            pt.x.a += x * d[dir][0];
            pt.x.b += x * d[dir][1];
            pt.y.a += x * d[dir][2];
            pt.y.b += x * d[dir][3];
            have.back().second = pt;
        }
    }
    for (int j = 45; j <= 360; j += 45) {
        dir = (j / 45) % 8;
        vector<pair<Point, Point>> have2;
        Point pt;
        for (auto& [s, x] : cmd) {
//            cin >> s >> x;
            if (s == "rotate") {
                dir = (dir + x / 45) % 8;
            } else if (s == "move") {
                pt.x.a += x * d[dir][0];
                pt.x.b += x * d[dir][1];
                pt.y.a += x * d[dir][2];
                pt.y.b += x * d[dir][3];
            } else {
                have2.push_back({pt, pt});
                pt.x.a += x * d[dir][0];
                pt.x.b += x * d[dir][1];
                pt.y.a += x * d[dir][2];
                pt.y.b += x * d[dir][3];
                have2.back().second = pt;
            }
        }
        update(have);
        update(have2);
        if (have == have2) {
            cout << j << '\n';
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
