#include <iostream>
#include <vector>

#define ll long long

using namespace std;

int dfs(ll x, ll n, vector<bool>& up, vector<bool>& down){
    if(x >= n){
        return 1;
    }

    if(!up[x] && !up[x + 1] && !down[x] && !down[x + 1]){
        if(dfs(x + 2, n, up, down) == 0){
            return 0;
        }

        return 2;
    }

    if(!up[x] && down[x] && !up[x + 1]){
        up[x] = true;
        up[x + 1] = true;
        return dfs(x + 1, n, up, down);
    }

    if(!down[x] && up[x] && !down[x + 1]){
        down[x] = true;
        down[x + 1] = true;
        return dfs(x + 1, n, up, down);
    }

    if(up[x] && down[x]){
        return dfs(x + 1, n, up, down);
    }

    if(!up[x] && !down[x]){
        up[x] = true;
        down[x] = true;
        return dfs(x + 1, n, up, down);
    }

    return 0;
}

void solve(){
    ll n;
    cin >> n;
    vector<bool> up(n + 1, true), down(n + 1, true);
    for(int i = 0; i < n; i++){
        char c;
        cin >> c;
        up[i] = (c == '#');
    }

    for(int i = 0; i < n; i++){
        char c;
        cin >> c;
        down[i] = (c == '#');
    }

    ll res = dfs(0, n, up, down);
    if(res == 0){
        cout << "None" << endl;
    }else if(res == 1){
        cout << "Unique" << endl;
    }else{
        cout << "Multiple" << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
