#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vpl = vector<pll>;
using vbo = vector<bool>;
#define int long long
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))
#define sz(a) (ll)(a.size())

#define FOR(i, a, b) for (ll i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (ll i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i: a)

namespace solve_G {

    struct Point {
        ll x, y;

        Point() = default;

        Point(ll _x, ll _y) : x(_x), y(_y) {}

        Point(Point l, Point r) : x(r.x - l.x), y(r.y - l.y) {}

        friend Point rotate45(Point P) {
            return {P.y, P.y - P.x};
        }

        Point rotate(ll _angle) {
            _angle %= 360;
            for (; _angle; _angle -= 45) {
                *this = rotate45(*this);
            }
            return *this;
        }

        bool operator==(const Point other) const {
            return x == other.x && y == other.y;
        }

        Point operator*(ll d) {
            return Point(x * d, y * d);
        }

        Point operator+(Point other) {
            return Point(x + other.x, y + other.y);
        }
    };

    vector<pair<Point, Point>> rotate_and_normalize(vector<pair<Point, Point>> &arr, ll angle) {
        vector<pair<Point, Point>> brr = arr;
        F0R(i, sz(brr)) {
            brr[i].first = brr[i].first.rotate(angle);
            brr[i].second = brr[i].second.rotate(angle);
        }

        ll actual_mx = 1e16;
        ll current_mx = 1e16;
        ll actual_my = 1e16;
        ll current_my = 1e16;

        F0R(i, sz(arr)) {
            actual_mx = min(actual_mx, arr[i].first.x);
            actual_mx = min(actual_mx, arr[i].second.x);
            actual_my = min(actual_my, arr[i].first.y);
            actual_my = min(actual_my, arr[i].second.y);

            current_mx = min(current_mx, brr[i].first.x);
            current_mx = min(current_mx, brr[i].second.x);
            current_my = min(current_my, brr[i].first.y);
            current_my = min(current_my, brr[i].second.y);
        }

        F0R(i, sz(brr)) {
            brr[i].first.x -= current_mx - actual_mx;
            brr[i].first.y -= current_my - actual_my;
            brr[i].second.x -= current_mx - actual_mx;
            brr[i].second.y -= current_my - actual_my;
        }

        return brr;
    }

    bool is_equal(const vector<pair<Point, Point>> &arr, const vector<pair<Point, Point>> &brr) {
        vbo used(sz(brr), false);
        F0R(i, sz(arr)) {
            bool found = false;
            F0R(j, sz(brr)) {
                if (used[j]) continue;
                if (arr[i].first == brr[j].first && arr[i].second == brr[j].second) {
                    used[j] = true;
                    found = true;
                    break;
                }
                if (arr[i].first == brr[j].second && arr[i].second == brr[j].first) {
                    used[j] = true;
                    found = true;
                    break;
                }
            }
            if (!found) {
                return false;
            }
        }
        return true;
    }

    void solve() {
        Point a(-1, 1);
        a.rotate(135);
        cout << a.x << ' ' << a.y << endl;
        return;
        ll q;
        cin >> q;
        vector<pair<Point, Point>> arr;
        Point pos = Point(0, 0);
        ll current_angle = 0;
        F0R(i, q) {
            Point gg = {-1, 1};
            Point dir = gg.rotate(current_angle);
            string t;
            cin >> t;
            if (t == "rotate") {
                ll d_angle;
                cin >> d_angle;
                current_angle += d_angle;
                current_angle %= 360;
            } else if (t == "move") {
                ll dist;
                cin >> dist;
                pos = pos + dir * dist;
            } else {
                ll dist;
                cin >> dist;
                Point s_pos = pos;
                Point t_pos = pos + dir * dist;
                pos = t_pos;
                arr.push_back({s_pos, t_pos});
            }
        }
        assert(is_equal(arr, rotate_and_normalize(arr, 360)));
        for (int i = 45; i < 360; i += 45) {
            if (is_equal(arr, rotate_and_normalize(arr, i))) {
                cout << i;
                return;
            }
        }
        cout << 360;
    }
}

namespace solve_B {
    vector<char> number{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                        'a', 'b', 'c', 'd', 'e', 'f'};

    deque<char> to_hex(ll a) {
        deque<char> res(4);
        F0R(i, 4) {
            res[3 - i] = number[a % 16];
            a /= 16;
        }
        return res;
    }

    void solve() {
        ll x;
        cin >> x;
        vll ans(1 << 12);
        ans[0] = (1 << 16) - 16;
        ans[1] = (16 * 2 + 7);
        ans[2] = 1 << 6;
        F0R(i, 16) {
            ll pos_0 = (1 << 6) + (i << 8);
            ll pos_1 = (1 << 6) + (1 << 7) + (i << 8);
            if ((x >> i) & 1) {
                ans[pos_0] = 4;
                ans[pos_0 + 1] = (1 << 16) - 16;
                ans[pos_0 + 2] = 1 << 12;

                if (i < 15) {
                    ans[pos_1] = (1 << 16) - 16 + i + 1;
                    ans[pos_1 + 1] = (pos_1 + 2) * 16 + 7;
                    ans[pos_1 + 2] = (1 << 6) + ((i + 1) << 8);
                } else {
                    ans[pos_1] = 0;
                    ans[pos_1 + 1] = (1 << 16) - 16;
                    ans[pos_1 + 2] = 1 << 12;
                }
            } else {
                ans[pos_1] = 4;
                ans[pos_1 + 1] = (1 << 16) - 16;
                ans[pos_1 + 2] = 1 << 12;

                if (i < 15) {
                    ans[pos_0] = (1 << 16) - 16 + i + 1;
                    ans[pos_0 + 1] = (pos_0 + 2) * 16 + 7;
                    ans[pos_0 + 2] = (1 << 6) + ((i + 1) << 8);
                } else {
                    ans[pos_0] = 0;
                    ans[pos_0 + 1] = (1 << 16) - 16;
                    ans[pos_0 + 2] = 1 << 12;
                }
            }
        }
        F0R(i, (1 << 12) - 1) {
            each(j, to_hex(ans[i])) {
                cout << j;
            }
            cout << ' ';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve_B::solve();
}