#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <functional>
#define ll long long

using namespace std;

void solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	vector<int> type(n);
	vector<int> in(n);

	for (int i = 0; i < n; ++i) {
		string a, b;
		cin >> a >> b;
		int idx = 0;
		if (a == "unset") idx += 2;
		if (b == "false") idx += 1;
		type[i] = idx;
	}

	int m;
	cin >> m;

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back(b);
		++in[b];
	}

	vector<queue<int>> q(4);

	for (int i = 0; i < n; ++i) {
		if (in[i] == 0) {
			q[type[i]].push(i);
		}
	}

	vector<int> ans;
	int cur = 0;

	function<void(int)> del = [&](int to) {
		for (auto x : g[to]) {
			--in[x];

			if (in[x] == 0) {
				q[type[x]].push(x);
			}
		}
	};

	for (int i = 0; i < n; ++i) {
		if (cur == 0) {
			if (!q[3].empty()) {
				ans.push_back(q[3].front());
				del(q[3].front());
				q[3].pop();
				continue;
			}

			if (q[0].empty()) {
				cout << -1;
				return;
			}

			ans.push_back(q[0].front());
			del(q[0].front());
			q[0].pop();
			cur = 1;

		} else {
			if (!q[1].empty()) {
				ans.push_back(q[1].front());
				del(q[1].front());
				q[1].pop();
				continue;
			}

			if (q[2].empty()) {
				cout << -1;
				return;
			}

			ans.push_back(q[2].front());
			del(q[2].front());
			q[2].pop();
			cur = 0;
		}
	}

	for (auto x : ans) {
		cout << x + 1 << " ";
	}
}