def conv_to_ans(eq, idx_left, signs):
    str_out = str(abs(eq[0]))

    for i in range(1, len(eq)):
        str_out += signs[i - 1]
        str_out += str(abs(eq[i]))

    return str_out


def calc(eq_arr, idx_left):
    left = right = 0
    for i in range(idx_left + 1):
        left += eq_arr[i]

    for i in range(idx_left + 1, len(eq_arr)):
        right += eq_arr[i]

    return [left == right, eq_arr]

def check_number(num: list):
    num_copy = num.copy()
    if len(num_copy) == 0:
        return False
    if num_copy[0] == '-':
        num_copy.pop(0)
    if len(num_copy) == 0:
        return False
    if '-' in num_copy:
        return False
    if num_copy[0] == '0' and len(num_copy) > 1:
        return False
    return True


def swap_two_numbers(eq_arr, idx_left, idx_first_num, idx_second_num):
    arr_first_num = list(str(eq_arr[idx_first_num]))
    arr_second_num = list(str(eq_arr[idx_second_num]))
    copy_eq_arr = eq_arr.copy()
    for i in range(len(arr_first_num)):
        copy_first = arr_first_num.copy()
        copy_first.pop(i)
        if not check_number(copy_first):
            continue

        for j in range(len(arr_second_num) + 1):
            copy_second = arr_second_num.copy()
            copy_second.insert(j, arr_first_num[i])
            if not check_number(copy_second):
                continue

            copy_eq_arr[idx_first_num] = int(''.join(copy_first))
            copy_eq_arr[idx_second_num] = int(''.join(copy_second))
            res, new_eq_arr = calc(copy_eq_arr, idx_left)

            if res:
                return new_eq_arr

    return []

def swap_one_number(eq_arr, idx_left, idx_num):
    arr_num = list(str(eq_arr[idx_num]))
    copy_eq_arr = eq_arr.copy()

    for i in range(len(arr_num)):
        copy_arr = arr_num.copy()
        to_insert = copy_arr.pop(i)
        for j in range(len(copy_arr) + 1):
            copy_arr_second = copy_arr.copy()
            copy_arr_second.insert(j, to_insert)

            if not check_number(copy_arr_second):
                continue

            copy_eq_arr[idx_num] = int(''.join(copy_arr_second))
            res, new_eq_arr = calc(copy_eq_arr, idx_left)

            if res:
                return new_eq_arr

    return []

def conv_to_arr(side):
    side = side.replace('+', ' ')
    side = side.replace('-', ' -')

    arr = side.split()
    out = [int(i) for i in arr]
    return out

def calc_equation(eq):
    signs = []
    for i in range(len(eq)):
        if eq[i] in ['+', '-', '=']:
            signs.append(eq[i])

    left, right = eq.split('=')
    left = conv_to_arr(left)
    right = conv_to_arr(right)

    idx_left = len(left) - 1
    eq = left + right

    res, _ = calc(eq, idx_left)
    if res:
        return "Correct"

    for i in range(len(eq)):
        new_eq = swap_one_number(eq, idx_left, i)
        if len(new_eq) != 0:
            return conv_to_ans(new_eq, idx_left, signs)

    for i in range(len(eq) - 1):
        for j in range(i + 1, len(eq)):
            new_eq_one = swap_two_numbers(eq, idx_left, i, j)
            if len(new_eq_one) != 0:
                return conv_to_ans(new_eq_one, idx_left, signs)

            new_eq_two = swap_two_numbers(eq, idx_left, j, i)
            if len(new_eq_two) != 0:
                return conv_to_ans(new_eq_two, idx_left, signs)

    return "Impossible"


if __name__ == '__main__':
    eq = input()
    print(calc_equation(eq))
