#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define forn(i, n) for (ll i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

struct Q {
	int op = 0, v = 0;
	int comp = 0;
	int index = -1;

	Q() = default;

	Q(const string &op_s, const string &v_s) {
		op = (op_s == "set");
		v = (v_s == "true");
	}

	int to_number1() const {
		// set
		if (op) {
			if (v) {
				return 1;
			} else {
				return 2;
			}
		} else {
			if (v) {
				return 3;
			} else {
				return 0;
			}
		}
	}

	int to_number2() const {
		// set
		if (op) {
			if (v) {
				return 0;
			} else {
				return 1;
			}
		} else {
			if (v) {
				return 2;
			} else {
				return 3;
			}
		}
	}

	// 0 is UNSET
	// 1 is SET
	bool operator<(const Q &rhs) const {
		if (comp == 0) {
			return to_number1() < rhs.to_number1();
		}
		return to_number2() < rhs.to_number2();
	}
};

void solve() {
	int n;
	cin >> n;

	vector<Q> qs(n);
	
	int st_exists = 0;
	int ut_exists = 0;

	forn(i, n) {
		string op, value;
		cin >> op >> value;
		qs[i] = Q(op, value);
		qs[i].index = i;

		if (qs[i].op == 1) {
			// SET
			if (qs[i].v) {
				++st_exists;
			}
		} else {
			if (qs[i].v) {
				++ut_exists;
			}
		}
	}

	int q;
	cin >> q;
	vector<unordered_set<int>> a(n);
	vector<unordered_set<int>> ba(n);

	forn(i, q) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		a[x].insert(y);
		ba[y].insert(x);
	}

	if ((st_exists == 0 && ut_exists > 0) || st_exists == 2 || ut_exists == 2) {
		cout << "-1\n";
		return;
	}

	set<Q> st;
	forn(i, n) {
		if (ba[i].size() == 0) {
			st.insert(qs[i]);
		}
	}

	vector<int> ans;

	int stage = 0;
	while (!st.empty()) {
		auto top_el = *st.begin();
		st.erase(st.begin());
		auto [op, v, type, top] = top_el;

		// erase
		for (auto it : a[top]) {
			ba[it].erase(top);
			if (ba[it].size() == 0) {
				st.insert(qs[it]);
			}
		}


		if (stage == 0 && op == 1) {
			++stage;
			vector<Q> tmp(all(st));
			st.clear();
			for (auto &it : tmp) {
				it.comp++;
				st.insert(it);
			}
			if (v != 1) {
				cout << "-1\n";
				return;
			}
		} else if (stage == 1 && op == 0) {
			++stage;
			if (v != 1) {
				cout << "-1\n";
				return;
			}
		}
		ans.push_back(top);

	}

	forn(i, n) {
		cout << ans[i] + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}
}