#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<pair<int, int> > moves = { {-1, 0}, {1, 0}, {0, -1}, {0, 1}};

void Solve() {
    int n;
    cin >> n;
    string s[3];
    cin >> s[0] >> s[1];
    if (n == 1 && s[0][0] == '.' && s[1][0] == '.') {
        cout << "Unique\n";
        return;
    }
    vector<int> cnt(2 * n + 3);
    for (int i = 0; i < n - 1; i++) {
        if (s[0][i] == '.' && s[0][i + 1] == '.') {
            cnt[i]++;
            cnt[i + 1]++;
        }
        if (s[1][i] == '.' && s[1][i + 1] == '.') {
            cnt[n + i]++;
            cnt[n + i + 1]++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (s[0][i] == '.' && s[1][i] == '.') {
            cnt[i]++;
            cnt[n + i]++;
        }
    }
    queue<pair<int, int>> q;
    for (int i = 0; i < 2 * n; i++) {
        if (s[i / n][i % n] == '.' && cnt[i] == 0) {
            cout << "None\n";
            return;
        }
        if (cnt[i] == 1) {
            q.push({i / n, i % n});
        }
    }
    while (!q.empty()) {
        pair<int, int> cur = q.front();
        q.pop();
        if (s[cur.first][cur.second] != '.') {
            continue;
        }
        pair<int, int> nei= {-1, -1};
        for (auto st : moves) {
            int x = cur.first + st.first, y = cur.second + st.second;
            if (x >= 0 && x <= 1 && y >= 0 && y < n) {
                if (s[x][y] == '.') {
                    s[cur.first][cur.second] = '$';
                    s[x][y] = '$';
                    nei = {x, y};
                }
            }
        }
        if (nei.first == -1) {
            cout << "None\n";
            return;
        } else {
            for (auto st : moves) {
                int x = nei.first + st.first, y = nei.second + st.second;
                if (x >= 0 && x <= 1 && y >= 0 && y < n) {
                    if (s[x][y] == '.') {
                        int cc = 0;
                        for (auto st1 : moves) {
                            int xx = x + st1.first, yy = y + st1.second;
                            if (xx >= 0 && xx <= 1 && yy >= 0 && yy < n) {
                                if (s[xx][yy] == '.') {
                                    cc++;
                                }
                            }
                        }
                        if (cc == 0) {
                            cout << "None\n";
                            return;
                        }
                        if (cc == 1) {
                            q.push({x, y});
                        }
                    }
                }
            }
        }
    }
    int cn = 0;
    for (int i = 0; i < n; i++) {
        cn += (s[0][i] == '.');
        cn += (s[1][i] == '.');
    }
    if (cn == 0) {
        cout << "Unique\n";
        return;
    }
    for (int i = 0; i < 2; i++) {
        for (int i1 = 0; i1 < n; i1++) {
            int cc = 0;
            for (auto st1 : moves) {
                int xx = i + st1.first, yy = i1 + st1.second;
                if (xx >= 0 && xx <= 1 && yy >= 0 && yy < n) {
                    if (s[xx][yy] == '.') {
                        cc++;
                    }
                }
            }
            if (cc == 0) {
                cout << "None/n";
                return;
            }
        }
    }
    cout << "Multiple\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        Solve();
    }
}
