#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <compare>

using namespace std;

#define ll long long

struct point {
	double x = 0;
	double y = 0;
	bool moving = false;

	bool operator<(const point& p) const {
		if (x < p.x) {
			return true;
		}
		if (!(x > p.x) && y < p.y) {
			return true;
		}
		return false;
	}

	bool operator==(const point& p) const {
		if (abs(x - p.x) < 0.000001 && abs(y - p.y) < 0.000001) {
			return true;
		}
		return false;
	}
};


point find_origin(set<point> ps) {
	point origin = *ps.begin();

	for (auto p : ps) {
		if (p.y < origin.y) {
			origin = p;
		}
		if (abs(p.y - origin.y) < 0.0000001 && p.x < origin.x) {
			origin = p;
		}
	}
	return origin;
}


set<point> move_to_origin(set<point> ps, point origin) {
	set<point> moved{};
	for (auto p : ps) {
		p.x -= origin.x;
		p.y -= origin.y;
		moved.insert(p);
	}
	return moved;
}


const double PI = 3.141592653589793;

double const MOV_CONST = sqrt(2) / 2;

int main()
{
	int n;
	cin >> n;

	int degrees = 0;
	point current { 0, 0, false };

	// Create initial
	set<point> initial {};

	string command;
	int argument;
	while (n--) {
		cin >> command >> argument;

		if (command == "rotate") {
			degrees += argument;
			degrees %= 360;
		}
		else {
			if (command == "draw")
				current.moving = false;
			else
				current.moving = true;

			initial.insert(current);

			double coef = (degrees / 180.) * PI;
			current.x += argument * cos(coef);
			current.y += argument * sin(coef);

			if (abs(current.x) < 0.000001)
				current.x = 0;
			if (abs(current.y) < 0.000001)
				current.y = 0;
		}
	}

	initial.insert(current);

	point initial_origin = find_origin(initial);
	initial = move_to_origin(initial, initial_origin);

	set<point> to_rotate = set<point>(initial.begin(), initial.end());
	// rotate this shit
	for (int j = 1; j <= 8; j++) {
		set<point> rotated {};

		for (point p : to_rotate) {
			point temp = p;
			temp.x = p.x * MOV_CONST - p.y * MOV_CONST;
			temp.y = p.x * MOV_CONST + p.y * MOV_CONST;
			if (abs(temp.x) < 0.000001)
				temp.x = 0;
			if (abs(temp.y) < 0.000001)
				temp.y = 0;
			
			rotated.insert(temp);
		}

		rotated = move_to_origin(rotated, find_origin(rotated));


		auto temp1 = vector(rotated.begin(), rotated.end());
		sort(temp1.begin(), temp1.end());
		auto temp2 = vector(initial.begin(), initial.end());
		sort(temp2.begin(), temp2.end());

		bool flag = true;
		for (int i = 0; flag && i < temp1.size(); i++) {

			if (!(temp1[i] == temp2[i]))
				flag = false;
		}
		if (flag) {
			cout << j * 45;
			return 0;
		}

		to_rotate = rotated;
	}

	cout << 360;
}
