#define _GLIBCXX_DEBUG 1
#pragma gcc optimize ("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

using namespace std;
#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define rsort(a) sort(a, [&] (auto b, auto c) {return b > c;})
using ll = long long;
using ld = long double;
using ull = unsigned long long; 
const long long inf = 1e18;
const ll MOD = 998244353;
const int N = 1e6;
int n, m;
struct edge{
    int x,y;
    ll w;
    edge(){
        x = 0;
        y = 0;
        w = 0;
    }
    edge(int x_, int y_, int z_){
        x = x_;
        y = y_;
        w = z_;
    }
};
vector<edge> g[N];
vector<edge> h[N];
void Dij(vector<ll> &d, vector<edge> *v, int u){
    for(int i = 0; i < n; i ++){
        d[i] = inf;
    }
    d[u] = 0;
    set<pair<ll, int>> q = {};
    q.insert({0, u});
    while(!q.empty()){
        auto [L, R] = *q.begin();
        q.erase(q.begin());
        for(auto to: v[R]){
            if(d[to.y] > d[to.x] + to.w){
                q.erase({d[to.y], to.y});
                d[to.y] = d[to.x] + to.w;
                q.insert({d[to.y], to.y});
            }
        }
    }
}
void Dijkstra(vector<pair<ll, ll>> &d, vector<edge> *v, vector<ll> &e,  int u){
    for(int i = 0; i < n; i ++){
        d[i] = {inf, inf};
    }
    d[u] = {0, e[u]};
    set<pair<pair<ll, ll>, int>> q = {};
    q.insert({d[u], u});
    while(!q.empty()){
        auto [L, R] = *q.begin();
        q.erase(q.begin());
        for(auto to: v[R]){
            pair<ll, ll> newansw = {d[to.x].first + to.w, max(e[to.y], e[to.x])};
            if(d[to.y] > newansw){
                q.erase({d[to.y], to.y});
                d[to.y] = newansw;
                q.insert({d[to.y], to.y});
            }
        }
    }
}
signed main(){
    cin >> n >> m;
    for(int i  = 0; i < m; i ++){
        int x, y, z;
        cin >> x >> y >> z;
        x --;
        y --;
        g[x].pb({x, y, z});        
        h[y].pb({y, x, z});
    }    
    vector<ll> d1(n);
    Dij(d1, g, 0);
    if(d1[n - 1] == inf){
        cout << -1 << endl;
        return 0;
    }
    vector<ll> d2(n);
    Dij(d2, h, n - 1);
    vector<int> nonreach = {};
    for(int i = 0; i < n - 1; i ++){
        if(d2[i] == inf){
            nonreach.pb(i);
        }
    }
    vector<ll> answ(n);
    for(int i = 0; i < n; i ++){
        answ[i] = inf;
    }
    for(int i = 0; i < nonreach.size(); i ++){
        answ[nonreach[i]] = 0;
    }
    deque<int> s = {};
    for(int i = 0; i < nonreach.size(); i ++){
        s.push_back(nonreach[i]);
    }
    vector<int> cnt(n);
    for(int i = 0; i < n; i ++){
        cnt[i] = 0;
        for(auto to: h[i]){
            if(d2[to.x] == d2[to.y] + to.w){
                cnt[to.x] ++;
            }
        }
    }
    for(auto to: cnt){
        //cout << to << " ";
    }
    while(!s.empty()){
        auto w = s.front();
        s.pop_front();
        if(w == n - 1){
            continue;
        }
        for(auto to: h[w]){
            if(d2[to.x] == d2[to.y] + to.w && cnt[to.x] == 1){
                if(answ[to.y] > answ[to.x]){
                    answ[to.y] = answ[to.x];
                    s.push_front(to.y);
                }
            }
            else
            {
                if(answ[to.y] > answ[to.x] + 1){
                    answ[to.y] = answ[to.x] + 1;
                    s.push_back(to.y);
                }
            }
            if (d2[to.x] == d2[to.y] + to.w)
            {
                cnt[to.x] --;
            }
        }
    }
    answ[n - 1] = inf;
    vector<pair<ll,ll>> d3(n);
    for(int i = 0; i < answ.size(); i ++){
        answ[i] = - answ[i];
    }
    Dijkstra(d3, g, answ, 0);
    if(d3[n - 1].second == -inf){
        cout << n << endl;
        return 0;
    }
    cout << min(n, -d3[n - 1].second - 1);
}