#define _GLIBCXX_DEBUG 1
#pragma gcc optimize ("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define rsort(a) sort(a, [&] (auto b, auto c) {return b > c;})
using ll = long long;
using ld = long double;
using ull = unsigned long long; 
const ll inf = 1e18;
const ll MOD = 998244353;
 
void solve();
 
signed main(){
    ll t;
    cin >> t;
    while(t--) {
        solve();
    }
}
 
struct deadline
{
    ll len;
    ll d;
};
 
struct question
{
    ll t;
    ll idx;
};
 
struct answer
{
    ll idx;
    ll ans;
};
 
 
void solve() {
    ll n, m, q;
    cin >> n;
    cin >> m;
    cin >> q;
    vector<ll> a(n);
    vector<ll> d(n);
    vector<deadline> deadlines;
    vector<pair<ll,ll>> da(n);
    for(int i = 0; i < n; i++){
        cin >> da[i].second;
    }
    for(int i = 0; i < n; i++){
        cin >> da[i].first;
    }
    sort(all(da));
    for(int i = 0; i < n; i++){
        a[i] = da[i].second;
    }
    for(int i = 0; i < n; i++){
        d[i] = da[i].first;
    }
 
 
    deadlines.push_back({a[0], d[0]});
    for(int i = 1; i < n; i++){
        deadlines.push_back({a[i], d[i]});
        if(deadlines.size() <= 1) {
            continue;
        }
        deadline last = deadlines[deadlines.size() - 1];
        deadline lastlast = deadlines[deadlines.size() - 2];
        while(lastlast.d >= last.d - last.len)
        {
            deadlines[deadlines.size() - 2].len += last.len;
            deadlines[deadlines.size() - 2].d = deadlines[deadlines.size() - 1].d;
            deadlines.pop_back();
            if(deadlines.size() <= 1) {
                break;;
            }
            last = deadlines[deadlines.size() - 1];
            lastlast = deadlines[deadlines.size() - 2];
        }
    }
    vector<ll> film(m);
     
    for(int i = 0; i < m; i++){
        cin >> film[i];
    }
    vector<question> questions;
     
    for(int i = 0; i < q; i++){
        ll t;
        cin >> t;
        questions.push_back({t, i});
    }
     
    sort(all(questions), [&] (question a, question b) {return a.t < b.t;});
    vector<answer> answers;
 
    ll film_idx = 0;
    ll seg_idx = 1;
    ll accum_time = deadlines[0].d - deadlines[0].len;
    vector<ll> points(1, 0);
    while(film_idx < m && accum_time >= film[film_idx]) {
        points.push_back(points.back() +  film[film_idx]);
        accum_time -= film[film_idx];
        film_idx += 1;
    }
 
    for(int i = 1; i < deadlines.size(); i++) {
        deadline ddl = deadlines[i];
        accum_time += deadlines[i].d - deadlines[i].len - deadlines[i-1].d;
        ll last = points.back() + deadlines[i-1].len;
        while(film_idx < m && accum_time >= film[film_idx]) {
            points.push_back(last + film[film_idx]);
            accum_time -= film[film_idx];
            film_idx += 1;
            last = points.back();
        }
    }
    ll last = deadlines.back().d - accum_time;
    while(film_idx < m) {
        points.push_back(last + film[film_idx]);
        film_idx += 1;
        last = points.back();
    }
    film_idx = 0;
 
    for(int i = 0; i < q; i++) {
        question qu = questions[i];
        while(film_idx < points.size() && points[film_idx] <= qu.t) {
            film_idx += 1;
        }
        answers.push_back({qu.idx, film_idx});
    }
      
    sort(all(answers), [&] (answer a, answer b) {return a.idx < b.idx ;});
    for(int i = 0; i < q; i++) {
        cout << answers[i].ans - 1 << ' ';
    }
    cout << '\n';
}