/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tree-vectorize")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first 
#define s second
#define x first 
#define y second

ll n, m;
const ll MAXN = 1e5 + 10;

bool compare(ll a1, ll b1, ll a2, ll b2) {
    ll da = a1 - a2;
    ll db = b2 - b1;
    if (da == 0 || db == 0) {
        if (da == 0) return b1 < b2;
        return a1 < a2;
    } else if (da / abs(da) * db < 0) {
        return da < 0;
    } else {
        __int128_t dega = da;
        __int128_t degb = db;
        return 2 * dega * dega < degb * degb;
    }
}

bool equal(ll a1, ll b1, ll a2, ll b2) {
    return a1 == a2 && b1 == b2;
}

struct pos{
    ll a, b, c, d;

    pos(ll a, ll b, ll c, ll d):a(a),b(b),c(c),d(d) {
    }

    pos(){}

    pos rot45() {
        return pos((b - d) / 2, a - c, (b + d) / 2, a + c);
    }

    pos rot180() {
        return pos(-a, -b, -c, -d);
    }

    pos operator*(ll x) {
        return pos(a * x, b * x, c * x, d * x);
    }

    pos& operator += (pos p) {
        a += p.a;
        b += p.b;
        c += p.c;
        d += p.d;
        return *this;
    }

    pos& operator -= (pos p) {
        a -= p.a;
        b -= p.b;
        c -= p.c;
        d -= p.d;
        return *this;
    }
};

bool operator<(pos q, pos p) {
        if (compare(q.a, q.b, p.a, p.b)) return true;
        if (compare(p.a, p.b, q.a, q.b)) return false;
        return compare(q.c, q.d, p.c, p.d);
    }

    bool operator==(pos q, pos p) {
        return q.a == p.a && q.b == p.b && q.c == p.c && q.d == p.d;
    }

void solve() {
    cin >> m;
    vector<pair<pos, pos>> lines;
    pos cur = {0, 0, 0, 0};
    ll angle = 0;
    map<ll, pos> dirs;
    pos ed(1, 0, 0, 0);
    for (int i = 0; i < 360; i += 45) {
        dirs[i] = ed;
        ed = ed.rot45();
    }

    for (int i = 0; i < m; ++i) {
        string s;
        ll x;
        cin >> s >> x;
        if (s == "move") {
            cur += dirs[angle] * x;
        } else if (s == "draw") {
            pos before = cur;
            cur += dirs[angle] * x;
            pos now = cur;
            if (now < before) swap(before, now);
            lines.emplace_back(before, now);
        } else {
            angle += x;
            angle %= 360;
        }
    }

    sort(lines.begin(), lines.end());
    vector<vector<pair<pos, pos>>> types(4);
    for (auto &[p1, p2]: lines) {
        if (equal(p1.a, p1.b, p2.a, p2.b)) {
            //vertical
            types[0].emplace_back(p1, p2);
        } else if (equal(p1.c, p1.d, p2.c, p2.d)) {
            //horizontal
            types[1].emplace_back(p1, p2);
        } else if (compare(p1.c, p1.d, p2.c, p2.d)) {
            //upward
            types[2].emplace_back(p1, p2);
        } else {
            //downward
            types[3].emplace_back(p1, p2);
        }
    }
    vector<pair<pos, pos>> clean_lines;
    for (int i = 0; i < 4; ++i) {
        map<pos, ll> e;
        vector<pair<pos, pos>> united;
        for (auto &[p1, p2]: types[i]) {
            if (e.count(p1)) {
                ll id = e[p1];
                e.erase(p1);
                united[id].second = p2;
                e[p2] = id;
            } else {
                e[p2] = e.size();
                united.emplace_back(p1, p2);
            }
        }
        for (auto&line: united) {
            clean_lines.emplace_back(line);
        }
    }

    lines = clean_lines;
    sort(lines.begin(), lines.end());
    auto gay = lines[0].first;
        for (auto&[st, en]: lines) {
            st -= gay;
            en -= gay;
        }

    // for (auto&[p1, p2]: lines) {
    //     cerr << p1.a << " " << p1.b << " " << p1.c << " " << p1.d << " - ";
    //     cerr << p2.a << " " << p2.b << " " << p2.c << " " << p2.d << endl;
    // }
    
    pos stpoint = lines[0].first;
    for (auto&[st, en]: lines) {
        st -= stpoint;
        en -= stpoint;
    }
    auto alt_lines = lines;
    for (int da = 45; da <= 360; da += 45) {
        for (auto &line: alt_lines) {
            auto &[st, en] = line;
            st = st.rot45();
            en = en.rot45();
            if (en < st) swap(st, en);
        }
        sort(alt_lines.begin(), alt_lines.end());
        stpoint = alt_lines[0].first;
        for (auto&[st, en]: alt_lines) {
            st -= stpoint;
            en -= stpoint;
        }

        if (lines == alt_lines) {
            cout << da << "\n";
            return;
        }
    }
    cout << "360\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}