#include <bits/stdc++.h>

using namespace std;

const int kMaxN = 1e5 + 10;

int type[kMaxN];
int answer[kMaxN];
std::vector<int> edges[kMaxN];
std::vector<int> order;
std::vector<int> used(kMaxN);

bool dfs(int u, int check) {
    used[u] = 1;
    for (auto v : edges[u]) {
        if (type[v] == check || check == 2) {
            if (used[v] == 1) {
                return false;
            }
            if (used[v] == 0) {
                if (!dfs(v, check)) {
                    return false;
                }
            }
        }
    }
    order.push_back(u);
    used[u] = 2;
    return true;
}

void solve() {
    int n;
    std::cin >> n;
    int first_set = -1;
    int first_unset = -1;
    for (int i = 0; i < n; ++i) {
        std::string a, b;
        std::cin >> a >> b;
        if (a[0] == 'u') {
            type[i] = 0;
        } else {
            type[i] = 1;
        }
        if (b[0] == 'f') {
            answer[i] = 0;
        } else {
            if (a[0] == 's') {
                first_set = i;
            } else {
                first_unset = i;
            }
            answer[i] = 1;
        }
    }
    int m;
    std::cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u;
        --v;
        edges[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            if (!dfs(i, 2)) {
                std::cout << -1 << std::endl;
                return;
            }
        }
    }
    order.clear();
    fill(used.begin(), used.end(), 0);
    std::vector<int> start;
    if (first_set != -1) {
        for (int i = 0; i < n; ++i) {
            if (i != first_set && used[i] == 0 && type[i] == 1) {
                dfs(i, 1);
            }
        }
        if (used[first_set] == 2) {
            std::cout << -1 << std::endl;
            return;
        }
        dfs(first_set, 1);
        for (int i = 0; i < n; ++i) {
            if (type[i] == 1) {
                for (auto v : edges[i]) {
                    if (type[v] == 0) {
                        start.push_back(v);
                    }
                }
            }
        }
    }
    std::vector<int> st = order;
    reverse(st.begin(), st.end());
    order.clear();
    if (first_unset != -1) {
        for (auto el : start) {
            if (el != first_unset && used[el] == 0) {
                dfs(el, 0);
            }
        }
        if (used[first_unset] == 2) {
            std::cout << -1 << std::endl;
            return;
        }
        dfs(first_unset, 0);
    }
    std::vector<int> last = order;
    reverse(last.begin(), last.end());
    order.clear();
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0 && type[i] == 0) {
            dfs(i, 0);
        }
    }
    std::vector<int> first = order;
    reverse(first.begin(), first.end());
    order.clear();
    std::vector<int> ans;
    std::vector<int> rev_ans(n);
    int cur = 0;
    for (auto el : first) {
        ans.push_back(el);
        rev_ans[el] = cur++;
    }
    for (auto el : st) {
        ans.push_back(el);
        rev_ans[el] = cur++;
    }
    for (auto el : last) {
        ans.push_back(el);
        rev_ans[el] = cur++;
    }
    /*
    std::cout << first.size() << ": ";
    for (auto el : first) {
        std::cout << el << " ";
    }
    std::cout << std::endl;
    std::cout << st.size() << ": ";
    for (auto el : st) {
        std::cout << el << " ";
    }
    std::cout << std::endl;
    std::cout << last.size() << ": ";
    for (auto el : last) {
        std::cout << el << " ";
    }
    std::cout << std::endl;
    for (auto el : ans) {
        std::cout << el << " ";
    }
    std::cout << std::endl;
    */
    if (ans.size() != n) {
        std::cout << -1 << std::endl;
        return;
    }
    for (int u = 0; u < n; ++u) {
        for (auto v : edges[u]) {
            if (rev_ans[u] > rev_ans[v]) {
                std::cout << -1 << std::endl;
                return;
            }
        }
    }
    for (auto el : ans) {
        std::cout << el + 1 << " ";
    }
    return;
}

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

int32_t main() {
    IOSync();
    int tests = 1;
    // std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
